/*********************************************************************************

 C-SWAT Ver.2.2.0.0 (C)


 Copyright (c) 2006-2013, Isao MORI (Orios)
 All rights reserved.

 Redistribution and use in source and binary forms, with or without modification,
 are permitted provided that the following conditions are met:
   * Redistributions of source code must retain the above copyright notice, this
     list of conditions and the following disclaimer.
   * Redistributions in binary form must reproduce the above copyright notice,
     this list of conditions and the following disclaimer in the documentation
     and/or other materials provided with the distribution.
 
 THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND
 ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
 WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
 DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT HOLDER OR CONTRIBUTORS BE LIABLE FOR
 ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
 (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
 LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON
 ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
 (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
 SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
*********************************************************************************/

//==================================================
// CN[h
//==================================================
#include "c-swat.h"
#include "EncWnd.h"
#include "ReEncWnd.h"

//==================================================
// N[h擾֐
//==================================================
int GetRunningMode(CmdLine *poCmdLine)
{
	// ϐ̐錾
	int i;

	if (poCmdLine->nArgc == 0) {
		return 0;
	}
	else if ((poCmdLine->nArgc > 1)) {
	// t@C2ȏ̏ꍇ --> Í
		return 0;
	}
	else {
		if (lstrcmp(poCmdLine->ppcArgv[0], "--reenc") == 0) {
			// ĈÍɎst@CĈÍ
			return 3;

		}
		else {
			for (i = lstrlen((LPCSTR)poCmdLine->ppcArgv[0]) - 1; i >= 0; i--) {
				if (poCmdLine->ppcArgv[0][i] == 0x2E) {
					if (lstrcmpi(poCmdLine->ppcArgv[0] + i, ".cse") == 0) {
					// CSEt@C̏ꍇ --> 
						return 1;
					}
					if (lstrcmpi(poCmdLine->ppcArgv[0] + i, ".csl") == 0) {
					// CSLt@C̏ꍇ --> C-SWATt@CXgɂ镜
						return 2;
					}
				}
			}
		}

		// ȊO --> Í
		return 0;
	}
}


//==================================================
// [UfBNg̍쐬
//==================================================
void CreateUserDir()
{
	char appdataPath_array[MAX_PATH];
	SHGetFolderPath(NULL, CSIDL_APPDATA, NULL, SHGFP_TYPE_CURRENT, appdataPath_array);
	std::string userDirPath(appdataPath_array);
	userDirPath += "\\Orios";
	CreateDirectory(userDirPath.c_str(), 0);
	userDirPath += "\\C-SWAT";
	CreateDirectory(userDirPath.c_str(), 0);
}


//==================================================
// ĈÍ
//==================================================
bool ReEncode(const XML& reEncFileList, const PathManagement& pathManagement_obj, CSwatCipher& cipher_obj)
{
	int nFilePathLen;
	char* apcDecFilePath[1];
	char* apcEncFilePath[1];
	bool abOpen[1];
	bool abEnc[1];
	bool bReEncWndOK;
	int nElmID1;
	int nElmID2;

	nElmID1 = reEncFileList.poRoot->GetElmID("passwordHash", 0);
	if (nElmID1 == -1) {
		return false;
	}
	ReEncWnd reEncWnd(&cipher_obj, reEncFileList.poRoot->ppoElms[nElmID1]->pcContent, const_cast<PathManagement*>(&pathManagement_obj));

	nElmID1 = -1;
	while (true) {
		nElmID1 = reEncFileList.poRoot->GetElmID("item", nElmID1 + 1);
		if (nElmID1 == -1) {
			break;
		}
		else {
			nElmID2 = reEncFileList.poRoot->ppoElms[nElmID1]->GetElmID("reEncFile", 0);
			nFilePathLen = CharSet::ConvertText((unsigned char*)reEncFileList.poRoot->ppoElms[nElmID1]->ppoElms[nElmID2]->pcContent, UTF8_TO_SHIFTJIS);
			apcDecFilePath[0] = (char*)malloc(nFilePathLen + 1);
			CharSet::CopyText((unsigned char*)apcDecFilePath[0]);
			apcDecFilePath[0][nFilePathLen] = NULL;
	
			nElmID2 = reEncFileList.poRoot->ppoElms[nElmID1]->GetElmID("originalFile", 0);
			nFilePathLen = CharSet::ConvertText((unsigned char*)reEncFileList.poRoot->ppoElms[nElmID1]->ppoElms[nElmID2]->pcContent, UTF8_TO_SHIFTJIS);
			apcEncFilePath[0] = (char*)malloc(nFilePathLen + 1);
			CharSet::CopyText((unsigned char*)apcEncFilePath[0]);
			apcEncFilePath[0][nFilePathLen] = NULL;
	
			abOpen[0] = false;
			abEnc[0] = true;
			cipher_obj.RegFiles((char**)&apcDecFilePath, (bool*)&abOpen, (char**)&apcEncFilePath, (bool*)&abEnc, 1);
	
			reEncWnd.poFileList->AddText("\"", true);
			reEncWnd.poFileList->AddText(apcDecFilePath[0], true);
			reEncWnd.poFileList->AddText("\"\r\n", true);
	
			free(apcDecFilePath[0]);
			free(apcEncFilePath[0]);
		}
	}

	bReEncWndOK = reEncWnd.Run(SW_SHOW);
	if (bReEncWndOK) {
		cipher_obj.bChangeName = false;
		cipher_obj.bAutoDel = true;
		cipher_obj.bOverwrite = true;
		cipher_obj.bCreateList = false;
		cipher_obj.Encode(1);
	}
	return true;
}


//==================================================
// C֐
//==================================================
#ifdef DEBUG_MODE
int main()
{
	LPSTR pcCmdLine = static_cast<LPTSTR>(GetCommandLine());
	bool isInQuote = false;
	for (int i = 0; i < lstrlen(pcCmdLine); i++) {
		if (pcCmdLine[i] == '"') {
			if (!isInQuote) {
				isInQuote = true;
			}
			else {
				pcCmdLine += i + 2;
				break;
			}
		}
	}
#else
int WINAPI WinMain(HINSTANCE, HINSTANCE, LPSTR pcCmdLine, int)
{
#endif
	// ϐ̐錾
	PathManagement *poPathManagement;
	EncWnd *poEncWnd;
	CmdLine *poCmdLine;
	CSwatCipher *poCSwatCipher;
	XML *poCSWATFileList;
	bool bEncWndOK;
	int i;
	int nMode;

	// eIuWFNg̐
	poCmdLine = new CmdLine(pcCmdLine);
	poPathManagement = new PathManagement();
	poCSwatCipher = new CSwatCipher(poPathManagement);

	CreateUserDir();
	nMode = GetRunningMode(poCmdLine);
	if (nMode == 1) {
	// Pt@C[h
		poCSwatCipher->Decode(poCmdLine->ppcArgv[0], NULL, 0);

	}
	else if ((nMode == 2)) {
	// C-SWATt@CXg̏

		poCSWATFileList = new XML();
		poCSWATFileList->Load(poCmdLine->ppcArgv[0]);

		if (lstrcmp(poCSWATFileList->poRoot->pcElmName, "reEncFileList") == 0) {
			// ĈÍt@ĈƂ
			ReEncode(*poCSWATFileList, *poPathManagement, *poCSwatCipher);
			DeleteFile(poCmdLine->ppcArgv[0]);
			
		}
		else {
		// [h
			poCSwatCipher->Decode(poCmdLine->ppcArgv[0], poCSWATFileList, 1);
		}
		delete poCSWATFileList;

	}
	else if ((nMode == 3)) {
	// ĈÍɎst@C̍ĈÍ
		char appdataPath_array[MAX_PATH];
		SHGetFolderPath(NULL, CSIDL_APPDATA, NULL, SHGFP_TYPE_CURRENT, appdataPath_array);
		std::string reEncFilePath(appdataPath_array);
		reEncFilePath += "\\Orios\\C-SWAT\\*.csl";
		WIN32_FIND_DATA findFileData;
		HANDLE reEncFileListSearch_hdl = FindFirstFile(reEncFilePath.c_str(), &findFileData);
		if (reEncFileListSearch_hdl != INVALID_HANDLE_VALUE) {
			do {
				XML reEncFileList;
				reEncFilePath = appdataPath_array; // FindFirstFileŎgreEncFilePathėp
				reEncFilePath += "\\Orios\\C-SWAT\\";
				reEncFilePath += findFileData.cFileName;
				reEncFileList.Load(reEncFilePath.c_str());
				ReEncode(reEncFileList, *poPathManagement, *poCSwatCipher);
				DeleteFile(reEncFilePath.c_str());
			} while(FindNextFile(reEncFileListSearch_hdl, &findFileData) != 0);
			FindClose(reEncFileListSearch_hdl);
		}

	}
	else {
	// Í[h
		
		// CEBhE
		poCSwatCipher->LoadConfig(0);
		poEncWnd = new EncWnd(poCSwatCipher, poPathManagement);
		for (i = 0; i < (poCmdLine->nArgc); i++) {
			poEncWnd->InsertFile(poCmdLine->ppcArgv[i]);
		}
		bEncWndOK = poEncWnd->Run(SW_SHOW);
		delete poEncWnd;

		// Í
		if (bEncWndOK) {
			poCSwatCipher->Encode(0);
		}
	}

	// IuWFNg̉
	delete poCSwatCipher;
	delete poPathManagement;
	delete poCmdLine;

#ifdef DEBUG_MODE
	Sleep(100000);
#endif
	// ߂l
	return 0;
}
