/*********************************************************************************

 C-SWAT Ver.2.2.0.0 (ÍNX)


 Copyright (c) 2006-2013, Isao MORI (Orios)
 All rights reserved.

 Redistribution and use in source and binary forms, with or without modification,
 are permitted provided that the following conditions are met:
   * Redistributions of source code must retain the above copyright notice, this
     list of conditions and the following disclaimer.
   * Redistributions in binary form must reproduce the above copyright notice,
     this list of conditions and the following disclaimer in the documentation
     and/or other materials provided with the distribution.
 
 THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND
 ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
 WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
 DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT HOLDER OR CONTRIBUTORS BE LIABLE FOR
 ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
 (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
 LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON
 ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
 (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
 SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
*********************************************************************************/


//==================================================
// CN[h
//==================================================
#include "CSwatCipher.h"

//==================================================
// `
//==================================================
CSwatCipherWnd* CSwatCipher::poCSwatCipherWnd = NULL;
DdeWnd* CSwatCipher::poDdeWnd = NULL;

//----------------------------------------
// t@CpQ
//----------------------------------------
const char CSwatCipher::cChar[64] = {
	0x41, 0x42, 0x43, 0x44, 0x45, 0x46, 0x47, 0x48,
	0x49, 0x4A, 0x4B, 0x4C, 0x4D, 0x4E, 0x4F, 0x50,
	0x51, 0x52, 0x53, 0x54, 0x55, 0x56, 0x57, 0x58,
	0x59, 0x5A, 0x61, 0x62, 0x63, 0x64, 0x65, 0x66,
	0x67, 0x68, 0x69, 0x6A, 0x6B, 0x6C, 0x6D, 0x6E,
	0x6F, 0x70, 0x71, 0x72, 0x73, 0x74, 0x75, 0x76,
	0x77, 0x78, 0x79, 0x7A, 0x30, 0x31, 0x32, 0x33,
	0x34, 0x35, 0x36, 0x37, 0x38, 0x39, 0x2D, 0x5F
};

//----------------------------------------
// RXgN^
//----------------------------------------
CSwatCipher::CSwatCipher(PathManagement *_poPathManagement)
{
	SYSTEMTIME st;

	ppcFilePath = (char**)malloc(1);
	ppcEncFilePath = (char**)malloc(1);
	phThread = (HANDLE*)malloc(1);
	pp_oawfp = (OPEN_AND_WATCH_FILE_PARAMS**)malloc(1);
	pcRootDir = (char*)malloc(1);
	pcCslFileName = (char*)malloc(1);
	pbOpen = (bool*)malloc(1);
	pbEnc = (bool*)malloc(1);
	pcHintText_UTF8 = (char*)malloc(1);
	pcPassHash = (char*)malloc(20);
	pcKey = (char*)malloc(32);
	pcPassHashMD5 = (char*)malloc(16);
	poPathManagement = _poPathManagement;
	nNumOfFiles = 0;
	nNumOfOpenedFiles = 0;
	dwMaxBufSize = 0x19000;
	bPassSet = false;

	bChangeName = false;
	bAutoDel = false;
	bOverwrite = false;
	bNotWatch = false;
	bCreateList = false;
	bAbsolutePath = false;
	pcCslFileName_Config = (char*)malloc(1);
	pcCslFileName_Config[0] = NULL;

	FillMemory(&st, sizeof(SYSTEMTIME), 0);
	GetSystemTime(&st);
	srand(st.wMilliseconds + st.wSecond * 1000);
	
	poConfig = new XML();
}

//----------------------------------------
// fXgN^
//----------------------------------------
CSwatCipher::~CSwatCipher()
{
	// ϐ̐錾
	int i;
	
	// q[v̈̉
	for (i = 0; i < nNumOfFiles; i++) {
		free(ppcFilePath[i]);
		if (ppcEncFilePath[i] != NULL) {
			free(ppcEncFilePath[i]);
		}
	}
	free(phThread);
	free(pp_oawfp);
	free(ppcFilePath);
	free(ppcEncFilePath);
	free(pcRootDir);
	free(pcCslFileName);
	free(pbOpen);
	free(pbEnc);
	free(pcPassHashMD5);
	free(pcPassHash);
	free(pcKey);
	free(pcHintText_UTF8);
	free(pcCslFileName_Config);

	delete poConfig;
}

//----------------------------------------
// t@Co^֐
//----------------------------------------
void CSwatCipher::RegFiles(char** ppcNewFilePath, bool* _pbOpen, char** ppcNewEncFilePath, bool* _pbEnc, int nNumOfNewFiles)
{
	// ϐ̐錾
	int nDirPathLen;
	int i;
	int j;

	// t@C̓o^
	ppcFilePath = (char**)realloc(ppcFilePath, (nNumOfFiles + nNumOfNewFiles) * sizeof(char*));
	ppcEncFilePath = (char**)realloc(ppcEncFilePath, (nNumOfFiles + nNumOfNewFiles) * sizeof(char*));
	for (i = 0; i < nNumOfNewFiles; i++) {
		ppcFilePath[nNumOfFiles + i] = (char*)malloc(lstrlen((LPCSTR)ppcNewFilePath[i]) + 1);
		lstrcpy((LPSTR)ppcFilePath[nNumOfFiles + i], ppcNewFilePath[i]);
		if (ppcNewEncFilePath != NULL) {
			ppcEncFilePath[nNumOfFiles + i] = (char*)malloc(lstrlen((LPCSTR)ppcNewEncFilePath[i]) + 1);
			lstrcpy((LPSTR)ppcEncFilePath[nNumOfFiles + i], ppcNewEncFilePath[i]);
		}
		else {
			ppcEncFilePath[nNumOfFiles + i] = NULL;
		}
	}

	// Jۂ̓o^
	pbOpen = (bool*)realloc(pbOpen, (nNumOfFiles + nNumOfNewFiles) * sizeof(bool));
	memcpy(pbOpen + nNumOfFiles, _pbOpen, nNumOfNewFiles * sizeof(bool));
	pbEnc = (bool*)realloc(pbEnc, (nNumOfFiles + nNumOfNewFiles) * sizeof(bool));
	if (_pbEnc != NULL) {
		memcpy(pbEnc + nNumOfFiles, _pbEnc, nNumOfNewFiles * sizeof(bool));
	}
	else {
		for (i = 0; i < nNumOfNewFiles; i++) {
			pbEnc[nNumOfFiles + i] = true;
		}
	}

	// [gfBNg̐ݒ
	if (nNumOfFiles == 0) {
		nDirPathLen = PathManagement::GetDirPathLen((unsigned char*)ppcFilePath[0]);
		if (nDirPathLen != -1) {
			pcRootDir = (char*)realloc(pcRootDir, nDirPathLen + 1);
			memcpy(pcRootDir, ppcFilePath[0], nDirPathLen);
			pcRootDir[nDirPathLen] = NULL;
		}
	}
	for (i = 0; i < nNumOfNewFiles; i++) {
		for (j = 0; j < lstrlen((LPCSTR)pcRootDir); j++) {
			if (pcRootDir[j] != ppcFilePath[nNumOfFiles + i][j]) {
				pcRootDir[j] = NULL;
				break;
			}
		}
	}
	nDirPathLen = PathManagement::GetDirPathLen((unsigned char*)pcRootDir);
	if (nDirPathLen != -1) {
		pcRootDir = (char*)realloc(pcRootDir, nDirPathLen + 1);
		pcRootDir[nDirPathLen] = NULL;
	}
	
	// ŏI
	nNumOfFiles += nNumOfNewFiles;
}

//----------------------------------------
// pX[hݒ֐
//----------------------------------------
void CSwatCipher::SetPass(char* passwd)
{
	// SHA-1nbV̐
	SHA1 sha1_obj;
	sha1_obj.ProduceSHA1((unsigned char*)passwd, lstrlen((LPCSTR)passwd), (unsigned long*)pcPassHash);
	for (int i4 = 0; i4 < 20; i4 += 4) {
		swap(pcPassHash[i4], pcPassHash[i4 + 3]);
		swap(pcPassHash[i4 + 1], pcPassHash[i4 + 2]);
	}

	// SHA-256nbV̐
	SHA256 sha256_obj;
	sha256_obj.ProduceSHA256((unsigned char*)passwd, lstrlen((LPCSTR)passwd), (unsigned long*)pcKey);
	for (int i4 = 0; i4 < 32; i4 += 4) {
		swap(pcKey[i4], pcKey[i4 + 3]);
		swap(pcKey[i4 + 1], pcKey[i4 + 2]);
	}
	
	// MD5nbV̐
	MD5 md5_obj;
	md5_obj.ProduceMD5(passwd, lstrlen((LPCSTR)passwd), (unsigned long*)pcPassHashMD5);
	for (int i4 = 0; i4 < 16; i4 += 4) {
		swap(pcPassHashMD5[i4], pcPassHashMD5[i4 + 3]);
		swap(pcPassHashMD5[i4 + 1], pcPassHashMD5[i4 + 2]);
	}
	
	bPassSet = true;
}

//----------------------------------------
// qgeLXgݒ֐
//----------------------------------------
void CSwatCipher::SetHintText(char* pcNewHintText)
{
	int nHintTextLen = CharSet::ConvertText((unsigned char*)pcNewHintText, SHIFTJIS_TO_UTF8);
	pcHintText_UTF8 = (char*)realloc(pcHintText_UTF8, nHintTextLen + 1);
	CharSet::CopyText((unsigned char*)pcHintText_UTF8);
	pcHintText_UTF8[nHintTextLen] = NULL;
}

//----------------------------------------
// CSLt@Cݒ֐
//----------------------------------------
void CSwatCipher::SetCslFileName(char* pcNewFileName)
{
	pcCslFileName = (char*)realloc(pcCslFileName, lstrlen((LPCSTR)pcNewFileName) + 1);
	lstrcpy((LPSTR)pcCslFileName, pcNewFileName);
	if (lstrlen((LPCSTR)pcCslFileName) == 0) {
		pcCslFileName = (char*)realloc(pcCslFileName, 16);
		lstrcpy((LPSTR)pcCslFileName, "DecFileList.csl");
	}
	else if ((lstrcmpi(pcCslFileName + lstrlen((LPCSTR)pcCslFileName) - 4, ".csl") != 0)) {
		pcCslFileName = (char*)realloc(pcCslFileName, lstrlen((LPCSTR)pcNewFileName) + 5);
		lstrcat((LPSTR)pcCslFileName, ".csl");
	}
}

//----------------------------------------
// Í֐
//----------------------------------------
void CSwatCipher::Encode(int nMode)
{
	// ϐ̐錾
	SYSTEMTIME st;
	HANDLE hThread;
	char* pcListPath;
	XML* poCSLFile;
	char acNumOfFiles[10];
	char* pcEncFilePath;
	char* pcEncFilePath_UTF8;
	int nEncFilePathLen;
	DWORD dwAttr;
	int nDirPathLen;
	bool bSuccess;
	int nNumOfSucceededFiles = 0;
	int i;
	int j;

	// o^t@CȂꍇ
	if (nNumOfFiles == 0) {
		return;
	}
	
	// EBhEXbh̍쐬
	hThread = CreateThread(NULL, 0, &CreateStatusWnd, NULL, 0, NULL);
	while (poCSwatCipherWnd == NULL) {
		Sleep(100);
	}
	ShowWindow(poCSwatCipherWnd->hWnd, SW_SHOW);
	SetForegroundWindow(poCSwatCipherWnd->hWnd);

	if (nMode == 0) {
		SaveConfig(0);
	}

	// CSLt@Cf[^̍쐬
	if (bCreateList) {
		poCSLFile = new XML();
		poCSLFile->poRoot->SetElmName("decFileList");
		poCSLFile->poRoot->AddAttr("version", "1.0");
		if (bAbsolutePath) {
			poCSLFile->poRoot->AddAttr("path", "absolute");
		}
		else {
			poCSLFile->poRoot->AddAttr("path", "relative");
		}
		poCSLFile->poRoot->ChangeContent("\r\n", true);
		poCSLFile->poRoot->AddElm("hintText", pcHintText_UTF8, true);
		FillMemory(&acNumOfFiles, 10, 0);
		_ltoa(nNumOfFiles, (char*)&acNumOfFiles, 10);
		poCSLFile->poRoot->AddElm("fileNum", (char*)&acNumOfFiles, true);
	}

	// Í
	for (i = 0; i < nNumOfFiles; i++) {
		
		// fBNg̒̎擾
		nDirPathLen = PathManagement::GetDirPathLen((unsigned char*)ppcFilePath[i]);

		if (!pbEnc[i]) {
		// 폜݂̂̏ꍇ
			CompleteDel(ppcFilePath[i], ppcFilePath[i] + nDirPathLen, 0, 1000);
			poCSwatCipherWnd->SetProgress((i + 1) * 1000 / nNumOfFiles, 0);
			continue;
		}

		// t@C̍쐬
		if (ppcEncFilePath[i] != NULL) {
			pcEncFilePath = ppcEncFilePath[i];
		}
		else if ((bChangeName)) {
			dwAttr = 0;
			pcEncFilePath = (char*)malloc(nDirPathLen + 13);
			memcpy(pcEncFilePath, ppcFilePath[i], nDirPathLen);
			lstrcpy((LPSTR)pcEncFilePath + nDirPathLen + 8, ".cse");
			while (dwAttr != 0xFFFFFFFF) {
				for (j = 0; j < 8; j++) {
					pcEncFilePath[nDirPathLen + j] = cChar[(rand() & 0x3F)];
				}
				dwAttr = GetFileAttributes(pcEncFilePath);
			}
		}
		else {
			pcEncFilePath = (char*)malloc(lstrlen((LPCSTR)ppcFilePath[i]) + 5);
			lstrcpy((LPSTR)pcEncFilePath, ppcFilePath[i]);
			lstrcat((LPSTR)pcEncFilePath, ".cse");
		}

		// Í
		bSuccess = CreateCSEFile(ppcFilePath[i], nDirPathLen, pcEncFilePath);

		// CSLt@Cւ̏
		if (bSuccess && bCreateList) {
			nNumOfSucceededFiles++;
			if (bAbsolutePath) {
				nEncFilePathLen = CharSet::ConvertText((unsigned char*)pcEncFilePath, SHIFTJIS_TO_UTF8);
			}
			else {
				nEncFilePathLen = CharSet::ConvertText((unsigned char*)pcEncFilePath + lstrlen((LPCSTR)pcRootDir), SHIFTJIS_TO_UTF8);
			}
			pcEncFilePath_UTF8 = (char*)malloc(nEncFilePathLen + 1);
			CharSet::CopyText((unsigned char*)pcEncFilePath_UTF8);
			pcEncFilePath_UTF8[nEncFilePathLen] = NULL;
			poCSLFile->poRoot->AddElm("decFile", pcEncFilePath_UTF8, true);
			free(pcEncFilePath_UTF8);
			if (pbOpen[i]) {
				poCSLFile->poRoot->ppoElms[nNumOfSucceededFiles + 1]->AddAttr("open", "yes");
			}
		}
		
		// ŏI
		if (ppcEncFilePath[i] == NULL) {
			free(pcEncFilePath);
		}
		poCSwatCipherWnd->SetProgress((i + 1) * 1000 / nNumOfFiles, 0);
		if (i % 100 == 99) {
			SendMessage(poCSwatCipherWnd->poStatus->hWnd, WM_SETTEXT, 0, (LPARAM)"");
			FillMemory(&st, sizeof(SYSTEMTIME), 0);
			GetSystemTime(&st);
			srand(st.wMilliseconds + st.wSecond * 1000);
		}
	}
	
	// CSLt@C̏
	if (bCreateList) {
		pcListPath = (char*)malloc(lstrlen((LPCSTR)pcRootDir) + lstrlen((LPCSTR)pcCslFileName) + 1);
		lstrcpy((LPSTR)pcListPath, pcRootDir);
		lstrcat((LPSTR)pcListPath, pcCslFileName);
		poCSLFile->Save(pcListPath, bOverwrite);
		free(pcListPath);
		delete poCSLFile;
	}

	// ŏI
	PostMessage(poCSwatCipherWnd->hWnd, WM_CLOSE, 0, 0);
	WaitForSingleObject(hThread, INFINITE);
	CloseHandle(hThread);
}

//----------------------------------------
// ֐
//----------------------------------------
void CSwatCipher::Decode(char *pcFilePath, XML* _poDecFileList, int nMode)
{
	XML* poDecFileList;
	HANDLE hThread;
	bool *pbSuccess;
	char** ppcEncFilePath;
	DWORD dwTimeAfterUse;
	DECFILEDATA *pdfdDecFileData;
	FILETIME ft;
	HANDLE hDecFile;
	char* apcDecFilePath[1];
	bool abOpen[1];
	bool abEnc[1];
	int nNumOfDecFiles;
	int nElmID;
	int nAttrID;
	double dVersion;
	int nCurDecFile = 0;
	int nFilePathLen;
	int nDirPathLen;
	bool bOpen;
	char* pcHintText_ShiftJIS;
	int nHintTextLen;
	char* pcStop;
	XML *poReEncFileList;
	int nFileNameLen_UTF8;
	char* pcFileName_UTF8;
	int nElmID2;
	char* pcReEncFileListPath;
	DWORD dwAttr = 0;
	SYSTEMTIME st;
	char acPassHashSHA1_Text[41];
	HANDLE hReEncFileList;
	int i;

	
	hThread = CreateThread(NULL, 0, &CreateStatusWnd, NULL, 0, NULL);
	while (poCSwatCipherWnd == NULL) {
		Sleep(100);
	}
	bPassError = false;

	LoadConfig(1);

	poReEncFileList = new XML();
	poReEncFileList->poRoot->SetElmName("reEncFileList");
	poReEncFileList->poRoot->AddAttr("version", "1.01");
	if (lstrlen((LPCSTR)poReEncFileList->poRoot->pcContent) == 0) {
		poReEncFileList->poRoot->ChangeContent("\r\n", true);
	}

	if (nMode == 0) {
	// Pt@C̕
		nNumOfDecFiles = 1;
		ppcEncFilePath = (char**)malloc(nNumOfDecFiles * sizeof(char*));
		pbSuccess = (bool*)malloc(nNumOfDecFiles * sizeof(bool));
		ppcEncFilePath[0] = (char*)malloc(lstrlen((LPCSTR)pcFilePath) + 1);
		lstrcpy((LPSTR)ppcEncFilePath[0], pcFilePath);
		pdfdDecFileData = (DECFILEDATA*)malloc(nNumOfDecFiles * sizeof(DECFILEDATA));
		pbSuccess[0] = ExpandCSEFile(pcFilePath, true, pdfdDecFileData[0]);
		poCSwatCipherWnd->SetProgress(1000, 1);

		if (pbSuccess[0]) {
			nElmID2 = poReEncFileList->poRoot->AddElm("item", "\r\n\t", true);
			nFileNameLen_UTF8 = CharSet::ConvertText((unsigned char*)pcFilePath, SHIFTJIS_TO_UTF8);
			pcFileName_UTF8 = (char*)malloc(nFileNameLen_UTF8 + 1);
			CharSet::CopyText((unsigned char*)pcFileName_UTF8);
			pcFileName_UTF8[nFileNameLen_UTF8] = NULL;
			poReEncFileList->poRoot->ppoElms[nElmID2]->AddElm("originalFile", pcFileName_UTF8, true);
			nFileNameLen_UTF8 = CharSet::ConvertText((unsigned char*)(char*)&pdfdDecFileData[0].acDecFilePath, SHIFTJIS_TO_UTF8);
			pcFileName_UTF8 = (char*)realloc(pcFileName_UTF8, nFileNameLen_UTF8 + 1);
			CharSet::CopyText((unsigned char*)pcFileName_UTF8);
			pcFileName_UTF8[nFileNameLen_UTF8] = NULL;
			poReEncFileList->poRoot->ppoElms[nElmID2]->AddElm("reEncFile", pcFileName_UTF8, true);
			free(pcFileName_UTF8);
		}
			
	}
	else if ((nMode == 1)) {
	// t@CXgɊÂ

		nDirPathLen = PathManagement::GetDirPathLen((unsigned char*)pcFilePath);
		
		if (_poDecFileList != NULL) {
			poDecFileList = _poDecFileList;
		}
		else {
			poDecFileList = new XML();
			poDecFileList->Load(pcFilePath);
		}
		nElmID = poDecFileList->poRoot->GetElmID("fileNum", 0);
		nAttrID = poDecFileList->poRoot->GetAttrID("version");
		if (nAttrID == -1) {
			bAbsolutePath = false;
		}
		else {
			dVersion = strtod(poDecFileList->poRoot->psAttr[nAttrID].pcAttrValue, NULL);
			if (dVersion > CSL_SUPPORT_VERSION) {
				MessageBox(NULL, STR_MSG_NOT_SUPPORTED, STR_SOFTNAME, MB_OK);
				delete poReEncFileList;
				if (_poDecFileList == NULL) {
					delete poDecFileList;
				}
				return;
			}
		}
		nAttrID = poDecFileList->poRoot->GetAttrID("path");
		if (nAttrID == -1) {
			bAbsolutePath = false;
		}
		else {
			if (lstrcmp("absolute", poDecFileList->poRoot->psAttr[nAttrID].pcAttrValue) == 0) {
				bAbsolutePath = true;
			}
			else {
				bAbsolutePath = false;
			}
		}
		nNumOfDecFiles = strtol(poDecFileList->poRoot->ppoElms[nElmID]->pcContent, &pcStop, 10);
		ppcEncFilePath = (char**)malloc(nNumOfDecFiles * sizeof(char*));
		pbSuccess = (bool*)malloc(nNumOfDecFiles * sizeof(bool));
		pdfdDecFileData = (DECFILEDATA*)malloc(nNumOfDecFiles * sizeof(DECFILEDATA));

		nElmID = poDecFileList->poRoot->GetElmID("hintText", 0);
		if (nElmID == -1) {
			free(ppcEncFilePath);
			free(pbSuccess);
			free(pdfdDecFileData);
			delete poReEncFileList;
			if (_poDecFileList == NULL) {
				delete poDecFileList;
			}
			return;

		}
		else {
			nHintTextLen = CharSet::ConvertText((unsigned char*)poDecFileList->poRoot->ppoElms[nElmID]->pcContent, UTF8_TO_SHIFTJIS);
			pcHintText_ShiftJIS = (char*)malloc(nHintTextLen + 1);
			CharSet::CopyText((unsigned char*)pcHintText_ShiftJIS);
			pcHintText_ShiftJIS[nHintTextLen] = NULL;
			if (!ShowDecWnd(pcFilePath, pcFilePath + nDirPathLen, pcHintText_ShiftJIS)) {
				free(ppcEncFilePath);
				free(pbSuccess);
				free(pdfdDecFileData);
				free(pcHintText_ShiftJIS);
				delete poReEncFileList;
				if (_poDecFileList == NULL) {
					delete poDecFileList;
				}
				return;
			}
			free(pcHintText_ShiftJIS);
		}

		nElmID = -1;
		while (true) {
			nElmID = poDecFileList->poRoot->GetElmID("decFile", nElmID + 1);
			if (nElmID == -1) {
				break;
			}
			else {
				nCurDecFile++;
				nFilePathLen = CharSet::ConvertText((unsigned char*)poDecFileList->poRoot->ppoElms[nElmID]->pcContent, UTF8_TO_SHIFTJIS);
				if (bAbsolutePath) {
					ppcEncFilePath[nCurDecFile - 1] = (char*)malloc(nFilePathLen + 1);
					CharSet::CopyText((unsigned char*)ppcEncFilePath[nCurDecFile - 1]);
					ppcEncFilePath[nCurDecFile - 1][nFilePathLen] = NULL;
				}
				else {
					ppcEncFilePath[nCurDecFile - 1] = (char*)malloc(nDirPathLen + nFilePathLen + 1);
					memcpy(ppcEncFilePath[nCurDecFile - 1], pcFilePath, nDirPathLen);
					CharSet::CopyText((unsigned char*)ppcEncFilePath[nCurDecFile - 1] + nDirPathLen);
					ppcEncFilePath[nCurDecFile - 1][nDirPathLen + nFilePathLen] = NULL;
				}
				nAttrID = poDecFileList->poRoot->ppoElms[nElmID]->GetAttrID("open");
				if (nAttrID == -1) {
					bOpen = false;
				}
				else if ((lstrcmp("yes", poDecFileList->poRoot->ppoElms[nElmID]->psAttr[nAttrID].pcAttrValue) == 0)) {
					bOpen = true;
				}
				else {
					bOpen = false;
				}
				pbSuccess[nCurDecFile - 1] = ExpandCSEFile(ppcEncFilePath[nCurDecFile - 1], bOpen, pdfdDecFileData[nCurDecFile - 1]);
				if (bPassError) {
					for (i = 0; i < nCurDecFile; i++) {
						free(ppcEncFilePath[i]);
					}
					free(ppcEncFilePath);
					free(pbSuccess);
					free(pdfdDecFileData);
					if (_poDecFileList == NULL) {
						delete poDecFileList;
					}
					delete poReEncFileList;
					return;
				}
				if (bAutoDel) {
					poCSwatCipherWnd->SetProgress((DWORD)nCurDecFile * 1000 / ((DWORD)nNumOfDecFiles + 1), 0);
				}
				else {
					poCSwatCipherWnd->SetProgress((DWORD)nCurDecFile * 1000 / (DWORD)nNumOfDecFiles, 0);
				}
				if (nCurDecFile % 100 == 99) {
					SendMessage(poCSwatCipherWnd->poStatus->hWnd, WM_SETTEXT, 0, (LPARAM)"");
				}
				
				if (pbSuccess[nCurDecFile - 1]) {
					nElmID2 = poReEncFileList->poRoot->AddElm("item", "\r\n", true);
					nFileNameLen_UTF8 = CharSet::ConvertText((unsigned char*)ppcEncFilePath[nCurDecFile - 1], SHIFTJIS_TO_UTF8);
					pcFileName_UTF8 = (char*)malloc(nFileNameLen_UTF8 + 1);
					CharSet::CopyText((unsigned char*)pcFileName_UTF8);
					pcFileName_UTF8[nFileNameLen_UTF8] = NULL;
					poReEncFileList->poRoot->ppoElms[nElmID2]->AddElm("originalFile", pcFileName_UTF8, true);
					nFileNameLen_UTF8 = CharSet::ConvertText((unsigned char*)(char*)&pdfdDecFileData[nCurDecFile - 1].acDecFilePath, SHIFTJIS_TO_UTF8);
					pcFileName_UTF8 = (char*)realloc(pcFileName_UTF8, nFileNameLen_UTF8 + 1);
					CharSet::CopyText((unsigned char*)pcFileName_UTF8);
					pcFileName_UTF8[nFileNameLen_UTF8] = NULL;
					poReEncFileList->poRoot->ppoElms[nElmID2]->AddElm("reEncFile", pcFileName_UTF8, true);
					free(pcFileName_UTF8);
				}
				
			}
		}
		if (_poDecFileList == NULL) {
			delete poDecFileList;
		}
	}
	
	if (bAutoDel) {
		CompleteDel(pcFilePath, pcFilePath + nDirPathLen, 0, 1000);
		poCSwatCipherWnd->SetProgress(1000, 0);
	}
	SaveConfig(1);

	PostMessage(poCSwatCipherWnd->hWnd, WM_CLOSE, 0, 0);
	WaitForSingleObject(hThread, INFINITE);
	CloseHandle(hThread);

	for (i = 0; i < nNumOfDecFiles; i++) {
		if (pbSuccess[i]) {
			break;
		}
	}
	if (i == nNumOfDecFiles) {
		for (i = 0; i < nNumOfDecFiles; i++) {
			free(ppcEncFilePath[i]);
		}
		free(ppcEncFilePath);
		free(pbSuccess);
		free(pdfdDecFileData);
		delete poReEncFileList;
		return;
	}
	
	SHA1 sha1_obj;
	unsigned long passHash_sha1_l[5];
	for (int i = 0; i < 5; i++) {
		passHash_sha1_l[i] = ((pcPassHash[i * 4] << 24) & 0xFF000000) | ((pcPassHash[i * 4 + 1] << 16) & 0x00FF0000) | ((pcPassHash[i * 4 + 2] << 8) & 0x0000FF00) | (pcPassHash[i * 4 + 3] & 0x000000FF);
	}
	sha1_obj.FormatSHA1(passHash_sha1_l, acPassHashSHA1_Text);
	acPassHashSHA1_Text[40] = NULL;
	int passwdHashElmID = poReEncFileList->poRoot->AddElm("passwordHash", (char*) &acPassHashSHA1_Text, true);
	poReEncFileList->poRoot->ppoElms[passwdHashElmID]->AddAttr("func", "SHA-1");
	FillMemory(&st, sizeof(SYSTEMTIME), 0);
	GetSystemTime(&st);
	srand(st.wMilliseconds + st.wSecond * 1000);
	char appdataPath_array[MAX_PATH];
	SHGetFolderPath(NULL, CSIDL_APPDATA, NULL, SHGFP_TYPE_CURRENT, appdataPath_array);
	pcReEncFileListPath = (char*)malloc(lstrlen(static_cast<LPCSTR>(appdataPath_array)) + 27);
	lstrcpy((LPSTR)pcReEncFileListPath, appdataPath_array);
	lstrcat((LPSTR)pcReEncFileListPath, "\\Orios\\C-SWAT\\________.csl");
	while (dwAttr != 0xFFFFFFFF) {
		for (i = 0; i < 8; i++) {
			pcReEncFileListPath[lstrlen(static_cast<LPCSTR>(appdataPath_array)) + 14 + i] = cChar[(rand() & 0x3F)];
		}
		dwAttr = GetFileAttributes(pcReEncFileListPath);
	}
	poReEncFileList->Save(pcReEncFileListPath, true);
	hReEncFileList = CreateFile(pcReEncFileListPath, GENERIC_READ | GENERIC_WRITE, 0, NULL, OPEN_EXISTING, 0, NULL);

	DWORD dw_MaxRunningTime = 0;
	for (i = 0; i < nNumOfOpenedFiles; i++) {
		WaitForSingleObject(phThread[i], INFINITE);
		CloseHandle(phThread[i]);
		if (dw_MaxRunningTime < pp_oawfp[i]->dw_RunningTime) {
			dw_MaxRunningTime = pp_oawfp[i]->dw_RunningTime;
		}
		free(pp_oawfp[i]);
	}
	if ((nNumOfOpenedFiles == 0) && (!bNotWatch)) {
		MessageBox(NULL, STR_MSG_WAITING, STR_SOFTNAME, MB_OK);
	}
	if (!bNotWatch && (dw_MaxRunningTime <= 10)) {
		MessageBox(NULL, STR_MSG_REENC_TOO_EARLY, STR_SOFTNAME, MB_OK);
	}
	
	for (i = 0; i < nNumOfDecFiles; i++) {

		if ((!pbSuccess[i]) || bNotWatch) {
			continue;
		}

		apcDecFilePath[0] = (char*)&pdfdDecFileData[i].acDecFilePath;
		abOpen[0] = false;

		FillMemory(&ft, sizeof(FILETIME), 0);
		hDecFile = CreateFile(apcDecFilePath[0], GENERIC_READ, 0, NULL, OPEN_EXISTING, NULL, NULL);
		if (hDecFile != INVALID_HANDLE_VALUE) {
			GetFileTime(hDecFile, NULL, NULL, &ft);
			CloseHandle(hDecFile);
			dwTimeAfterUse = GetTotalSecs(ft);
		}
		else {
			dwTimeAfterUse = 0;
		}

		abEnc[0] = (pdfdDecFileData[i].dwLastWrittenTime != dwTimeAfterUse)? true: false;
		RegFiles((char**)&apcDecFilePath, (bool*)&abOpen, &ppcEncFilePath[i], (bool*)&abEnc, 1);
	}
	
	bChangeName = false;
	bAutoDel = true;
	bOverwrite = true;
	bCreateList = false;
	Encode(1);
	
	if (hReEncFileList != INVALID_HANDLE_VALUE) {
		CloseHandle(hReEncFileList);
	}
	DeleteFile(pcReEncFileListPath);
	free(pcReEncFileListPath);
	for (i = 0; i < nNumOfDecFiles; i++) {
		free(ppcEncFilePath[i]);
	}
	free(ppcEncFilePath);
	free(pbSuccess);
	free(pdfdDecFileData);
	delete poReEncFileList;
}

//----------------------------------------
// EBhE쐬֐
//----------------------------------------
unsigned long __stdcall CSwatCipher::CreateStatusWnd(void*)
{
	poCSwatCipherWnd = new CSwatCipherWnd();
	poCSwatCipherWnd->Run(SW_HIDE);
	delete poCSwatCipherWnd;
	poCSwatCipherWnd = NULL;
	return 0;
}

//----------------------------------------
// R[h̎擾
//----------------------------------------
char CSwatCipher::GetAttrCode(char *pcFilePath) const
{
	// ϐ̐錾E
	DWORD dwAttr;
	char cAttr = 0;

	// ̎擾
	dwAttr = GetFileAttributes(pcFilePath);

	// R[hւ̕ϊ
	if ((dwAttr & FILE_ATTRIBUTE_READONLY) == FILE_ATTRIBUTE_READONLY) {
		cAttr |= 0x01;
	}
	if ((dwAttr & FILE_ATTRIBUTE_HIDDEN) == FILE_ATTRIBUTE_HIDDEN) {
		cAttr |= 0x02;
	}
	if ((dwAttr & FILE_ATTRIBUTE_SYSTEM) == FILE_ATTRIBUTE_SYSTEM) {
		cAttr |= 0x04;
	}
	if ((dwAttr & FILE_ATTRIBUTE_TEMPORARY) == FILE_ATTRIBUTE_TEMPORARY) {
		cAttr |= 0x08;
	}
	if ((dwAttr & FILE_ATTRIBUTE_ARCHIVE) == FILE_ATTRIBUTE_ARCHIVE) {
		cAttr |= 0x10;
	}
	if ((dwAttr & FILE_ATTRIBUTE_ENCRYPTED) == FILE_ATTRIBUTE_ENCRYPTED) {
		cAttr |= 0x20;
	}

	// ߂l
	return cAttr;
}

//----------------------------------------
// oߕb֐
//----------------------------------------
DWORD CSwatCipher::GetTotalSecs(FILETIME ft)
{
	SYSTEMTIME st;
	return (FileTimeToSystemTime(&ft, &st)) ? GetTotalSecs(st) : 0;
}

//----------------------------------------
// oߕb֐
//----------------------------------------
DWORD CSwatCipher::GetTotalSecs(SYSTEMTIME st)
{
	// ZɂĂ͓t31`1428(29)ɂ
	if (st.wMonth < 3) {
		st.wYear--;
		st.wMonth += 12;
	}
	DWORD totalDays = (st.wYear - 1970) * 365 + (st.wYear - 1968) / 4 + (st.wMonth - 2) * 3059 / 100 + st.wDay + 28;
	return totalDays * 86400 + st.wHour * 3600 + st.wMinute * 60 + st.wSecond;
}

//----------------------------------------
// oߕbߊ֐
//----------------------------------------
void CSwatCipher::AnalyzeTotalSecs(DWORD totalSecs, FILETIME* p_ft) const
{
	// ϐ̐錾E
	SYSTEMTIME st;
	DWORD tmp;
	memset(&st, 0, sizeof(SYSTEMTIME));

	// ̉
	st.wSecond = static_cast<WORD>(totalSecs % 60);
	DWORD totalMinutes = totalSecs / 60;
	st.wMinute = static_cast<WORD>(totalMinutes % 60);
	DWORD totalHours = totalMinutes / 60;
	st.wHour = static_cast<WORD>(totalHours % 24);
	DWORD totalDays = totalHours / 24;
//	printf("totalDays: %d\n", totalDays);

	// N̉ (1N31`1428(29)Ƃ)
	//  * Zł悤ɓ4{ĂB
	totalDays -= 58;
	tmp = totalDays * 4 - 2;
	st.wYear = 1970 + tmp / 1461 + ((tmp % 1461 == 0) ? -1 : 0);
	totalDays -= (st.wYear - 1970) * 365 + (st.wYear - 1968) / 4;
	//  * Zł悤ɓ100{ĂB
	tmp = (totalDays + 30) * 100;
	st.wMonth = tmp / 3059 + 2;
	st.wDay = totalDays - (st.wMonth - 2) * 3059 / 100 + 30;

	// 3`14͈̔͂ŉZĂ̂ŁA̕␳
	if (st.wMonth > 12) {
		st.wMonth -= 12;
		st.wYear++;
	}

//	printf("totalHours: %d\n", totalHours);
//	printf("totalMinutes: %d\n", totalMinutes);
//	printf("totalSecs: %d\n", totalSecs);
//	printf("Time: %d-%02d-%02d %02d:%02d:%02d\n\n", st.wYear, st.wMonth, st.wDay, st.wHour, st.wMinute, st.wSecond);

	// FILETIME\̂ւ̕ϊ
	SystemTimeToFileTime(&st, p_ft);
}

//----------------------------------------
// ̐ݒ
//----------------------------------------
void CSwatCipher::SetAttrFromCode(char* pcFilePath, char cAttr) const
{
	// ϐ̐錾E
	DWORD dwAttr = 0;

	// R[h̉
	if ((cAttr & 0x01) == 0x01) {
		dwAttr |= FILE_ATTRIBUTE_READONLY;
	}
	if ((cAttr & 0x02) == 0x02) {
		dwAttr |= FILE_ATTRIBUTE_HIDDEN;
	}
	if ((cAttr & 0x04) == 0x04) {
		dwAttr |= FILE_ATTRIBUTE_SYSTEM;
	}
	if ((cAttr & 0x08) == 0x08) {
		dwAttr |= FILE_ATTRIBUTE_TEMPORARY;
	}
	if ((cAttr & 0x10) == 0x10) {
		dwAttr |= FILE_ATTRIBUTE_ARCHIVE;
	}
	if ((cAttr & 0x20) == 0x20) {
		dwAttr |= FILE_ATTRIBUTE_ENCRYPTED;
	}

	// ̐ݒ
	SetFileAttributes(pcFilePath, dwAttr);

}

//----------------------------------------
// CSEt@C쐬֐
//----------------------------------------
bool CSwatCipher::CreateCSEFile(char* pcFilePath, int nDirPathLen, const char* pcEncFilePath) const
{
	// ϐ̐錾
	Cipher* poRijndael = 0;
	DWORD dwCurPos;
	DWORD dwTemp;
	unsigned __int64 un64Temp;
	unsigned short unTemp;
	unsigned char ucTemp;
	DWORD dwNumOfBytes;
	int nFileNameLen;
	char* pcFileName = 0;

	int nFileNameLen_UTF8;
	char* pcFileName_UTF8 = 0;

	HANDLE hOriginalFile = INVALID_HANDLE_VALUE;
	unsigned __int64 un64OriginalFileSize;
	unsigned __int64 un64EncDataSize;

	HANDLE hEncFile = INVALID_HANDLE_VALUE;

	unsigned char* pucOriginalFileBuf = 0;
	unsigned char* pucEncDataBuf = 0;
	DWORD dwEncBufSize;
	DWORD dwNumOfBytesToWrite;

	unsigned char fileHead[64];
	unsigned char fileHeadHash[32];
	char acVector[16];
	SHA256 sha256_obj;

	FILETIME ftLastModifiedTime;
	FILETIME ftCreationTime;
	int m;

	DWORD dwNumOfBytesToRead;
	unsigned __int64 un64NumOfBytesLeft;

	const int ERR_FILE_CANNOT_OPEN = 1;
	const int ERR_FILE_CANNOT_SAVE = 2;
	const int ERR_FILE_CANNOT_READ = 3;
	const int ERR_FILE_CANNOT_WRITE = 4;

	try {	
		// 
		poRijndael = new Rijndael();
		nFileNameLen = lstrlen((LPCSTR)pcFilePath) - nDirPathLen;
		pcFileName = (char*)malloc(nFileNameLen + 1);
		memcpy(pcFileName, pcFilePath + nDirPathLen, nFileNameLen + 1);
	

		// t@CEqgeLXg̕ϊ
		nFileNameLen_UTF8 = CharSet::ConvertText((unsigned char*)pcFileName, SHIFTJIS_TO_UTF8);
		pcFileName_UTF8 = (char*)malloc(nFileNameLen_UTF8);
		CharSet::CopyText((unsigned char*)pcFileName_UTF8);
	

		// t@CTCY̌vZ
		poCSwatCipherWnd->poStatus->AddText(STR_INFO_ENCODING_01, true);
		poCSwatCipherWnd->poStatus->AddText(pcFileName, true);
		poCSwatCipherWnd->poStatus->AddText(STR_INFO_ENCODING_02, true);
		poCSwatCipherWnd->SetProgress(0, 1);
		hOriginalFile = CreateFile(pcFilePath, (bAutoDel) ? (GENERIC_READ | GENERIC_WRITE) : GENERIC_READ, FILE_SHARE_READ,
			NULL, OPEN_EXISTING, FILE_FLAG_SEQUENTIAL_SCAN, NULL);
		if (hOriginalFile == INVALID_HANDLE_VALUE) throw ERR_FILE_CANNOT_OPEN;
		un64OriginalFileSize = GetFileSize(hOriginalFile, &dwTemp);
		un64OriginalFileSize |= ((unsigned __int64)dwTemp << 32);
		un64EncDataSize = poRijndael->GetNeededBufSize(un64OriginalFileSize);
	
		poCSwatCipherWnd->un64FileSize = un64EncDataSize;
		poCSwatCipherWnd->un64Range = (bAutoDel) ? 780 : 980;


		// ۑt@C̃I[v
		hEncFile = CreateFile(pcEncFilePath, GENERIC_WRITE, 0, NULL, CREATE_NEW, FILE_FLAG_SEQUENTIAL_SCAN, NULL);
		if ((hEncFile == INVALID_HANDLE_VALUE) && (bOverwrite)) {
			hEncFile = CreateFile(pcEncFilePath, GENERIC_WRITE, 0, NULL, TRUNCATE_EXISTING, FILE_FLAG_SEQUENTIAL_SCAN, NULL);
		}
		if (hEncFile == INVALID_HANDLE_VALUE) throw ERR_FILE_CANNOT_SAVE;
		poCSwatCipherWnd->SetProgress(10, 1);


		// L̈̊m
		dwNumOfBytesToWrite = lstrlen((LPCSTR)pcHintText_UTF8) + nFileNameLen_UTF8 + 114;
		dwEncBufSize = (un64EncDataSize > dwMaxBufSize) ? dwMaxBufSize : ((un64EncDataSize > dwNumOfBytesToWrite) ? (DWORD)un64EncDataSize : dwNumOfBytesToWrite);
		pucOriginalFileBuf = (unsigned char*)malloc(dwMaxBufSize);
		pucEncDataBuf = (unsigned char*)malloc(dwEncBufSize);
		FillMemory(pucEncDataBuf, dwEncBufSize, 0);


		// wb_(ۂ̃t@Cf[^ȊO̕)̍쐬	
		lstrcpy((LPSTR)pucEncDataBuf, "CSE");
		pucEncDataBuf[3] = 0x04;
		pucEncDataBuf[4] = 0x00;
		un64Temp = un64EncDataSize + lstrlen((LPCSTR)pcHintText_UTF8) + nFileNameLen_UTF8 + 102;
		memcpy(pucEncDataBuf + 5, &un64Temp, 8);
		dwCurPos = 13;
		poCSwatCipherWnd->SetProgress(10, 1);

		// ubN
		pucEncDataBuf[dwCurPos] = 0x01;
		un64Temp = 5;
		memcpy(pucEncDataBuf + dwCurPos + 1, &un64Temp, 8);
		unTemp = 0x0001;
		memcpy(pucEncDataBuf + dwCurPos + 9, &unTemp, 2);
		ucTemp = 0x01;
		memcpy(pucEncDataBuf + dwCurPos + 11, &ucTemp, 1);
		unTemp = 0x2002;
		memcpy(pucEncDataBuf + dwCurPos + 12, &unTemp, 2);
		dwCurPos += 14;

		// ÍubN
		FillMemory(fileHead, 64, 0);
		ReadFile(hOriginalFile, fileHead, (un64OriginalFileSize >= 64) ? 64 : un64OriginalFileSize, &dwNumOfBytes, NULL);
		SetFilePointer(hOriginalFile, 0, NULL, FILE_BEGIN);
		sha256_obj.ProduceSHA256(fileHead, 64, reinterpret_cast<unsigned long*>(fileHeadHash));
		for (int i4 = 0; i4 < 32; i4 += 4) {
			swap(fileHeadHash[i4], fileHeadHash[i4 + 3]);
			swap(fileHeadHash[i4 + 1], fileHeadHash[i4 + 2]);
		}
		pucEncDataBuf[dwCurPos] = 0x03;
		un64Temp = lstrlen((LPCSTR)pcHintText_UTF8) + 50;
		memcpy(pucEncDataBuf + dwCurPos + 1, &un64Temp, 8);
		memcpy(pucEncDataBuf + dwCurPos + 9, fileHeadHash, 32);
		for (int i = 0; i < 16; i++) {
			acVector[i] = rand() & 0xFF;
		}
		memcpy(pucEncDataBuf + dwCurPos + 41, acVector, 16);
		unTemp = lstrlen((LPCSTR)pcHintText_UTF8);
		memcpy(pucEncDataBuf + dwCurPos + 57, &unTemp, 2);
		memcpy(pucEncDataBuf + dwCurPos + 59, pcHintText_UTF8, lstrlen((LPCSTR)pcHintText_UTF8));
		dwCurPos += lstrlen((LPCSTR)pcHintText_UTF8) + 59;
		poCSwatCipherWnd->SetProgress(20, 1);


		// t@CubN
		FillMemory(&ftCreationTime, sizeof(FILETIME), 0);
		FillMemory(&ftLastModifiedTime, sizeof(FILETIME), 0);
		GetFileTime(hOriginalFile, &ftCreationTime, NULL, &ftLastModifiedTime);
	
		pucEncDataBuf[dwCurPos] = 0x11;
		un64Temp = un64EncDataSize + nFileNameLen_UTF8 + 19;
		memcpy(pucEncDataBuf + dwCurPos + 1, &un64Temp, 8);
		ucTemp = GetAttrCode(pcFilePath);
		memcpy(pucEncDataBuf + dwCurPos + 9, &ucTemp, 1);
		dwTemp = GetTotalSecs(ftCreationTime);
		memcpy(pucEncDataBuf + dwCurPos + 10, &dwTemp, 4);
		dwTemp = GetTotalSecs(ftLastModifiedTime);
		memcpy(pucEncDataBuf + dwCurPos + 14, &dwTemp, 4);
	
		unTemp = nFileNameLen_UTF8;
		memcpy(pucEncDataBuf + dwCurPos + 18, &unTemp, 2);
		for (m = 0; m < unTemp; m++) {
			pcFileName_UTF8[m] ^= pcPassHashMD5[m % 16];
		}
		memcpy(pucEncDataBuf + dwCurPos + 20, pcFileName_UTF8, nFileNameLen_UTF8);
		un64Temp = un64OriginalFileSize;
		memcpy(pucEncDataBuf + dwCurPos + 20 + nFileNameLen_UTF8, &un64Temp, 8);

		if (WriteFile(hEncFile, pucEncDataBuf, dwNumOfBytesToWrite, &dwNumOfBytes, NULL) == 0) throw ERR_FILE_CANNOT_WRITE;
		free(pcFileName_UTF8), pcFileName_UTF8 = 0;
		poCSwatCipherWnd->SetProgress(20, 1);

		// t@Cf[^̈Í
		un64NumOfBytesLeft = un64OriginalFileSize;
		poRijndael->RegWndToSendMsg(poCSwatCipherWnd->hWnd, WM_RIJNDAEL_ENC);
		while (un64NumOfBytesLeft != 0) {

			// t@Cf[^̓ǂݏo
			if (un64NumOfBytesLeft > dwMaxBufSize) {
				dwNumOfBytesToRead = dwMaxBufSize;
			}
			else {
				FillMemory(pucOriginalFileBuf, dwMaxBufSize, 0);
				dwNumOfBytesToRead = (DWORD)un64NumOfBytesLeft;
			}
			if (ReadFile(hOriginalFile, pucOriginalFileBuf, dwNumOfBytesToRead, &dwNumOfBytes, NULL) == 0) throw ERR_FILE_CANNOT_READ;
			un64NumOfBytesLeft -= dwNumOfBytesToRead;

			// Í
			poRijndael->Encrypt(pucOriginalFileBuf, dwNumOfBytesToRead, pcKey, pucEncDataBuf, (unsigned char*)acVector);

			// 
			dwNumOfBytesToWrite = (DWORD)poRijndael->GetNeededBufSize(dwNumOfBytesToRead);
			if (WriteFile(hEncFile, pucEncDataBuf, dwNumOfBytesToWrite, &dwNumOfBytes, NULL) == 0) throw ERR_FILE_CANNOT_WRITE;
		
			// vOXo[
			poCSwatCipherWnd->un64Base = (un64OriginalFileSize - un64NumOfBytesLeft) * (poCSwatCipherWnd->un64Range) / un64OriginalFileSize;
		}


		// ŏIubN̏
		pucEncDataBuf[0] = 0x21;
		if (WriteFile(hEncFile, pucEncDataBuf, 1, &dwNumOfBytes, NULL) == 0) throw ERR_FILE_CANNOT_WRITE;
		CloseHandle(hEncFile), hEncFile = INVALID_HANDLE_VALUE;
		free(pucEncDataBuf), pucEncDataBuf = 0;
		CloseHandle(hOriginalFile), hOriginalFile = INVALID_HANDLE_VALUE;
		free(pucOriginalFileBuf), pucOriginalFileBuf = 0;
	

		// t@C폜
		if (bAutoDel) CompleteDel(pcFilePath, pcFileName, 800, 190);
		poCSwatCipherWnd->SetProgress(1000, 1);

	
		// ŏI
		poCSwatCipherWnd->poStatus->AddText(STR_INFO_FINISH_PROCESS_01, true);
		poCSwatCipherWnd->poStatus->AddText(pcFileName, true);
		poCSwatCipherWnd->poStatus->AddText(STR_INFO_FINISH_PROCESS_02, true);
	}
	catch (int errorCode) {
		poCSwatCipherWnd->poStatus->AddText(STR_INFO_FAIL_ENCODING_01, true);
		poCSwatCipherWnd->poStatus->AddText(pcFileName, true);
		poCSwatCipherWnd->poStatus->AddText(STR_INFO_FAIL_ENCODING_02, true);
		switch (errorCode) {
		case ERR_FILE_CANNOT_OPEN:
			poCSwatCipherWnd->poStatus->AddText(STR_INFO_FILE_CANNOT_OPEN, true);
		case ERR_FILE_CANNOT_SAVE:
			poCSwatCipherWnd->poStatus->AddText(STR_INFO_FILE_CANNOT_SAVE, true);
		case ERR_FILE_CANNOT_READ:
			poCSwatCipherWnd->poStatus->AddText(STR_INFO_FILE_CANNOT_READ, true);
		case ERR_FILE_CANNOT_WRITE:
			poCSwatCipherWnd->poStatus->AddText(STR_INFO_FILE_CANNOT_WRITE, true);
		}
		poCSwatCipherWnd->poStatus->AddText(STR_INFO_FAIL_ENCODING_03, true);
		poCSwatCipherWnd->SetProgress(1000, 0);

		if (poRijndael != 0) delete poRijndael;
		if (pcFileName != 0) free(pcFileName);
		if (pcFileName_UTF8 != 0) free(pcFileName_UTF8);
		if (hOriginalFile != INVALID_HANDLE_VALUE) CloseHandle(hOriginalFile);
		if (hEncFile != INVALID_HANDLE_VALUE) CloseHandle(hEncFile);
		if (pucOriginalFileBuf != 0) free(pucOriginalFileBuf);
		if (pucEncDataBuf != 0) free(pucEncDataBuf);

		return false;
	}

	delete poRijndael;
	free(pcFileName);
	return true;
}

//----------------------------------------
// ֐
//----------------------------------------
bool CSwatCipher::ExpandCSEFile(char* pcFilePath, bool bOpen, DECFILEDATA &dfdFileData)
{
	// t@C̒o
	char* pcFileDir;
	int nDirPathLen;
	int nFileNameLen;
	char* pcFileName;

	nDirPathLen = PathManagement::GetDirPathLen((unsigned char*)pcFilePath);
	nFileNameLen = lstrlen((LPCSTR)pcFilePath) - nDirPathLen;
	pcFileName = (char*)malloc(nFileNameLen + 1);
	pcFileDir = (char*)malloc(nDirPathLen + 1);
	memcpy(pcFileName, pcFilePath + nDirPathLen, nFileNameLen + 1);
	memcpy(pcFileDir, pcFilePath, nDirPathLen);
	pcFileDir[nDirPathLen] = NULL;

	// t@C̃I[vEǂݏo
	HANDLE hEncFile;
	DWORD un64EncFileSize;
	DWORD dwEncBufSize;
	DWORD dwTemp;
	DWORD dwNumOfBytes;
	unsigned char* pucEncFileBuf;

	hEncFile = CreateFile(pcFilePath, GENERIC_READ, FILE_SHARE_READ, NULL, OPEN_EXISTING, FILE_FLAG_SEQUENTIAL_SCAN, NULL);
	if (hEncFile == INVALID_HANDLE_VALUE) {
		MessageBox(NULL, STR_MSG_FILE_CANNOT_OPEN, pcFilePath, MB_OK);
		free(pcFileDir);
		free(pcFileName);
		return false;
	}
	un64EncFileSize = GetFileSize(hEncFile, &dwTemp);
	un64EncFileSize |= ((unsigned __int64)dwTemp << 32);
	if (un64EncFileSize > dwMaxBufSize) {
		dwEncBufSize = dwMaxBufSize;
	}
	else {
		dwEncBufSize = un64EncFileSize;
	}
	pucEncFileBuf = (unsigned char*)malloc(dwEncBufSize);
	
	// t@C̉
	unsigned __int64 un64BlockSize;
	unsigned short usTemp;
	unsigned char ucTemp;
	unsigned char ucHashLen;
	char* pcHintText_ShiftJIS;
	int nHintTextLen;
	char* pcTrueHash; // CSE Ver.3܂ł̓pX[hnbV(SHA-1)ACSE Ver.4ȍ~̓t@C̐擪64oCg̃nbV(SHA-256)
	char cAttr;
	DWORD dwTotalSec_LastModified;
	DWORD dwTotalSec_Creation;
	unsigned __int64 un64DecFileSize;
	char* pcDecFileName_UTF8;
	int nDecFileNameLen;
	char* pcDecFilePath;
	FILETIME ftLastModifiedTime;
	FILETIME ftCreationTime;
	HANDLE hDecFile;
	unsigned char* pucDecFileData;
	Cipher *poRijndael;
	unsigned __int64 un64NumOfBytesLeft;
	DWORD dwNumOfBytesToRead;
	DWORD dwNumOfBytesToWrite;
	char acInitVector[16];
	unsigned char fileHead_a[64];
	unsigned __int64 bytesDecoded_un64 = 0;
	bool isPassConfirmed = false;
	unsigned char passHashMD5_le[16]; // Little Endian
	unsigned char pcKeyForBothVersion[32]; // Ver.3nłVer.4nłg錮
	int j;

	// wb_̃`FbN
	ReadFile(hEncFile, pucEncFileBuf, 13, &dwNumOfBytes, NULL);
	if ((pucEncFileBuf[0] != 0x43) || (pucEncFileBuf[1] != 0x53) || (pucEncFileBuf[2] != 0x45)) {
	// CSEt@CłȂꍇ
		MessageBox(NULL, STR_MSG_NOT_CSE_FILE, STR_SOFTNAME, MB_OK);
		free(pucEncFileBuf);
		free(pcFileDir);
		free(pcFileName);
		return false;
	}
	int majorVerOfCSEFile = static_cast<int>(pucEncFileBuf[3]);
	if (pucEncFileBuf[3] > 0x04) {
	// W[o[Wʂ̏ꍇ(W[o[Wオƌ݊Ȃ)
		MessageBox(NULL, STR_MSG_NOT_SUPPORTED, STR_SOFTNAME, MB_OK);
		free(pucEncFileBuf);
		free(pcFileDir);
		free(pcFileName);
		return false;
	}

	while (true) {
		if (!ReadFile(hEncFile, pucEncFileBuf, 1, &dwNumOfBytes, NULL) || (dwNumOfBytes == 0)) {
			break;
		}
		switch(pucEncFileBuf[0]) {
		case 0x01:
			// ubN
			ReadFile(hEncFile, &un64BlockSize, 8, &dwNumOfBytes, NULL);
			ReadFile(hEncFile, &usTemp, 2, &dwNumOfBytes, NULL);
			if (usTemp != 0x0001) {
				MessageBox(NULL, STR_MSG_NOT_SUPPORTED, STR_SOFTNAME, MB_OK);
				free(pucEncFileBuf);
				free(pcFileDir);
				free(pcFileName);
				return false;
			}
			ReadFile(hEncFile, &ucTemp, 1, &dwNumOfBytes, NULL);
			if (ucTemp != 0x01) {
				MessageBox(NULL, STR_MSG_NOT_SUPPORTED, STR_SOFTNAME, MB_OK);
				free(pucEncFileBuf);
				free(pcFileDir);
				free(pcFileName);
				return false;
			}
			ReadFile(hEncFile, &ucTemp, 1, &dwNumOfBytes, NULL);
			if ((ucTemp != 0x01) && (ucTemp != 0x02)) {
				MessageBox(NULL, STR_MSG_NOT_SUPPORTED, STR_SOFTNAME, MB_OK);
				free(pucEncFileBuf);
				free(pcFileDir);
				free(pcFileName);
				return false;
			}
			ReadFile(hEncFile, &ucHashLen, 1, &dwNumOfBytes, NULL);
			break;
		
		case 0x02:
			// pX[hubN
			//   CSE Ver.3.0ȑÕubN
			//   Ǝ㐫̂Ver.4.0ȍ~ł͔p~
			//   ł͌݊̂߈ێ
			ReadFile(hEncFile, &un64BlockSize, 8, &dwNumOfBytes, NULL);
			pcTrueHash = (char*)malloc(ucHashLen);
			ReadFile(hEncFile, pcTrueHash, ucHashLen, &dwNumOfBytes, NULL);
			ReadFile(hEncFile, &usTemp, 2, &dwNumOfBytes, NULL);
			pcHintText_UTF8 = (char*)realloc(pcHintText_UTF8, usTemp + 1);
			ReadFile(hEncFile, pcHintText_UTF8, usTemp, &dwNumOfBytes, NULL);
			pcHintText_UTF8[usTemp] = NULL;
			nHintTextLen = CharSet::ConvertText((unsigned char*)pcHintText_UTF8, UTF8_TO_SHIFTJIS);
			pcHintText_ShiftJIS = (char*)malloc(nHintTextLen + 1);
			CharSet::CopyText((unsigned char*)pcHintText_ShiftJIS);
			pcHintText_ShiftJIS[nHintTextLen] = NULL;
			
			if (!bPassSet) {
				if (!ShowDecWnd(pcFilePath, pcFileName, pcHintText_ShiftJIS)) {
					free(pcTrueHash);
					free(pucEncFileBuf);
					free(pcFileDir);
					free(pcFileName);
					return false;
				}
			}
			free(pcHintText_ShiftJIS);
			
			for (int j4 = 0; j4 < 20; j4 += 4) {
				if (
					(pcPassHash[j4    ] != pcTrueHash[j4 + 3]) ||
					(pcPassHash[j4 + 1] != pcTrueHash[j4 + 2]) ||
					(pcPassHash[j4 + 2] != pcTrueHash[j4 + 1]) ||
					(pcPassHash[j4 + 3] != pcTrueHash[j4    ])
				) {
					bPassError = true;
					MessageBox(NULL, STR_MSG_PASSWORD_ERROR, STR_SOFTNAME, MB_OK);
					free(pucEncFileBuf);
					free(pcFileDir);
					free(pcFileName);
					free(pcTrueHash);
					return false;
				}
			}
			break;

		case 0x03:
			// ÍubN

			ReadFile(hEncFile, &un64BlockSize, 8, &dwNumOfBytes, NULL);
			pcTrueHash = (char*)malloc(ucHashLen);
			ReadFile(hEncFile, pcTrueHash, ucHashLen, &dwNumOfBytes, NULL);
			ReadFile(hEncFile, acInitVector, 16, &dwNumOfBytes, NULL);
			ReadFile(hEncFile, &usTemp, 2, &dwNumOfBytes, NULL);
			pcHintText_UTF8 = (char*)realloc(pcHintText_UTF8, usTemp + 1);
			ReadFile(hEncFile, pcHintText_UTF8, usTemp, &dwNumOfBytes, NULL);
			pcHintText_UTF8[usTemp] = NULL;
			nHintTextLen = CharSet::ConvertText((unsigned char*)pcHintText_UTF8, UTF8_TO_SHIFTJIS);
			pcHintText_ShiftJIS = (char*)malloc(nHintTextLen + 1);
			CharSet::CopyText((unsigned char*)pcHintText_ShiftJIS);
			pcHintText_ShiftJIS[nHintTextLen] = NULL;

			if (!bPassSet) {
				if (!ShowDecWnd(pcFilePath, pcFileName, pcHintText_ShiftJIS)) {
					free(pcTrueHash);
					free(pucEncFileBuf);
					free(pcFileDir);
					free(pcFileName);
					return false;
				}
			}
			free(pcHintText_ShiftJIS);
			break;

		case 0x11:
			// t@CubN

			for (int j4 = 0; j4 < 16; j4 += 4) {
				passHashMD5_le[j4] = pcPassHashMD5[j4 + 3];
				passHashMD5_le[j4 + 1] = pcPassHashMD5[j4 + 2];
				passHashMD5_le[j4 + 2] = pcPassHashMD5[j4 + 1];
				passHashMD5_le[j4 + 3] = pcPassHashMD5[j4];
			}
			if (majorVerOfCSEFile <= 0x03) {
				poRijndael = new BadRijndael();
				memcpy(acInitVector, passHashMD5_le, 16);
				for (int j4 = 0; j4 < 32; j4 += 4) {
					pcKeyForBothVersion[j4] = pcKey[j4 + 3];
					pcKeyForBothVersion[j4 + 1] = pcKey[j4 + 2];
					pcKeyForBothVersion[j4 + 2] = pcKey[j4 + 1];
					pcKeyForBothVersion[j4 + 3] = pcKey[j4];
				}

			}
			else {
				poRijndael = new Rijndael();
				memcpy(pcKeyForBothVersion, pcKey, 32);
			}
			poRijndael->RegWndToSendMsg(poCSwatCipherWnd->hWnd, WM_RIJNDAEL_DEC);
			ShowWindow(poCSwatCipherWnd->hWnd, SW_SHOW);
			SetForegroundWindow(poCSwatCipherWnd->hWnd);
			poCSwatCipherWnd->poStatus->AddText(STR_INFO_DECODING_01, true);
			poCSwatCipherWnd->poStatus->AddText(pcFileName, true);
			poCSwatCipherWnd->poStatus->AddText(STR_INFO_DECODING_02, true);
			poCSwatCipherWnd->SetProgress(0, 1);
			
			if (bAutoDel) {
				poCSwatCipherWnd->un64Range = 780;
			}
			else {
				poCSwatCipherWnd->un64Range = 980;
			}

			// ̎擾
			ReadFile(hEncFile, &un64BlockSize, 8, &dwNumOfBytes, NULL);
			ReadFile(hEncFile, &cAttr, 1, &dwNumOfBytes, NULL);
			ReadFile(hEncFile, &dwTotalSec_Creation, 4, &dwNumOfBytes, NULL);
			ReadFile(hEncFile, &dwTotalSec_LastModified, 4, &dwNumOfBytes, NULL);
			//printf("dwTotalSec_Creation: %x\ndwTotalSec_LastModified: %x\n\n", dwTotalSec_Creation, dwTotalSec_LastModified);
			ReadFile(hEncFile, &usTemp, 2, &dwNumOfBytes, NULL);
			pcDecFileName_UTF8 = (char*)malloc(usTemp + 1);
			ReadFile(hEncFile, pcDecFileName_UTF8, usTemp, &dwNumOfBytes, NULL);
			if (majorVerOfCSEFile <= 0x03) {
				for (j = 0; j < usTemp; j++) {
					pcDecFileName_UTF8[j] ^= passHashMD5_le[j % 16];
				}
			}
			else {
				for (j = 0; j < usTemp; j++) {
					pcDecFileName_UTF8[j] ^= pcPassHashMD5[j % 16];
				}
			}
			pcDecFileName_UTF8[usTemp] = NULL;
			ReadFile(hEncFile, &un64DecFileSize, 8, &dwNumOfBytes, NULL);
			poCSwatCipherWnd->SetProgress(10, 1);

			// 
			un64NumOfBytesLeft = un64DecFileSize;
			if (un64NumOfBytesLeft > dwMaxBufSize) {
				pucDecFileData = (unsigned char*)malloc(dwMaxBufSize);
			}
			else if ((un64NumOfBytesLeft == 0)) {
				pucDecFileData = (unsigned char*)malloc((size_t)poRijndael->GetNeededBufSize(1));
			}
			else {
				pucDecFileData = (unsigned char*)malloc((size_t)poRijndael->GetNeededBufSize(un64NumOfBytesLeft));
			}
			poCSwatCipherWnd->un64FileSize = un64NumOfBytesLeft;
			poCSwatCipherWnd->un64Base = poCSwatCipherWnd->un64Range + 10;

			FillMemory(fileHead_a, 64, 0);
			do {
				// t@Cf[^̓ǂݏo
				if (un64NumOfBytesLeft > dwMaxBufSize) {
					dwNumOfBytesToWrite = dwNumOfBytesToRead = dwMaxBufSize;
				}
				else if ((un64NumOfBytesLeft == 0)) {
					dwNumOfBytesToWrite = 0;
					dwNumOfBytesToRead = (DWORD)poRijndael->GetNeededBufSize(1);
				}
				else {
					dwNumOfBytesToWrite = (DWORD)un64NumOfBytesLeft;
					dwNumOfBytesToRead = (DWORD)poRijndael->GetNeededBufSize(un64NumOfBytesLeft);
				}
				ReadFile(hEncFile, pucEncFileBuf, dwNumOfBytesToRead, &dwNumOfBytes, NULL);
				bytesDecoded_un64 += dwNumOfBytesToWrite;
				un64NumOfBytesLeft -= dwNumOfBytesToWrite;
				if (un64DecFileSize != 0) {
					// vOXo[
					poCSwatCipherWnd->un64Base = (un64DecFileSize - un64NumOfBytesLeft) * (poCSwatCipherWnd->un64Range) / un64DecFileSize;
	
					// 
					poRijndael->Decrypt(pucEncFileBuf, dwNumOfBytesToRead, (char*)pcKeyForBothVersion, pucDecFileData, reinterpret_cast<unsigned char*>(acInitVector));
				}
				else {
					// vOXo[
					poCSwatCipherWnd->un64Base = poCSwatCipherWnd->un64Range;
				}

				// pX[h̊mF
				if (!isPassConfirmed && ((bytesDecoded_un64 >= 64) || (un64NumOfBytesLeft == 0))) {
					if (majorVerOfCSEFile >= 0x04) {
						SHA256 sha256_obj;
						unsigned char fileHeadHash_a[32];
						unsigned char fileHeadHastText_a[65];
						fileHeadHastText_a[64] = NULL;
						memcpy(fileHead_a, pucDecFileData, (bytesDecoded_un64 < 64)? bytesDecoded_un64: 64);
						sha256_obj.ProduceSHA256(fileHead_a, 64, reinterpret_cast<unsigned long*>(fileHeadHash_a));
						for (int j4 = 0; j4 < 32; j4 += 4) {
							if (
								(fileHeadHash_a[j4    ] != static_cast<unsigned char>(pcTrueHash[j4 + 3])) ||
								(fileHeadHash_a[j4 + 1] != static_cast<unsigned char>(pcTrueHash[j4 + 2])) ||
								(fileHeadHash_a[j4 + 2] != static_cast<unsigned char>(pcTrueHash[j4 + 1])) ||
								(fileHeadHash_a[j4 + 3] != static_cast<unsigned char>(pcTrueHash[j4    ]))
							) {
								bPassError = true;
								MessageBox(NULL, STR_MSG_PASSWORD_ERROR, STR_SOFTNAME, MB_OK);
								free(pucEncFileBuf);
								free(pcFileDir);
								free(pcFileName);
								free(pcTrueHash);
								return false;
							}
						}
					}
					isPassConfirmed = true;

					// t@C̐(pX[hȂƃt@CȂȂ߁AɋLq)
					nDecFileNameLen = CharSet::ConvertText((unsigned char*)pcDecFileName_UTF8, UTF8_TO_SHIFTJIS);
					pcDecFilePath = (char*)malloc(nDirPathLen + nDecFileNameLen + 1);
					memcpy(pcDecFilePath, pcFileDir, nDirPathLen);
					CharSet::CopyText((unsigned char*)pcDecFilePath + nDirPathLen);
					pcDecFilePath[nDirPathLen + nDecFileNameLen] = NULL;

					// t@C̍쐬
					SECURITY_ATTRIBUTES sa = {sizeof(SECURITY_ATTRIBUTES), NULL, TRUE};
					hDecFile = CreateFile(pcDecFilePath, GENERIC_WRITE, 0, NULL, CREATE_NEW, FILE_FLAG_SEQUENTIAL_SCAN, NULL);
					if ((hDecFile == INVALID_HANDLE_VALUE) && (bOverwrite)) {
						hDecFile = CreateFile(pcDecFilePath, GENERIC_WRITE, 0, NULL, TRUNCATE_EXISTING, FILE_FLAG_SEQUENTIAL_SCAN, NULL);
					}
					if (hDecFile == INVALID_HANDLE_VALUE) {
						delete poRijndael;
						free(pucEncFileBuf);
						free(pcFileDir);
						free(pcFileName);
						free(pcTrueHash);
						free(pcDecFilePath);
						return false;
					}
				}

				// xNg̐ݒ
				memcpy(acInitVector, pucEncFileBuf + dwNumOfBytesToRead - 16, 16);
				
				// 
				if (WriteFile(hDecFile, pucDecFileData, dwNumOfBytesToWrite, &dwNumOfBytes, NULL) == 0) {
					free(pucDecFileData);
					CloseHandle(hDecFile);
					free(pcTrueHash);
					free(pcFileDir);
					free(pucEncFileBuf);
					free(pcFileName);
					free(pcDecFilePath);
					delete poRijndael;
					return false;
				}
			} while(un64NumOfBytesLeft != 0);
			free(pucDecFileData);

			// ŏIXV̐ݒ
			AnalyzeTotalSecs(dwTotalSec_Creation, &ftCreationTime);
			AnalyzeTotalSecs(dwTotalSec_LastModified, &ftLastModifiedTime);
			SetFileTime(hDecFile, &ftCreationTime, NULL, &ftLastModifiedTime);
			CloseHandle(hDecFile);
			
			// ̐ݒ
			SetAttrFromCode(pcDecFilePath, cAttr);

			// IuWFNg̉Ȃ
			free(pcTrueHash);
			delete poRijndael;
			break;

		case 0x21:
			// IubN
			break;

		default:
			// ̑̃ubN
			ReadFile(hEncFile, &un64BlockSize, 8, &dwNumOfBytes, NULL);
			dwTemp = (DWORD)(un64BlockSize >> 32);
			SetFilePointer(hEncFile, (LONG)(un64BlockSize & 0xFFFFFFFF), (long*)&dwTemp, FILE_CURRENT);
		}
	}
	
	// S폜
	CloseHandle(hEncFile);
	if (bAutoDel) {
		CompleteDel(pcFilePath, pcFileName, 800, 190);
	}
	poCSwatCipherWnd->SetProgress(1000, 1);

	// q[v̈̉1
	free(pcFileDir);
	free(pucEncFileBuf);
	free(pcFileName);
				
	// t@C̃I[vEĎ
	dfdFileData.dwLastWrittenTime = dwTotalSec_LastModified;
	lstrcpy((LPSTR)&dfdFileData.acDecFilePath, pcDecFilePath);
	if (bOpen && (!bNotWatch)) {
		nNumOfOpenedFiles++;
		phThread = (HANDLE*)realloc(phThread, nNumOfOpenedFiles * sizeof(HANDLE));
		pp_oawfp = (OPEN_AND_WATCH_FILE_PARAMS**)realloc(pp_oawfp, nNumOfOpenedFiles * sizeof(OPEN_AND_WATCH_FILE_PARAMS*));
		pp_oawfp[nNumOfOpenedFiles - 1] = (OPEN_AND_WATCH_FILE_PARAMS*)malloc(sizeof(OPEN_AND_WATCH_FILE_PARAMS));
		pp_oawfp[nNumOfOpenedFiles - 1]->pcFilePath = (char*)&dfdFileData.acDecFilePath;
		pp_oawfp[nNumOfOpenedFiles - 1]->dw_RunningTime = 0;
		phThread[nNumOfOpenedFiles - 1] = CreateThread(NULL, 0, &OpenAndWatchFile, pp_oawfp[nNumOfOpenedFiles - 1], 0, NULL);
	}

	// q[v̈̊J2
	free(pcDecFilePath);
	return true;
}

//----------------------------------------
// S폜֐
//----------------------------------------
void CSwatCipher::CompleteDel(char *pcFilePath, char* pcFileName, int nStartPos, int nRange) const
{
	// t@C̃I[v
	HANDLE hDelFile;

	hDelFile = CreateFile(pcFilePath, GENERIC_WRITE, 0, NULL, OPEN_EXISTING, FILE_FLAG_SEQUENTIAL_SCAN, NULL);
	if (hDelFile == INVALID_HANDLE_VALUE) {
		return;
	}

	// t@C̍폜
	unsigned __int64 un64FileSize;
	DWORD dwTemp;
	unsigned __int64 un64NumOfBytesLeft;
	DWORD dwNumOfBytesToWrite;
	DWORD dw;
	SYSTEMTIME st;
	unsigned char* pucDelFileBuf;
	DWORD l;
	unsigned __int64 un64TempRange;

	poCSwatCipherWnd->poStatus->AddText(STR_INFO_DELETING_01, true);
	poCSwatCipherWnd->poStatus->AddText(pcFileName, true);
	poCSwatCipherWnd->poStatus->AddText(STR_INFO_DELETING_02, true);
	poCSwatCipherWnd->SetProgress(nStartPos, 1);

	un64FileSize = GetFileSize(hDelFile, &dwTemp);
	un64FileSize |= ((unsigned __int64)dwTemp << 32);
	un64NumOfBytesLeft = un64FileSize;
	pucDelFileBuf = (unsigned char*)malloc((un64NumOfBytesLeft > dwMaxBufSize)? dwMaxBufSize: (size_t)un64NumOfBytesLeft);
	un64TempRange = (unsigned __int64)(nRange * 0.6);
	while (un64NumOfBytesLeft != 0) {
	
		// ݃TCY̌vZ
		dwNumOfBytesToWrite = (un64NumOfBytesLeft > dwMaxBufSize)? dwMaxBufSize: (DWORD)un64NumOfBytesLeft;
		
		// _f[^
		FillMemory(&st, sizeof(SYSTEMTIME), 0);
		GetSystemTime(&st);
		srand(st.wMilliseconds);
		for (l = 0; l < dwNumOfBytesToWrite; l++) {
			pucDelFileBuf[l] = rand() & 0xFF;
		}
		WriteFile(hDelFile, pucDelFileBuf, dwNumOfBytesToWrite, &dw, NULL);

		// 
		poCSwatCipherWnd->SetProgress((int)(nStartPos + un64TempRange - un64NumOfBytesLeft * un64TempRange / un64FileSize), 1);
		un64NumOfBytesLeft -= dwNumOfBytesToWrite;
	}

	un64NumOfBytesLeft = un64FileSize;
	FillMemory(pucDelFileBuf, (un64NumOfBytesLeft > dwMaxBufSize)? dwMaxBufSize: (size_t)un64NumOfBytesLeft, 0);
	nStartPos += (int)un64TempRange;
	un64TempRange = (unsigned __int64)(nRange * 0.4);
	SetFilePointer(hDelFile, 0, 0, FILE_BEGIN);
	while (un64NumOfBytesLeft != 0) {
	
		// t@Cf[^̏
		dwNumOfBytesToWrite = (un64NumOfBytesLeft > dwMaxBufSize)? dwMaxBufSize: (DWORD)un64NumOfBytesLeft;
		WriteFile(hDelFile, pucDelFileBuf, dwNumOfBytesToWrite, &dw, NULL);
		
		// vOXo[
		poCSwatCipherWnd->SetProgress((int)(nStartPos + un64TempRange - un64NumOfBytesLeft * un64TempRange / un64FileSize), 1);
		un64NumOfBytesLeft -= dwNumOfBytesToWrite;
	}

	SetFilePointer(hDelFile, 0, 0, FILE_BEGIN);
	SetEndOfFile(hDelFile);
	
	CloseHandle(hDelFile);
	DeleteFile(pcFilePath);
}

//----------------------------------------
// EBhE\֐
//----------------------------------------
bool CSwatCipher::ShowDecWnd(char* pcFilePath, char* pcFileName, char* pcHintText_ShiftJIS)
{
	DecWnd *poDecWnd;

	poDecWnd = new DecWnd(pcFilePath, pcFileName, pcHintText_ShiftJIS, poPathManagement);
	if (bOverwrite) {
		SendMessage(poDecWnd->poOverwrite->hWnd, BM_SETCHECK, BST_CHECKED, 0);
	}
	if (bNotWatch) {
		SendMessage(poDecWnd->poNotWatch->hWnd, BM_SETCHECK, BST_CHECKED, 0);
		EnableWindow(poDecWnd->poAutoDel->hWnd, true);
	}
	else {
		EnableWindow(poDecWnd->poAutoDel->hWnd, false);
	}
	if (bAutoDel) {
		SendMessage(poDecWnd->poAutoDel->hWnd, BM_SETCHECK, BST_CHECKED, 0);
	}

	if (poDecWnd->Run(SW_SHOW)) {
		bOverwrite = poDecWnd->bOverwrite;
		bNotWatch = poDecWnd->bNotWatch;
		if (bNotWatch) {
			bAutoDel = poDecWnd->bAutoDel;
		}
		else {
			bAutoDel = false;
		}
		SetPass(poDecWnd->pcPassword);
		delete poDecWnd;
		return true;
	}
	else {
		delete poDecWnd;
		return false;
	}
}

//----------------------------------------
// VFR}h̓WJ
//----------------------------------------
void CSwatCipher::ExpandShellCommand(char* &pcCommandStr, const char* pcFilePath, bool bIncludesApp)
{
	bool bSubstitute;
	bool bApp = bIncludesApp;
	bool bInQuot = false;
	char* pcEnvVarName;
	char acEnvVar[MAX_PATH + 1];
	int nEnvVarLen;
	int nFilePathLen = lstrlen(pcFilePath);
	for (int i = 0; i < lstrlen((LPCSTR)pcCommandStr); i++) {
		bSubstitute = false;
		if (pcCommandStr[i] == '"') {
			if (bInQuot) {
				bApp = false;
			}
			bInQuot ^= 0x01;

		}
		else if ((pcCommandStr[i] == '%')) {
			if (bApp && ((i == 0) || (pcCommandStr[i - 1] == '"'))) {
				for (int j = i + 1; j < lstrlen((LPCSTR)pcCommandStr); j++) {
					if (pcCommandStr[j] == '%') {
						pcEnvVarName = (char*)malloc(j - i);
						memcpy(pcEnvVarName, pcCommandStr + i + 1, j - i - 1);
						pcEnvVarName[j - i - 1] = NULL;
						nEnvVarLen = GetEnvironmentVariable(pcEnvVarName, (char*)&acEnvVar, MAX_PATH);
						if (nEnvVarLen == 0) {
							break;
						}
						else if ((nEnvVarLen > (j - i + 1))) {
							pcCommandStr = (char*)realloc(pcCommandStr, lstrlen((LPCSTR)pcCommandStr) + nEnvVarLen - j + i + 2);
							for (int k = lstrlen((LPCSTR)pcCommandStr); k > j; k--) {
								pcCommandStr[k + nEnvVarLen - j + i - 1] = pcCommandStr[k];
							}
						}
						else if ((nEnvVarLen < (j - i + 1))) {
							for (int k = j + 1; k <= lstrlen((LPCSTR)pcCommandStr); k++) {
								pcCommandStr[k + nEnvVarLen - j + i - 1] = pcCommandStr[k];
							}
							pcCommandStr = (char*)realloc(pcCommandStr, lstrlen((LPCSTR)pcCommandStr) + nEnvVarLen - j + i + 2);
						}
						memcpy(pcCommandStr + i, &acEnvVar, nEnvVarLen);
						free(pcEnvVarName);
						bSubstitute = true;
						i += nEnvVarLen - 1;
						break;
					}
				}
			}

			if (!bSubstitute) {
				if ((pcCommandStr[i + 1] == '0') || (pcCommandStr[i + 1] == '1') || (pcCommandStr[i + 1] == 'L') || (pcCommandStr[i + 1] == 'l') || (pcCommandStr[i + 1] == 'D') || (pcCommandStr[i + 1] == 'd')) {
					int nCmdLineLen = lstrlen(pcCommandStr);
					pcCommandStr = (char*)realloc(pcCommandStr, nCmdLineLen + nFilePathLen - 1);
					for (int j = nCmdLineLen; j > i; j--) {
						pcCommandStr[nFilePathLen + j - 2] = pcCommandStr[j];
					}
					memcpy(pcCommandStr + i, pcFilePath, nFilePathLen);
					i += nFilePathLen - 1;
				}
				else if (((pcCommandStr[i + 1] == '*') || (pcCommandStr[i + 1] == 'H') || (pcCommandStr[i + 1] == 'h') || (pcCommandStr[i + 1] == 'I') || (pcCommandStr[i + 1] == 'i') || (pcCommandStr[i + 1] == 'S') || (pcCommandStr[i + 1] == 's'))) {
					for (int j = i; j < lstrlen((LPCSTR)pcCommandStr); j++) {
						pcCommandStr[j] = pcCommandStr[j + 2];
					}
					i--;
				}
				else {
					for (int j = i; j < lstrlen((LPCSTR)pcCommandStr); j++) {
						pcCommandStr[j] = pcCommandStr[j + 1];
					}
					i--;
				}
			}
		}
	}
}

//----------------------------------------
// t@CI[vEĎ֐
//----------------------------------------
unsigned long __stdcall CSwatCipher::OpenAndWatchFile(void* pParam)
{
	// ϐ̐錾
	OPEN_AND_WATCH_FILE_PARAMS* p_oawfp = (OPEN_AND_WATCH_FILE_PARAMS*)pParam;
	char* pcFilePath = p_oawfp->pcFilePath;

	// gq̎擾
	int nFilePathLen = lstrlen((LPCSTR)pcFilePath);
	char* pcExt = NULL;
	int i;
	for (i = nFilePathLen - 1; i >= 0; i--) {
		if (pcFilePath[i] == '.') {
			pcExt = (char*)malloc(nFilePathLen - i + 1);
			lstrcpy((LPSTR)pcExt, pcFilePath + i);
			break;
		}
	}

	// vOpX̎擾EDDE֘A̎擾
	HKEY hKey = NULL;
	HKEY hCmdKey = NULL;
	HKEY hDdeKey = NULL;
	HKEY hDdeKey2 = NULL;
	char* pcKeyName = NULL;
	char* pcKeyPosForApp = NULL;
	DWORD dwValueSize;

	char* pcCmdLine = NULL;
	char* pcDdeCmd = NULL;
	char* pcDdeApplication = NULL;
	char* pcDdeTopic = NULL;

	try {
		// gqȂꍇ
		if (i == -1) throw 0;

		// L[̈ʒu̎擾
		OSVERSIONINFO ovi;
		ovi.dwOSVersionInfoSize = sizeof(OSVERSIONINFO);
		GetVersionEx(&ovi);
		if (ovi.dwMajorVersion >= 6) {
			pcKeyName = (char*)malloc(72 + lstrlen((LPCSTR)pcExt));
			lstrcpy((LPSTR)pcKeyName, "Software\\Microsoft\\Windows\\CurrentVersion\\Explorer\\FileExts\\");
			lstrcat((LPSTR)pcKeyName, pcExt);
			lstrcat((LPSTR)pcKeyName, "\\UserChoice");
		}
		else {
			pcKeyName = (char*)malloc(61 + lstrlen((LPCSTR)pcExt));
			lstrcpy((LPSTR)pcKeyName, "Software\\Microsoft\\Windows\\CurrentVersion\\Explorer\\FileExts\\");
			lstrcat((LPSTR)pcKeyName, pcExt);
		}

		// ֘AtꂽAvP[VɊւL[̏ꏊ̎擾
		if (RegOpenKeyEx(HKEY_CURRENT_USER, pcKeyName, 0, KEY_READ, &hKey) == ERROR_SUCCESS) {
			if ((RegQueryValueEx(hKey, "Progid", NULL, NULL, NULL, &dwValueSize) == ERROR_SUCCESS) && (dwValueSize > 1)) {
				pcKeyPosForApp = (char*)malloc(dwValueSize);
				RegQueryValueEx(hKey, "Progid", NULL, NULL, (LPBYTE)pcKeyPosForApp, &dwValueSize);
			}
			else if (((RegQueryValueEx(hKey, "Application", NULL, NULL, NULL, &dwValueSize) == ERROR_SUCCESS) && (dwValueSize > 1))) {
				pcKeyPosForApp = (char*)malloc(dwValueSize);
				RegQueryValueEx(hKey, "Application", NULL, NULL, (LPBYTE)pcKeyPosForApp, &dwValueSize);
			}
			RegCloseKey(hKey);
		}
		if ((pcKeyPosForApp == NULL) && (RegOpenKeyEx(HKEY_CLASSES_ROOT, pcExt, 0, KEY_READ, &hKey) == ERROR_SUCCESS)) {
			if ((RegQueryValueEx(hKey, NULL, NULL, NULL, NULL, &dwValueSize) == ERROR_SUCCESS) && (dwValueSize > 1)) {
				pcKeyPosForApp = (char*)malloc(dwValueSize);
				RegQueryValueEx(hKey, NULL, NULL, NULL, (LPBYTE)pcKeyPosForApp, &dwValueSize);
			}
			RegCloseKey(hKey);
		}
		free(pcKeyName);
		pcKeyName = NULL;

		// shell\openL[nh̎擾
		hKey = NULL;
		if (pcKeyPosForApp == NULL) throw 0;
		while (true) {
			pcKeyName = (char*)malloc(lstrlen(pcKeyPosForApp) + 12);
			lstrcpy((LPSTR)pcKeyName, pcKeyPosForApp);
			lstrcat((LPSTR)pcKeyName, "\\shell\\open");
			if (RegOpenKeyEx(HKEY_CLASSES_ROOT, pcKeyName, 0, KEY_READ, &hKey) == ERROR_SUCCESS) {
				break;
			}
			else {
				lstrcpy((LPSTR)pcKeyName, pcKeyPosForApp);
				lstrcat((LPSTR)pcKeyName, "\\CurVer");
				if (RegOpenKeyEx(HKEY_CLASSES_ROOT, pcKeyName, 0, KEY_READ, &hKey) == ERROR_SUCCESS) {
					if ((RegQueryValueEx(hKey, NULL, NULL, NULL, NULL, &dwValueSize) == ERROR_SUCCESS) && (dwValueSize > 1)) {
						pcKeyPosForApp = (char*)realloc(pcKeyPosForApp, dwValueSize);
						RegQueryValueEx(hKey, NULL, NULL, NULL, (LPBYTE)pcKeyPosForApp, &dwValueSize);
						RegCloseKey(hKey);
						hKey = NULL;
					}
				}
				else throw 0;
			}
		}
		free(pcKeyPosForApp);
		pcKeyPosForApp = NULL;
		free(pcKeyName);
		pcKeyName = NULL;

		// vOpX̎擾
		if (RegOpenKeyEx(hKey, "command", 0, KEY_READ, &hCmdKey) == ERROR_SUCCESS) {
			if ((RegQueryValueEx(hCmdKey, NULL, NULL, NULL, NULL, &dwValueSize) == ERROR_SUCCESS)  && (dwValueSize > 1)) {
				pcCmdLine = (char*)malloc(dwValueSize);
				RegQueryValueEx(hCmdKey, NULL, NULL, NULL, (LPBYTE)pcCmdLine, &dwValueSize);
			}
			RegCloseKey(hCmdKey);
		}
			
		// DDE֘A̎擾
		if (RegOpenKeyEx(hKey, "ddeexec", 0, KEY_READ, &hDdeKey) == ERROR_SUCCESS) {
			if ((RegQueryValueEx(hDdeKey, NULL, NULL, NULL, NULL, &dwValueSize) == ERROR_SUCCESS)  && (dwValueSize > 1)) {
				pcDdeCmd = (char*)malloc(dwValueSize);
				RegQueryValueEx(hDdeKey, NULL, NULL, NULL, (LPBYTE)pcDdeCmd, &dwValueSize);
			}

			if (RegOpenKeyEx(hDdeKey, "Application", 0, KEY_READ, &hDdeKey2) == ERROR_SUCCESS) {
				if ((RegQueryValueEx(hDdeKey2, NULL, NULL, NULL, NULL, &dwValueSize) == ERROR_SUCCESS) && (dwValueSize > 1)) {
					pcDdeApplication = (char*)malloc(dwValueSize);
					RegQueryValueEx(hDdeKey2, NULL, NULL, NULL, (LPBYTE)pcDdeApplication, &dwValueSize);
				}
				RegCloseKey(hDdeKey2);
			}

			if (RegOpenKeyEx(hDdeKey, "Topic", 0, KEY_READ, &hDdeKey2) == ERROR_SUCCESS) {
				if ((RegQueryValueEx(hDdeKey2, NULL, NULL, NULL, NULL, &dwValueSize) == ERROR_SUCCESS) && (dwValueSize > 1)) {
					pcDdeTopic = (char*)malloc(dwValueSize);
					RegQueryValueEx(hDdeKey2, NULL, NULL, NULL, (LPBYTE)pcDdeTopic, &dwValueSize);
				}
				RegCloseKey(hDdeKey2);
			}

			RegCloseKey(hDdeKey);
		}

		// shell\openL[̃N[Y
		RegCloseKey(hKey);

	} catch ( ... ) { }
	if (pcKeyName != NULL) free(pcKeyName);
	if (pcKeyPosForApp != NULL) free(pcKeyPosForApp);
	if (pcExt != NULL) free(pcExt);
	
	// vÕI[v
	bool bNotOpened = true;
	STARTUPINFO si;
	PROCESS_INFORMATION pi;
	OPENFILENAME ofn;
	SYSTEMTIME st_Start;
	SYSTEMTIME st_End;

	FillMemory(&st_Start, sizeof(SYSTEMTIME), 0);
	FillMemory(&st_End, sizeof(SYSTEMTIME), 0);
	FillMemory(&si, sizeof(STARTUPINFO), 0);
	si.cb = sizeof(STARTUPINFO);
	FillMemory(&pi, sizeof(PROCESS_INFORMATION), 0);
	
	if (pcCmdLine != NULL) {
		// R}hC̓WJ
		ExpandShellCommand(pcCmdLine, pcFilePath, true);

		if (CreateProcess(NULL, pcCmdLine, NULL, NULL, false, 0, NULL, NULL, &si, &pi) != 0) {
			// DDEʐM
			if (pcDdeCmd != NULL) {
				// DDER}h̓WJ
				ExpandShellCommand(pcDdeCmd, pcFilePath, false);

				// DDEʐM
				DdeConversation dde;
				if (dde.connect(pi.dwProcessId, pcDdeApplication, pcDdeTopic)) {
					if (!dde.execCmd(pcDdeCmd)) {
						MessageBox(NULL, "", "", MB_OK);
					}
				}
				dde.disconnect();
			}
			GetSystemTime(&st_Start);

			// AvP[V̏Iҋ@
			WaitForSingleObject(pi.hProcess, INFINITE);
			CloseHandle(pi.hProcess);
			CloseHandle(pi.hThread);
			bNotOpened = false;
		}
		free(pcCmdLine);

	}
	if (pcDdeCmd != 0) free(pcDdeCmd);
	if (pcDdeApplication != 0) free(pcDdeApplication);
	if (pcDdeTopic != 0) free(pcDdeTopic);

	if (bNotOpened) {
		FillMemory(&ofn, sizeof(OPENFILENAME), 0);
		ofn.lStructSize = sizeof(OPENFILENAME);
		ofn.lpstrFilter = "s`t@C(*.com;*.exe)\0*.com;*.exe\0\0";
		ofn.lpstrFile = (char*)malloc(MAX_PATH + 1);
		FillMemory(ofn.lpstrFile, MAX_PATH + 1, 0);
		ofn.nMaxFile = MAX_PATH + 1;
		ofn.lpstrFileTitle = (char*)malloc(MAX_PATH + 1);
		FillMemory(ofn.lpstrFileTitle, MAX_PATH + 1, 0);
		ofn.nMaxFileTitle = MAX_PATH + 1;
		ofn.lpstrTitle = "̃t@CJvȎI";
		ofn.Flags = OFN_PATHMUSTEXIST | OFN_HIDEREADONLY;
		
		if (GetOpenFileName(&ofn) != 0) {
			pcCmdLine = (char*)malloc(lstrlen((LPCSTR)pcFilePath) + 3);
			lstrcpy((LPSTR)pcCmdLine, "\"");
			lstrcat((LPSTR)pcCmdLine, pcFilePath);
			lstrcat((LPSTR)pcCmdLine, "\"");

			GetSystemTime(&st_Start);
			if (CreateProcess(ofn.lpstrFile, pcCmdLine, NULL, NULL, false, 0, NULL, NULL, &si, &pi) != 0) {
				WaitForSingleObject(pi.hProcess, INFINITE);
				CloseHandle(pi.hProcess);
				CloseHandle(pi.hThread);
			}
			free(pcCmdLine);

		}
		
		free(ofn.lpstrFile);
		free(ofn.lpstrFileTitle);
	}

	// t@Cւ̃ANZX̊mF
	HANDLE hFileToCheckRights;

	if (GetFileAttributes(pcFilePath) != -1) {
		do {
			Sleep(5000);
			hFileToCheckRights = CreateFile(pcFilePath, GENERIC_READ | GENERIC_WRITE, 0, NULL, OPEN_ALWAYS, 0, NULL);
		} while(hFileToCheckRights == INVALID_HANDLE_VALUE);
		CloseHandle(hFileToCheckRights);
	}
	GetSystemTime(&st_End);

	if (!bNotOpened) {
		p_oawfp->dw_RunningTime = GetTotalSecs(st_End) - GetTotalSecs(st_Start);
	}

	return 0;
}

//----------------------------------------
// ݒǂݍ
//----------------------------------------
void CSwatCipher::LoadConfig(int nMode)
{
	int nElmID1;
	int nElmID2;
	int nContentLen;
	
	poConfig->Load(poPathManagement->pcConfigPath);

	if (nMode == 0) {
		nElmID1 = poConfig->poRoot->GetElmID("encode", 0);
		if (nElmID1 != -1) {
			nElmID2 = poConfig->poRoot->ppoElms[nElmID1]->GetElmID("autoDel", 0);
			if ((nElmID2 != -1) && (lstrcmp(poConfig->poRoot->ppoElms[nElmID1]->ppoElms[nElmID2]->pcContent, "yes") == 0)) {
				bAutoDel = true;
			}
			nElmID2 = poConfig->poRoot->ppoElms[nElmID1]->GetElmID("changeName", 0);
			if ((nElmID2 != -1) && (lstrcmp(poConfig->poRoot->ppoElms[nElmID1]->ppoElms[nElmID2]->pcContent, "yes") == 0)) {
				bChangeName = true;
			}
			nElmID2 = poConfig->poRoot->ppoElms[nElmID1]->GetElmID("overwrite", 0);
			if ((nElmID2 != -1) && (lstrcmp(poConfig->poRoot->ppoElms[nElmID1]->ppoElms[nElmID2]->pcContent, "yes") == 0)) {
				bOverwrite = true;
			}
			nElmID2 = poConfig->poRoot->ppoElms[nElmID1]->GetElmID("createList", 0);
			if ((nElmID2 != -1) && (lstrcmp(poConfig->poRoot->ppoElms[nElmID1]->ppoElms[nElmID2]->pcContent, "yes") == 0)) {
				bCreateList = true;
			}
			nElmID2 = poConfig->poRoot->ppoElms[nElmID1]->GetElmID("cslFileName", 0);
			if (nElmID2 != -1) {
				nContentLen = CharSet::ConvertText((unsigned char*)poConfig->poRoot->ppoElms[nElmID1]->ppoElms[nElmID2]->pcContent, UTF8_TO_SHIFTJIS);
				pcCslFileName_Config = (char*)realloc(pcCslFileName_Config, nContentLen + 1);
				CharSet::CopyText((unsigned char*)pcCslFileName_Config);
				pcCslFileName_Config[nContentLen] = NULL;
			}
			nElmID2 = poConfig->poRoot->ppoElms[nElmID1]->GetElmID("absolutePath", 0);
			if ((nElmID2 != -1) && (lstrcmp(poConfig->poRoot->ppoElms[nElmID1]->ppoElms[nElmID2]->pcContent, "yes") == 0)) {
				bAbsolutePath = true;
			}
		}
		
	}
	else if ((nMode == 1)) {
		nElmID1 = poConfig->poRoot->GetElmID("decode", 0);
		if (nElmID1 != -1) {
			nElmID2 = poConfig->poRoot->ppoElms[nElmID1]->GetElmID("overwrite", 0);
			if ((nElmID2 != -1) && (lstrcmp(poConfig->poRoot->ppoElms[nElmID1]->ppoElms[nElmID2]->pcContent, "yes") == 0)) {
				bOverwrite = true;
			}
			nElmID2 = poConfig->poRoot->ppoElms[nElmID1]->GetElmID("notWatch", 0);
			if ((nElmID2 != -1) && (lstrcmp(poConfig->poRoot->ppoElms[nElmID1]->ppoElms[nElmID2]->pcContent, "yes") == 0)) {
				bNotWatch = true;
			}
			nElmID2 = poConfig->poRoot->ppoElms[nElmID1]->GetElmID("autoDel", 0);
			if ((nElmID2 != -1) && (lstrcmp(poConfig->poRoot->ppoElms[nElmID1]->ppoElms[nElmID2]->pcContent, "yes") == 0)) {
				bAutoDel = true;
			}
		}
	}
}

//----------------------------------------
// ݒۑ
//----------------------------------------
void CSwatCipher::SaveConfig(int nMode)
{
	int nElmID1;
	int nElmID2;
	int nAttrID;
	int nContentLen;
	
	poConfig->poRoot->SetElmName("config");
	if (lstrlen((LPCSTR)poConfig->poRoot->pcContent) == 0) {
		poConfig->poRoot->ChangeContent("\r\n", true);
	}
	nAttrID = poConfig->poRoot->GetAttrID("softname");
	if (nAttrID == -1) {
		poConfig->poRoot->AddAttr("softname", STR_SOFTNAME);
	}
	else {
		poConfig->poRoot->ChangeAttrValue(nAttrID, STR_SOFTNAME);
	}
	nAttrID = poConfig->poRoot->GetAttrID("version");
	if (nAttrID == -1) {
		poConfig->poRoot->AddAttr("version", STR_VERSION);
	}
	else {
		poConfig->poRoot->ChangeAttrValue(nAttrID, STR_VERSION);
	}

	if (nMode == 0) {
		nElmID1 = poConfig->poRoot->GetElmID("encode", 0);
		if (nElmID1 == -1) {
			nElmID1 = poConfig->poRoot->AddElm("encode", "\r\n\t", true);
		}

		nElmID2 = poConfig->poRoot->ppoElms[nElmID1]->GetElmID("autoDel", 0);
		if (nElmID2 == -1) {
			nElmID2 = poConfig->poRoot->ppoElms[nElmID1]->AddElm("autoDel", "", true);
		}
		if (bAutoDel) {
			poConfig->poRoot->ppoElms[nElmID1]->ppoElms[nElmID2]->ChangeContent("yes", true);
		}
		else {
			poConfig->poRoot->ppoElms[nElmID1]->ppoElms[nElmID2]->ChangeContent("no", true);
		}

		nElmID2 = poConfig->poRoot->ppoElms[nElmID1]->GetElmID("changeName", 0);
		if (nElmID2 == -1) {
			nElmID2 = poConfig->poRoot->ppoElms[nElmID1]->AddElm("changeName", "", true);
		}
		if (bChangeName) {
			poConfig->poRoot->ppoElms[nElmID1]->ppoElms[nElmID2]->ChangeContent("yes", true);
		}
		else {
			poConfig->poRoot->ppoElms[nElmID1]->ppoElms[nElmID2]->ChangeContent("no", true);
		}
			
		nElmID2 = poConfig->poRoot->ppoElms[nElmID1]->GetElmID("overwrite", 0);
		if (nElmID2 == -1) {
			nElmID2 = poConfig->poRoot->ppoElms[nElmID1]->AddElm("overwrite", "", true);
		}
		if (bOverwrite) {
			poConfig->poRoot->ppoElms[nElmID1]->ppoElms[nElmID2]->ChangeContent("yes", true);
		}
		else {
			poConfig->poRoot->ppoElms[nElmID1]->ppoElms[nElmID2]->ChangeContent("no", true);
		}

		nElmID2 = poConfig->poRoot->ppoElms[nElmID1]->GetElmID("createList", 0);
		if (nElmID2 == -1) {
			nElmID2 = poConfig->poRoot->ppoElms[nElmID1]->AddElm("createList", "", true);
		}
		if (bCreateList) {
			poConfig->poRoot->ppoElms[nElmID1]->ppoElms[nElmID2]->ChangeContent("yes", true);
		}
		else {
			poConfig->poRoot->ppoElms[nElmID1]->ppoElms[nElmID2]->ChangeContent("no", true);
		}

		nElmID2 = poConfig->poRoot->ppoElms[nElmID1]->GetElmID("cslFileName", 0);
		if (nElmID2 == -1) {
			nElmID2 = poConfig->poRoot->ppoElms[nElmID1]->AddElm("cslFileName", "", true);
		}
		nContentLen = CharSet::ConvertText((unsigned char*)pcCslFileName, SHIFTJIS_TO_UTF8);
		pcCslFileName_Config = (char*)realloc(pcCslFileName_Config, nContentLen + 1);
		CharSet::CopyText((unsigned char*)pcCslFileName_Config);
		pcCslFileName_Config[nContentLen] = NULL;
		poConfig->poRoot->ppoElms[nElmID1]->ppoElms[nElmID2]->ChangeContent(pcCslFileName_Config, true);

		nElmID2 = poConfig->poRoot->ppoElms[nElmID1]->GetElmID("absolutePath", 0);
		if (nElmID2 == -1) {
			nElmID2 = poConfig->poRoot->ppoElms[nElmID1]->AddElm("absolutePath", "", true);
		}
		if (bAbsolutePath) {
			poConfig->poRoot->ppoElms[nElmID1]->ppoElms[nElmID2]->ChangeContent("yes", true);
		}
		else {
			poConfig->poRoot->ppoElms[nElmID1]->ppoElms[nElmID2]->ChangeContent("no", true);
		}
		
	}
	else if ((nMode == 1)) {
		nElmID1 = poConfig->poRoot->GetElmID("decode", 0);
		if (nElmID1 == -1) {
			nElmID1 = poConfig->poRoot->AddElm("decode", "\r\n\t", true);
		}

		nElmID2 = poConfig->poRoot->ppoElms[nElmID1]->GetElmID("overwrite", 0);
		if (nElmID2 == -1) {
			nElmID2 = poConfig->poRoot->ppoElms[nElmID1]->AddElm("overwrite", "", true);
		}
		if (bOverwrite) {
			poConfig->poRoot->ppoElms[nElmID1]->ppoElms[nElmID2]->ChangeContent("yes", true);
		}
		else {
			poConfig->poRoot->ppoElms[nElmID1]->ppoElms[nElmID2]->ChangeContent("no", true);
		}
			
		nElmID2 = poConfig->poRoot->ppoElms[nElmID1]->GetElmID("notWatch", 0);
		if (nElmID2 == -1) {
			nElmID2 = poConfig->poRoot->ppoElms[nElmID1]->AddElm("notWatch", "", true);
		}
		if (bNotWatch) {
			poConfig->poRoot->ppoElms[nElmID1]->ppoElms[nElmID2]->ChangeContent("yes", true);
		}
		else {
			poConfig->poRoot->ppoElms[nElmID1]->ppoElms[nElmID2]->ChangeContent("no", true);
		}

		nElmID2 = poConfig->poRoot->ppoElms[nElmID1]->GetElmID("autoDel", 0);
		if (nElmID2 == -1) {
			nElmID2 = poConfig->poRoot->ppoElms[nElmID1]->AddElm("autoDel", "", true);
		}
		if (bAutoDel) {
			poConfig->poRoot->ppoElms[nElmID1]->ppoElms[nElmID2]->ChangeContent("yes", true);
		}
		else {
			poConfig->poRoot->ppoElms[nElmID1]->ppoElms[nElmID2]->ChangeContent("no", true);
		}
	}

	poConfig->Save(poPathManagement->pcConfigPath, true);
}
