/*********************************************************************************

 C-SWAT Ver.2.2.0.0 (ÍNXpwb_)


 Copyright (c) 2006-2013, Isao MORI (Orios)
 All rights reserved.

 Redistribution and use in source and binary forms, with or without modification,
 are permitted provided that the following conditions are met:
   * Redistributions of source code must retain the above copyright notice, this
     list of conditions and the following disclaimer.
   * Redistributions in binary form must reproduce the above copyright notice,
     this list of conditions and the following disclaimer in the documentation
     and/or other materials provided with the distribution.
 
 THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND
 ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
 WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
 DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT HOLDER OR CONTRIBUTORS BE LIABLE FOR
 ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
 (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
 LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON
 ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
 (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
 SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
*********************************************************************************/

#ifndef CSWAT_CIPHER_HEADER
#define CSWAT_CIPHER_HEADER

#include "c-swat.h"
#include "PathManagement.h"
#include "CSwatCipherWnd.h"
#include "DdeConversation.h"
#include "DecWnd.h"

//==================================================
// 萔̐錾
//==================================================
#define CSWAT_DDE_TIMEOUT 20

//==================================================
// \̂̐錾
//==================================================
struct DECFILEDATA {
	DWORD dwLastWrittenTime;
	char acDecFilePath[MAX_PATH + 1];
};

struct OPEN_AND_WATCH_FILE_PARAMS {
	char* pcFilePath;
	DWORD dw_RunningTime;
};

//==================================================
// ÍNX
//==================================================
class CSwatCipher {
private:
	// ϐ̐錾
	static const char cChar[64];
	char** ppcFilePath;
	char** ppcEncFilePath;
	char* pcRootDir;
	char* pcCslFileName;
	bool* pbOpen;
	bool* pbEnc;
	char* pcKey;
	char* pcHintText_UTF8;
	int nNumOfFiles;
	mutable DWORD dwMaxBufSize;
	static CSwatCipherWnd *poCSwatCipherWnd;
	static DdeWnd* poDdeWnd;
	PathManagement *poPathManagement;
	int nNumOfOpenedFiles;
	HANDLE* phThread;
	OPEN_AND_WATCH_FILE_PARAMS** pp_oawfp;
	bool bPassSet;
	bool bPassError;
	XML* poConfig;

	// ֐̐錾
	char GetAttrCode(char* pcFilePath) const;
	static DWORD GetTotalSecs(FILETIME ft);
	static DWORD GetTotalSecs(SYSTEMTIME st);
	void AnalyzeTotalSecs(DWORD dwTotalSecs, FILETIME* pftTimeData) const;
	void SetAttrFromCode(char* pcFilePath, char cAttr) const;
	static unsigned long __stdcall CreateStatusWnd(void *pParamter);
	static unsigned long __stdcall CreateDdeWnd(void *pParamter);
	bool ShowDecWnd(char *pcFilePath, char *pcFileName, char *pcHintText_ShiftJIS);
	bool CreateCSEFile(char* pcFilePath, int nDirNameLen, const char* pcEncFilePath) const;
	//bool EncodeContent();
	bool ExpandCSEFile(char *pcFileName, bool bOpen, DECFILEDATA &dfdFileData);
	static void ExpandShellCommand(char* &pcCommandStr, const char* pcFilePath, bool bIncludesApp);
	void CompleteDel(char *pcFilePath, char* pcFileName, int nStartPos, int nRange) const;
	static unsigned long __stdcall OpenAndWatchFile(void *pParam);
	
	void SaveConfig(int nMode);

public:
	// ϐ̐錾
	bool bChangeName;
	bool bAutoDel;
	bool bOverwrite;
	bool bNotWatch;
	bool bCreateList;
	bool bAbsolutePath;
	char* pcCslFileName_Config;
	char* pcPassHash;
	char* pcPassHashMD5;

	// ֐̐錾
	CSwatCipher(PathManagement *_poPathManagement);
	~CSwatCipher();

	void Encode(int nMode);
	void Decode(char *pcFilePath, XML* _poDecFileList, int nMode);
	void RegFiles(char** ppcNewFilePath, bool* _pbOpen, char** ppcNewEncFilePath, bool* _pbEnc, int nNumOfNewFiles);
	void SetPass(char* pcPassword);
	void SetHintText(char* pcNewHintText);
	void SetCslFileName(char* pcNewFileName);
	void LoadConfig(int nMode);
};

#endif
