/*********************************************************************************

 C-SWAT Ver.2.2.0.0 (ÍEEBhE)


 Copyright (c) 2006-2013, Isao MORI (Orios)
 All rights reserved.

 Redistribution and use in source and binary forms, with or without modification,
 are permitted provided that the following conditions are met:
   * Redistributions of source code must retain the above copyright notice, this
     list of conditions and the following disclaimer.
   * Redistributions in binary form must reproduce the above copyright notice,
     this list of conditions and the following disclaimer in the documentation
     and/or other materials provided with the distribution.
 
 THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND
 ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
 WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
 DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT HOLDER OR CONTRIBUTORS BE LIABLE FOR
 ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
 (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
 LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON
 ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
 (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
 SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
*********************************************************************************/


//==================================================
// CN[h
//==================================================
#include "CSwatCipherWnd.h"

CSwatCipherWnd *CSwatCipherWnd::poThis = NULL;

//----------------------------------------
// EBhENX̓o^
//----------------------------------------
void CSwatCipherWnd::RegWndClass() const
{
	// ϐ̐錾
	WNDCLASSEX wcx;

	// NXf[^̑
	FillMemory(&wcx, sizeof(WNDCLASSEX), 0);
	wcx.cbSize = sizeof(WNDCLASSEX);
	wcx.style = CS_DBLCLKS | CS_HREDRAW | CS_VREDRAW;
	wcx.lpfnWndProc = &TempWindowProc;
	wcx.hInstance = GetModuleHandle(0);
	wcx.hIcon = static_cast<HICON>(LoadImage(wcx.hInstance, MAKEINTRESOURCE(C_SWAT_ICON), IMAGE_ICON, 32, 32, LR_CREATEDIBSECTION));
	wcx.hCursor = LoadCursor(NULL, IDC_ARROW);
	wcx.hbrBackground = hBrush;
	wcx.hIconSm = static_cast<HICON>(LoadImage(wcx.hInstance, MAKEINTRESOURCE(C_SWAT_ICON), IMAGE_ICON, 16, 16, LR_CREATEDIBSECTION));
	wcx.lpszClassName = "C-SWAT_CIPHERWND";

	// o^
	RegisterClassEx(&wcx);
}

//----------------------------------------
// CEBhE쐬
//----------------------------------------
void CSwatCipherWnd::CreateCSwatCipherWnd(const char *pcTitle, long nWidth, long nHeight)
{
	hWnd = CreateWindowEx(
		NULL,
		"C-SWAT_CIPHERWND",
		pcTitle,
		WS_OVERLAPPED | WS_CAPTION | WS_SYSMENU | WS_MINIMIZEBOX,
		CW_USEDEFAULT,
		CW_USEDEFAULT,
		nWidth + GetSystemMetrics(SM_CXFIXEDFRAME) * 2,
		nHeight + GetSystemMetrics(SM_CYFIXEDFRAME) * 2 + GetSystemMetrics(SM_CYCAPTION),
		NULL,
		NULL,
		GetModuleHandle(0),
		this
	);
}

//----------------------------------------
// {^֐
//----------------------------------------
void CSwatCipherWnd::DeleteCloseButton() const
{
	// ϐ̐錾
	HMENU hWndMenu;

	// {^̏
	hWndMenu = GetSystemMenu(hWnd, false);
	RemoveMenu(hWndMenu, 0x0000F060, 0x00000000);
	DeleteMenu(hWndMenu, 5, MF_BYPOSITION);
	DrawMenuBar(hWnd);
	CloseHandle(hWndMenu);
}

//----------------------------------------
// qEBhE쐬֐
//----------------------------------------
void CSwatCipherWnd::CreateChildWindows()
{
	poLabel01 = new Label(hWnd, STR_WND_CW_PROCESS_STATUS, 10, 13, 100, 14, NULL);
	poStatus = new TextArea(hWnd, 10, 30, 430, 150, ID_WND_STATUS, true, NULL);
	poProgressSub = new ProgressBar(hWnd, 10, 190, 390, 20, ID_WND_PROGRESS_SUB, true);
	poProgressMain = new ProgressBar(hWnd, 10, 220, 390, 20, ID_WND_PROGRESS_MAIN, true);
	SendMessage(poProgressSub->hWnd, PBM_SETRANGE, 0, 0x03E80000);
	SendMessage(poProgressMain->hWnd, PBM_SETRANGE, 0, 0x03E80000);
	poPercentageSub = new Label(hWnd, "0.0%", 405, 193, 35, 14, ID_WND_PERCENTAGE_SUB);
	poPercentageSub->ChangeWndStyle(ES_RIGHT, true);
	poPercentageMain = new Label(hWnd, "0.0%", 405, 223, 35, 14, ID_WND_PERCENTAGE_MAIN);
	poPercentageMain->ChangeWndStyle(ES_RIGHT, true);
}

//----------------------------------------
// CEBhER[obN֐
//----------------------------------------
LRESULT CSwatCipherWnd::CSwatCipherWndProc(HWND hWnd, UINT wMsg, WPARAM wParam, LPARAM lParam)
{
	switch(wMsg) {
	case WM_RIJNDAEL_ENC:
		// Rijndael̐i󋵂̕\
		poThis->SetProgress((int)((unsigned __int64)lParam * (poThis->un64Range) / (poThis->un64FileSize) + (poThis->un64Base)), 1);
		break;

	case WM_RIJNDAEL_DEC:
		// Rijndael̐i󋵂̕\
		poThis->SetProgress((int)((poThis->un64Base) - (unsigned __int64)lParam * (poThis->un64Range) / (poThis->un64FileSize)), 1);
		break;

	case WM_CLOSE:
		// {^ꂽꍇ
		DestroyWindow(hWnd);
		break;

	case WM_DESTROY:
		// EBhE
		PostQuitMessage(0);
		break;

	default:
		// ftHg̏
		return DefWindowProc(hWnd, wMsg, wParam, lParam);
	}
	return 0;
}

//----------------------------------------
// RXgN^
//----------------------------------------
CSwatCipherWnd::CSwatCipherWnd()
{
	// 
	pfnWindowProc = &CSwatCipherWndProc;
	poThis = this;
	pcPermillage[0] = (char*)malloc(7);
	pcPermillage[1] = (char*)malloc(7);
	bAccessToPermillage[0] = false;
	bAccessToPermillage[1] = false;

	// EBhE쐬
	RegWndClass();
	CreateCSwatCipherWnd(STR_SOFTNAME, 450, 250);
	DeleteCloseButton();
	CreateChildWindows();
}

//----------------------------------------
// fXgN^
//----------------------------------------
CSwatCipherWnd::~CSwatCipherWnd()
{
	// IuWFNg̉
	delete poLabel01;
	delete poStatus;
	delete poProgressMain;
	delete poProgressSub;
	delete poPercentageMain;
	delete poPercentageSub;

	// EBhENX̉
	UnregisterClass("C-SWAT_CIPHERWND", GetModuleHandle(0));
	
	// q[v̈̉
	free(pcPermillage[0]);
	free(pcPermillage[1]);
}

//----------------------------------------
// i󋵕\֐
//----------------------------------------
void CSwatCipherWnd::SetProgress(int nPermillage, int nWnd)
{
	// 番̍쐬
	if (!bAccessToPermillage[nWnd]) {
		bAccessToPermillage[nWnd] = true;
		FillMemory(pcPermillage[nWnd], 7, 0);
		if ((nPermillage <= 1000) && (nPermillage >= 0)) {
			if (nPermillage > 10) {
				_ltoa(nPermillage, pcPermillage[nWnd], 10);
				nPermillageLen = lstrlen((LPCSTR)pcPermillage[nWnd]);
				pcPermillage[nWnd][nPermillageLen] = pcPermillage[nWnd][nPermillageLen - 1];
				pcPermillage[nWnd][nPermillageLen - 1] = 0x2E;
				lstrcat((LPSTR)pcPermillage[nWnd], "%");
			}
			else {
				_ltoa(nPermillage, pcPermillage[nWnd] + 2, 10);
				pcPermillage[nWnd][0] = 0x30;
				pcPermillage[nWnd][1] = 0x2E;
				lstrcat((LPSTR)pcPermillage[nWnd], "%");
			}
		}
		
		// i󋵂̕\
		if (nWnd == 0) {
			SendMessage(poProgressMain->hWnd, PBM_SETPOS, nPermillage, 0);
			SendMessage(poPercentageMain->hWnd, WM_SETTEXT, 0, (LPARAM)pcPermillage[nWnd]);
		}
		else if ((nWnd == 1)) {
			SendMessage(poProgressSub->hWnd, PBM_SETPOS, nPermillage, 0);
			SendMessage(poPercentageSub->hWnd, WM_SETTEXT, 0, (LPARAM)pcPermillage[nWnd]);
		}
		bAccessToPermillage[nWnd] = false;
	}
}
