/*********************************************************************************

 C-SWAT Ver.2.2.0.0 (CSEt@CNX)


 Copyright (c) 2006-2013, Isao MORI (Orios)
 All rights reserved.

 Redistribution and use in source and binary forms, with or without modification,
 are permitted provided that the following conditions are met:
   * Redistributions of source code must retain the above copyright notice, this
     list of conditions and the following disclaimer.
   * Redistributions in binary form must reproduce the above copyright notice,
     this list of conditions and the following disclaimer in the documentation
     and/or other materials provided with the distribution.
 
 THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND
 ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
 WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
 DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT HOLDER OR CONTRIBUTORS BE LIABLE FOR
 ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
 (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
 LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON
 ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
 (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
 SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
*********************************************************************************/

//==================================================
// CSwatCipherNX
// CreateCSEFile\bhExpandCSEFile\bhڂ\
//==================================================

//==================================================
// CN[h
//==================================================
#include "CseFile.h"

//----------------------------------------
// t@C̎擾
//----------------------------------------
bool CseFile::getOriginalFileName(const unsigned char* cseFilePath, unsigned char* originalFileNameBuf, const unsigned char* password)
{
	// t@CJ
	HANDLE cseFileHdl = CreateFile(reinterpret_cast<LPCSTR>(cseFilePath), GENERIC_READ, FILE_SHARE_READ, NULL, OPEN_EXISTING, FILE_FLAG_SEQUENTIAL_SCAN, NULL);
	if (cseFileHdl == INVALID_HANDLE_VALUE) return false;

	// Header Block
	CSE_HEADER_BLOCK chb;
	DWORD numOfBytesRead;
	ReadFile(cseFileHdl, &chb.fileTypeId, 3, &numOfBytesRead, NULL);
	ReadFile(cseFileHdl, &chb.majorVersion, 1, &numOfBytesRead, NULL);
	if (memcmp(chb.fileTypeId, "CSE", 3) != 0 || chb.majorVersion > 4) return false;
	SetFilePointer(cseFileHdl, 9, NULL, FILE_CURRENT);

	// ubN
	CSE_NORMAL_BLOCK_HEADER cnbh;
	while (ReadFile(cseFileHdl, &cnbh.id, 1, &numOfBytesRead, NULL) && numOfBytesRead != 0) {
		if (cnbh.id == 0x21) break;
		else ReadFile(cseFileHdl, &cnbh.size, 8, &numOfBytesRead, NULL);

		// File Block
		if (cnbh.id == 0x11) {
			// t@C̒擾
			unsigned __int16 lengthOfFileName_utf8;
			SetFilePointer(cseFileHdl, 9, NULL, FILE_CURRENT);
			ReadFile(cseFileHdl, &lengthOfFileName_utf8, 2, &numOfBytesRead, NULL);

			// t@C̎擾
			unsigned char* fileName_utf8 = new unsigned char[lengthOfFileName_utf8 + 2];
			ReadFile(cseFileHdl, fileName_utf8, lengthOfFileName_utf8, &numOfBytesRead, NULL);
			fileName_utf8[lengthOfFileName_utf8] = fileName_utf8[lengthOfFileName_utf8 + 1] = 0;

			// t@C̃}XN
			MD5 md5_obj;
			unsigned char md5Hash[16];
			md5_obj.ProduceMD5(reinterpret_cast<const char*>(password), lstrlen(reinterpret_cast<LPCSTR>(password)), reinterpret_cast<unsigned long*>(md5Hash));
			if (chb.majorVersion >= 0x04) {
				for (int i4 = 0; i4 < 16; i4 += 4) {
					swap(md5Hash[i4], md5Hash[i4 + 3]);
					swap(md5Hash[i4 + 1], md5Hash[i4 + 2]);
				}
			}
			for (int i = 0; i < lengthOfFileName_utf8; i++) {
				fileName_utf8[i] ^= md5Hash[i % 16];
			}

			// t@CShift_JISɕϊ
			int lengthOfFileName_sjis = CharSet::ConvertText(fileName_utf8, UTF8_TO_SHIFTJIS);
			unsigned char* fileName_sjis = new unsigned char[lengthOfFileName_sjis + 1];
			CharSet::CopyText(fileName_sjis);
			fileName_sjis[lengthOfFileName_sjis] = 0;

			// t@C̕ۑ
			lstrcpy(reinterpret_cast<LPSTR>(originalFileNameBuf), reinterpret_cast<LPCSTR>(fileName_sjis));

			// ŏI
			delete[] fileName_utf8;
			delete[] fileName_sjis;
			break;

		}
		// ̑̃ubN
		else {
			SetFilePointer(cseFileHdl, cnbh.size, NULL, FILE_CURRENT);
		}
	}
	CloseHandle(cseFileHdl);

	// ԋpl
	return true;
}
