/*********************************************************************************

 C-SWAT Ver.2.2.0.0 (DDEʐM)


 Copyright (c) 2006-2013, Isao MORI (Orios)
 All rights reserved.

 Redistribution and use in source and binary forms, with or without modification,
 are permitted provided that the following conditions are met:
   * Redistributions of source code must retain the above copyright notice, this
     list of conditions and the following disclaimer.
   * Redistributions in binary form must reproduce the above copyright notice,
     this list of conditions and the following disclaimer in the documentation
     and/or other materials provided with the distribution.
 
 THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND
 ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
 WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
 DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT HOLDER OR CONTRIBUTORS BE LIABLE FOR
 ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
 (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
 LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON
 ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
 (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
 SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
*********************************************************************************/

//==================================================
// CN[h
//==================================================
#include "DdeConversation.h"

#define CSWAT_POST_DDE_MSG (WM_USER + 0x1000)

//==================================================
// DDEʐMNX
//==================================================
//----------------------------------------
// RXgN^
//----------------------------------------
DdeConversation::DdeConversation(): p_ddeWnd(NULL), hThread(NULL) { }

//----------------------------------------
// fXgN^
//----------------------------------------
DdeConversation::~DdeConversation() { }

//----------------------------------------
// DDEʐMpEBhE쐬֐
//----------------------------------------
unsigned long DdeConversation::runDdeWnd(void* p)
{
	DdeWnd* p_ddeWnd = reinterpret_cast<DdeWnd*>(p);
	p_ddeWnd->create();
	p_ddeWnd->Run(SW_HIDE);
	delete p_ddeWnd;
	return 0;
}

//----------------------------------------
// ڑ
//----------------------------------------
bool DdeConversation::connect(DWORD targetProcessId, const char* applicationStr, const char* topicStr)
{
	if (p_ddeWnd != NULL) return false;

	p_ddeWnd = new DdeWnd();
	hThread = CreateThread(NULL, 0, &runDdeWnd, p_ddeWnd, 0, NULL);
	for (int i = 0; i < CSWAT_DDE_TIMEOUT && !p_ddeWnd->isCreated(); i++) Sleep(100);
	if (!p_ddeWnd->isCreated()) return false;
//	cout << "DdeConversation: Created `DdeWnd' Object." << endl;

	ATOM applicationAtom = (applicationStr == NULL)? NULL: GlobalAddAtom(applicationStr); 
	ATOM topicAtom = (topicStr == NULL)? NULL: GlobalAddAtom(topicStr);
	p_ddeWnd->setTargetProcessId(targetProcessId);
//	cout << "applicationAtom = " << applicationAtom << ";" << endl;
//	cout << "topicAtom = " << topicAtom << ";" << endl;
//	cout << "targetProcessId = " << targetProcessId << ";" << endl;

	for (int i = 0; !p_ddeWnd->isConnected() && i < CSWAT_DDE_TIMEOUT; i++) {
		p_ddeWnd->sendInitiationMsg(HWND_BROADCAST, applicationAtom, topicAtom);
		Sleep(1000);
	}
//	if (p_ddeWnd->isConnected()) cout << "DdeConversation: Connection is established." << endl;

	if (applicationAtom != NULL) GlobalDeleteAtom(applicationAtom);
	if (topicAtom != NULL) GlobalDeleteAtom(topicAtom);
	return p_ddeWnd->isConnected();
}

//----------------------------------------
// R}h̎s
//----------------------------------------
bool DdeConversation::execCmd(const char* commandStr)
{
	if (p_ddeWnd == NULL || !p_ddeWnd->isConnected()) return false;

	HGLOBAL hCommand = GlobalAlloc(GMEM_MOVEABLE, lstrlen(commandStr) + 1);
	void* p_command = GlobalLock(hCommand);
	if (p_command == NULL) GlobalFree(hCommand); else lstrcpy(reinterpret_cast<char*>(p_command), commandStr);
	GlobalUnlock(hCommand);

	p_ddeWnd->sendExecutionMsg(hCommand);
//	cout << "DdeConversation: Sent the execution message." << endl;
	for (int i = 0; !p_ddeWnd->receivesAckMsg() && i < CSWAT_DDE_TIMEOUT; i++) Sleep(1000);
	GlobalFree(hCommand);

	bool result = p_ddeWnd->receivesAckMsg();
	if (!result) disconnect();
//	else cout << "DdeConversation: The execution message is sent successfully." << endl;
	return result;
}

//----------------------------------------
// ؒf
//----------------------------------------
void DdeConversation::disconnect()
{
	if (p_ddeWnd == NULL || !p_ddeWnd->isConnected()) return;

	p_ddeWnd->sendTerminationMsg();
	p_ddeWnd->close();
	WaitForSingleObject(hThread, INFINITE);
	CloseHandle(hThread);
	hThread = NULL;
	p_ddeWnd = NULL;
}

//==================================================
// DDEʐMpEBhENX
//==================================================
//----------------------------------------
// staticȕϐ̏
//----------------------------------------
bool DdeWnd::wndClassRegistered = false;

//----------------------------------------
// RXgN^
//----------------------------------------
DdeWnd::DdeWnd(): connectionEstablished(false), hServerWnd(NULL), targetProcessId(0), wndCreated(false)
{
	// 
	pfnWindowProc = &DdeWnd::ddeWndTmpProc;

	// EBhE쐬
	regWndClass();
}

//----------------------------------------
// EBhENX̓o^
//----------------------------------------
void DdeWnd::regWndClass()
{
	// o^󋵂̊mF
	if (wndClassRegistered) return;

	// NXf[^̑
	WNDCLASSEX wcx;
	memset(&wcx, 0, sizeof(WNDCLASSEX));
	wcx.cbSize = sizeof(WNDCLASSEX);
	wcx.lpfnWndProc = &TempWindowProc;
	wcx.hInstance = GetModuleHandle(0);
	wcx.lpszClassName = "C-SWAT_DDEWND";

	// o^
	RegisterClassEx(&wcx);
	wndClassRegistered = true;
}

//----------------------------------------
// CEBhE쐬
//----------------------------------------
void DdeWnd::create()
{
	hWnd = CreateWindowEx(NULL,"C-SWAT_DDEWND", "", NULL, CW_USEDEFAULT, CW_USEDEFAULT, CW_USEDEFAULT, CW_USEDEFAULT, NULL, NULL, GetModuleHandle(0), this);
	wndCreated = true;
}

//----------------------------------------
// CEBhER[obN֐
//----------------------------------------
LRESULT DdeWnd::ddeWndTmpProc(HWND hWnd, UINT wMsg, WPARAM wParam, LPARAM lParam)
{
	return (reinterpret_cast<DdeWnd*>(GetProp(hWnd, "ThisPtr")))->ddeWndProc(hWnd, wMsg, wParam, lParam);
}

//----------------------------------------
// CEBhER[obN֐
//----------------------------------------
LRESULT DdeWnd::ddeWndProc(HWND hWnd, UINT wMsg, WPARAM wParam, LPARAM lParam)
{
	switch(wMsg) {
	// WM_DDE_ACKbZ[W̏
	case WM_DDE_ACK:
		ackMsgReceived = true;
		cout << "DdeConversation: Received a WM_DDE_ACK message." << endl;
		if (!connectionEstablished) {
			DWORD processId;
			GetWindowThreadProcessId(reinterpret_cast<HWND>(wParam), &processId);
//			cout << "wParam = " << reinterpret_cast<HWND>(wParam) << ";" << endl;
//			cout << "processId = " << processId << ";" << endl;
//			cout << "targetProcessId = " << targetProcessId << ";" << endl;
			if (processId == targetProcessId) {
				hServerWnd = reinterpret_cast<HWND>(wParam);
				connectionEstablished = true;
			}
			else PostMessage(reinterpret_cast<HWND>(wParam), WM_DDE_TERMINATE, reinterpret_cast<WPARAM>(hWnd), 0);
		}
		break;

	// bZ[W̑㓊(Xbh̊֌Wő㓊ȂƂ܂Ȃ)
	case CSWAT_POST_DDE_MSG:
		SetLastError(0);
		PostMessage(hServerWnd, wParam, reinterpret_cast<WPARAM>(hWnd), lParam);
//		cout << "DdeConversation: A message(" << wParam << ", " << lParam << ") is sent from " << hWnd << " to " << hServerWnd << "." << endl;
//		cout << "GetLastError() = " << GetLastError() << ";" << endl;
		break;

	// {^ꂽꍇ
	case WM_CLOSE:
		DestroyWindow(hWnd);
		break;

	// EBhE
	case WM_DESTROY:
		PostQuitMessage(0);
		break;

	// ftHg̏
	default:
		return DefWindowProc(hWnd, wMsg, wParam, lParam);
	}
	return 0;
}

//----------------------------------------
// DDET[o[̃vZXID̐ݒ
//----------------------------------------
void DdeWnd::setTargetProcessId(DWORD targetProcessId)
{
	DdeWnd::targetProcessId = targetProcessId;
}

//----------------------------------------
// bZ[W̑M
//----------------------------------------
void DdeWnd::sendInitiationMsg(HWND hTargetWnd, ATOM applicationAtom, ATOM topicAtom)
{
	ackMsgReceived = false;
	SetLastError(0);
	SendMessage(hTargetWnd, WM_DDE_INITIATE, reinterpret_cast<WPARAM>(hWnd), MAKELONG(applicationAtom, topicAtom));
//	cout << "DdeConversation: Sent a WM_DDE_INITIATE to the DdeWnd." << endl;
//	cout << "GetLastError() = " << GetLastError() << ";" << endl;
}

//----------------------------------------
// R}hsbZ[W̑M
//----------------------------------------
void DdeWnd::sendExecutionMsg(HGLOBAL hCommand)
{
	ackMsgReceived = false;
	SetLastError(0);
	PostMessage(hWnd, CSWAT_POST_DDE_MSG, WM_DDE_EXECUTE, PackDDElParam(WM_DDE_EXECUTE, 0, reinterpret_cast<UINT>(hCommand)));
//	cout << "DdeConversation: Sent a WM_DDE_EXECUTE to the DdeWnd." << endl;
//	cout << "GetLastError() = " << GetLastError() << ";" << endl;
}

//----------------------------------------
// IbZ[W̑M
//----------------------------------------
void DdeWnd::sendTerminationMsg()
{
	SetLastError(0);
	PostMessage(hWnd, CSWAT_POST_DDE_MSG, WM_DDE_TERMINATE, 0);
//	cout << "DdeConversation: Sent a WM_DDE_TERMINATE to the DdeWnd." << endl;
//	cout << "GetLastError() = " << GetLastError() << ";" << endl;
	connectionEstablished = false;
}

//----------------------------------------
// EBhE
//----------------------------------------
void DdeWnd::close()
{
	PostMessage(hWnd, WM_CLOSE, 0, 0);
}

//----------------------------------------
// ڑ̊mF
//----------------------------------------
bool DdeWnd::isConnected()
{
	return connectionEstablished;
}

//----------------------------------------
// Window𐶐̊mF
//----------------------------------------
bool DdeWnd::isCreated()
{
	return wndCreated;
}

//----------------------------------------
// WM_DDE_ACK󂯎̊mF
//----------------------------------------
bool DdeWnd::receivesAckMsg()
{
	return ackMsgReceived;
}

//----------------------------------------
// fXgN^
//----------------------------------------
DdeWnd::~DdeWnd() { }
