/*********************************************************************************

 C-SWAT Ver.2.2.0.0 (DDEʐMpwb_)


 Copyright (c) 2006-2013, Isao MORI (Orios)
 All rights reserved.

 Redistribution and use in source and binary forms, with or without modification,
 are permitted provided that the following conditions are met:
   * Redistributions of source code must retain the above copyright notice, this
     list of conditions and the following disclaimer.
   * Redistributions in binary form must reproduce the above copyright notice,
     this list of conditions and the following disclaimer in the documentation
     and/or other materials provided with the distribution.
 
 THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND
 ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
 WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
 DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT HOLDER OR CONTRIBUTORS BE LIABLE FOR
 ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
 (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
 LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON
 ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
 (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
 SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
*********************************************************************************/

#ifndef DDE_CONVERSATION_HEADER
#define DDE_CONVERSATION_HEADER

#include "c-swat.h"

#define CSWAT_DDE_TIMEOUT 20

//==================================================
// DDEEBhENX
//==================================================
class DdeWnd : public Window {
private:
	static bool wndClassRegistered;
	bool connectionEstablished;
	bool ackMsgReceived;
	bool wndCreated;
	HWND hServerWnd;
	DWORD targetProcessId;

	static LRESULT ddeWndTmpProc(HWND hWnd, UINT wMsg, WPARAM wParam, LPARAM lParam);
	LRESULT ddeWndProc(HWND hWnd, UINT wMsg, WPARAM wParam, LPARAM lParam);
	void regWndClass();

public:
	DdeWnd();
	~DdeWnd();

	void create();
	void setTargetProcessId(DWORD targetProcessId);
	void sendInitiationMsg(HWND hTargetWnd, ATOM applicationAtom, ATOM topicAtom);
	void sendExecutionMsg(HGLOBAL hCommand);
	void sendTerminationMsg();
	bool isConnected();
	bool isCreated();
	bool receivesAckMsg();
	void close();
};


//==================================================
// DDEʐMNX
//==================================================
class DdeConversation {
private:
	DdeWnd* p_ddeWnd;
	HANDLE hThread;

	static unsigned long __stdcall runDdeWnd(void* p_ddeWnd);

public:
	// ֐̐錾
	DdeConversation();
	~DdeConversation();

	bool connect(DWORD targetProcessId, const char* applicationStr, const char* topicStr);
	bool execCmd(const char* commandStr);
	void disconnect();
};

#endif
