/*********************************************************************************

 C-SWAT Ver.2.2.0.0 (EBhE)


 Copyright (c) 2006-2013, Isao MORI (Orios)
 All rights reserved.

 Redistribution and use in source and binary forms, with or without modification,
 are permitted provided that the following conditions are met:
   * Redistributions of source code must retain the above copyright notice, this
     list of conditions and the following disclaimer.
   * Redistributions in binary form must reproduce the above copyright notice,
     this list of conditions and the following disclaimer in the documentation
     and/or other materials provided with the distribution.
 
 THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND
 ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
 WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
 DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT HOLDER OR CONTRIBUTORS BE LIABLE FOR
 ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
 (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
 LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON
 ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
 (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
 SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
*********************************************************************************/

#ifndef CSWAT_DEF_WND
#define CSWAT_DEF_WND

//==================================================
// CN[h
//==================================================
#include "DecWnd.h"

bool DecWnd::bClosable = true;

//----------------------------------------
// RXgN^
//----------------------------------------
DecWnd::DecWnd(char* _pcFilePath, char* _pcFileName, char* _pcHintText, PathManagement *_poPathManagement)
{
	// 
	pfnWindowProc = &DecWndProc;
	poPathManagement = _poPathManagement;
	pcFilePath = (char*)malloc(lstrlen((LPCSTR)_pcFilePath) + 1);
	memcpy(pcFilePath, _pcFilePath, lstrlen((LPCSTR)_pcFilePath) + 1);
	pcFileName = (char*)malloc(lstrlen((LPCSTR)_pcFileName) + 1);
	memcpy(pcFileName, _pcFileName, lstrlen((LPCSTR)_pcFileName) + 1);
	pcHintText = (char*)malloc(lstrlen((LPCSTR)_pcHintText) + 1);
	memcpy(pcHintText, _pcHintText, lstrlen((LPCSTR)_pcHintText) + 1);
	pcPassword = (char*)malloc(1);

	bAutoDel = false;
	bOverwrite = false;
	bNotWatch = false;

	// ֐̎s
	RegWndClass();
	CreateDecWnd(STR_SOFTNAME, 500, 230);
	CreateChildWnds();
}

//----------------------------------------
// fXgN^
//----------------------------------------
DecWnd::~DecWnd()
{
	// IuWFNg̉
	delete poLabel01;
	delete poDecFileName;
	delete poLabel02;
	delete poHintText;
	delete poLabel04;
	delete poOriginalFileName;
	delete poShowOFN;
	delete poLabel03;
	delete poPassword;
	delete poAutoDel;
	delete poOverwrite;
	delete poNotWatch;
	delete poOK;
	delete poCancel;
	delete poHelp;
	delete poVerInfo;
	delete poLabel05;
	delete poLabel06;
	delete poLabel07;
	delete poChildWnds;

	// q[v̈̉
	free(pcHintText);
	free(pcFileName);
	free(pcFilePath);
	free(pcPassword);
}

//----------------------------------------
// EBhENX̓o^
//----------------------------------------
void DecWnd::RegWndClass() const
{
	// ϐ̐錾
	WNDCLASSEX wcx;

	// NXf[^̑
	FillMemory(&wcx, sizeof(WNDCLASSEX), 0);
	wcx.cbSize = sizeof(WNDCLASSEX);
	wcx.style = CS_DBLCLKS | CS_HREDRAW | CS_VREDRAW;
	wcx.lpfnWndProc = &TempWindowProc;
	wcx.hInstance = GetModuleHandle(0);
	wcx.hIcon = static_cast<HICON>(LoadImage(wcx.hInstance, MAKEINTRESOURCE(C_SWAT_ICON), IMAGE_ICON, 32, 32, LR_CREATEDIBSECTION));
	wcx.hCursor = LoadCursor(NULL, IDC_ARROW);
	wcx.hbrBackground = hBrush;
	wcx.hIconSm = static_cast<HICON>(LoadImage(wcx.hInstance, MAKEINTRESOURCE(C_SWAT_ICON), IMAGE_ICON, 16, 16, LR_CREATEDIBSECTION));
	wcx.lpszClassName = "C-SWAT_DECWND";

	// EBhENX̓o^
	RegisterClassEx(&wcx);
}

//----------------------------------------
// EBhE쐬
//----------------------------------------
void DecWnd::CreateDecWnd(const char *pcTitle, long nWidth, long nHeight)
{
	hWnd = CreateWindowEx(
		NULL,
		"C-SWAT_DECWND",
		pcTitle,
		WS_OVERLAPPED | WS_CAPTION | WS_SYSMENU | WS_MINIMIZEBOX,
		CW_USEDEFAULT,
		CW_USEDEFAULT,
		nWidth + GetSystemMetrics(SM_CXFIXEDFRAME) * 2,
		nHeight + GetSystemMetrics(SM_CYFIXEDFRAME) * 2 + GetSystemMetrics(SM_CYCAPTION),
		NULL,
		NULL,
		GetModuleHandle(0),
		this
	);
}

//----------------------------------------
// qEBhE쐬
//----------------------------------------
void DecWnd::CreateChildWnds()
{
	// qEBhENXIuWFNg
	poChildWnds = new ChildWnds();

	// qEBhE쐬
	poLabel01 = new Label(hWnd, STR_WND_DEC_DECODING_FILE_NAME, 10, 13, 140, 14, NULL);
	poDecFileName = new Label(hWnd, pcFileName, 150, 13, 370, 14, NULL);
	poLabel02 = new Label(hWnd, STR_WND_DEC_HINT, 10, 38, 80, 14, NULL);
	poLabel05 = new Label(hWnd, STR_WND_COLON, 90, 38, 10, 14, NULL);
	poHintText = new Label(hWnd, pcHintText, 100, 38, 390, 14, NULL);
	poLabel04 = new Label(hWnd, STR_WND_ORIGINAL_FILE_NAME, 10, 63, 80, 14, NULL);
	poLabel06 = new Label(hWnd, STR_WND_COLON, 90, 63, 10, 14, NULL);
	poOriginalFileName = new Label(hWnd, "", 100, 63, 390, 14, NULL);
	poLabel03 = new Label(hWnd, STR_WND_DEC_PASSWORD, 10, 88, 80, 14, NULL);
	poLabel07 = new Label(hWnd, STR_WND_COLON, 90, 88, 10, 14, NULL);
	poPassword = new PassBox(hWnd, 100, 85, 250, 21, ID_WND_DEC_PASSWORD, poChildWnds);
	poShowOFN = new Button(hWnd, STR_WND_SHOW_OFN, 360, 85, 130, 21, ID_WND_DEC_SHOW_OFN, poChildWnds);
	poOverwrite = new CheckBox(hWnd, STR_WND_OVERWRITE, 10, 120, 480, 20, ID_WND_DEC_OVERWRITE, poChildWnds);
	poNotWatch = new CheckBox(hWnd, STR_WND_DEC_NOT_WATCH, 10, 145, 480, 20, ID_WND_DEC_NOT_WATCH, poChildWnds);
	poAutoDel = new CheckBox(hWnd, STR_WND_DEC_AUTO_DELETE, 30, 165, 460, 20, ID_WND_DEC_AUTO_DELETE, poChildWnds);
	poOK = new Button(hWnd, STR_WND_OK, 60, 200, 100, 21, ID_WND_DEC_OK, poChildWnds);
	poCancel = new Button(hWnd, STR_WND_CANCEL, 170, 200, 100, 21, ID_WND_DEC_CANCEL, poChildWnds);
	poHelp = new Button(hWnd, STR_WND_HELP, 280, 200, 100, 21, ID_WND_DEC_HELP, poChildWnds);
	poVerInfo = new Button(hWnd, STR_WND_VERSION_INFO, 390, 200, 100, 21, ID_WND_DEC_VERINFO, poChildWnds);
	poOK->SetDefButton();

	poPassword->AddToolTip(STR_TT_PASSWORD);
	poShowOFN->AddToolTip(STR_TT_SHOW_OFN);
	poOverwrite->AddToolTip(STR_TT_OVERWRITE);
	poNotWatch->AddToolTip(STR_TT_DEC_NOT_WATCH);
	poAutoDel->AddToolTip(STR_TT_DEC_AUTO_DEL);

	int fileNameLen = lstrlen(reinterpret_cast<LPCSTR>(pcFileName));
	if (lstrcmp(reinterpret_cast<LPCSTR>(pcFileName) + fileNameLen - 4, ".csl") == 0) {
		EnableWindow(poLabel04->hWnd, false);
		EnableWindow(poLabel06->hWnd, false);
		EnableWindow(poOriginalFileName->hWnd, false);
		EnableWindow(poShowOFN->hWnd, false);
	}
	
	// tH[JX̃Zbg
	SetFocus(poPassword->hWnd);
}

//----------------------------------------
// CEBhER[obN֐
//----------------------------------------
LRESULT DecWnd::DecWndProc(HWND hWnd, UINT wMsg, WPARAM wParam, LPARAM lParam)
{
	switch(wMsg) {
	case WM_COMMAND:
		switch(wParam & 0xFFFF) {
		case ID_WND_DEC_SHOW_OFN:
			// t@C\{^ꂽƂ
			((DecWnd*)GetProp(hWnd, "ThisPtr"))->ShowOriginalFileName();
			break;

		case ID_WND_DEC_OK:
			// OK{^ꂽƂ
			((DecWnd*)GetProp(hWnd, "ThisPtr"))->SetParams();
			((DecWnd*)GetProp(hWnd, "ThisPtr"))->bOK = true;
			SendMessage(hWnd, WM_CLOSE, 0, 0);
			break;

		case ID_WND_DEC_CANCEL:
			// LZ{^ꂽƂ
			((DecWnd*)GetProp(hWnd, "ThisPtr"))->CloseDecWnd(hWnd);
			break;

		case ID_WND_DEC_HELP:
			// wv{^ꂽƂ
			ShellExecute(NULL, NULL, ((DecWnd*)GetProp(hWnd, "ThisPtr"))->poPathManagement->pcHelpPath, NULL, NULL, SW_SHOW);
			break;

		case ID_WND_DEC_VERINFO:
			// wv{^ꂽƂ
			((DecWnd*)GetProp(hWnd, "ThisPtr"))->CreateVerInfoWnd();
			break;

		case ID_WND_DEC_NOT_WATCH:
			// uĎȂvꂽƂ
			if (SendMessage((HWND__ *)lParam, BM_GETCHECK, 0, 0) == BST_CHECKED) {
				((DecWnd*)GetProp(hWnd, "ThisPtr"))->poChildWnds->ChangeWndStatus(((DecWnd*)GetProp(hWnd, "ThisPtr"))->poAutoDel->hWnd, true);
			}
			else {
				((DecWnd*)GetProp(hWnd, "ThisPtr"))->poChildWnds->ChangeWndStatus(((DecWnd*)GetProp(hWnd, "ThisPtr"))->poAutoDel->hWnd, false);
			}
			break;
		}
		break;

	case WM_CLOSE:
		// {^ꂽƂ
		if (bClosable) DestroyWindow(hWnd);
		break;

	case WM_DESTROY:
		// EBhE̔j
		PostQuitMessage(0);
		break;

	default:
		// ftHg̏
		return DefWindowProc(hWnd, wMsg, wParam, lParam);
	}
	return 0;
}

//----------------------------------------
// Íp[^̐ݒ
//----------------------------------------
void DecWnd::SetParams()
{
	if (SendMessage(poAutoDel->hWnd, BM_GETCHECK, 0, 0) == BST_CHECKED) {
		bAutoDel = true;
	}
	if (SendMessage(poOverwrite->hWnd, BM_GETCHECK, 0, 0) == BST_CHECKED) {
		bOverwrite = true;
	}
	if (SendMessage(poNotWatch->hWnd, BM_GETCHECK, 0, 0) == BST_CHECKED) {
		bNotWatch = true;
	}
	poPassword->GetLatestText();
	pcPassword = (char*)realloc(pcPassword, lstrlen((LPCSTR)poPassword->pcText) + 1);
	lstrcpy((LPSTR)pcPassword, poPassword->pcText);
}

//----------------------------------------
// o[WEBhE֐
//----------------------------------------
void DecWnd::CreateVerInfoWnd()
{
	VerInfoWnd *poVerInfoWnd;

	bClosable = false;
	poVerInfoWnd = new VerInfoWnd();
	delete poVerInfoWnd;
	bClosable = true;
}

//----------------------------------------
// t@C\
//----------------------------------------
void DecWnd::ShowOriginalFileName()
{
	poPassword->GetLatestText();
	pcPassword = (char*)realloc(pcPassword, lstrlen((LPCSTR)poPassword->pcText) + 1);
	lstrcpy((LPSTR)pcPassword, poPassword->pcText);

	CseFile cse_obj;
	unsigned char originalFileName[MAX_PATH + 1];
	originalFileName[0] = 0;
	cse_obj.getOriginalFileName(reinterpret_cast<const unsigned char*>(pcFilePath), originalFileName, reinterpret_cast<const unsigned char*>(pcPassword));
	poOriginalFileName->changeText(reinterpret_cast<const char*>(originalFileName));
}

//----------------------------------------
// I
//----------------------------------------
void DecWnd::CloseDecWnd(HWND hWnd)
{
	poPassword->GetLatestText();
	unsigned char* text = new unsigned char[lstrlen(reinterpret_cast<LPCSTR>(poPassword->pcText)) + 1];
	lstrcpy(reinterpret_cast<LPSTR>(text), poPassword->pcText);
	unsigned char eePass[] = {0x82, 0xE7, 0x82, 0xF1, 0x82, 0xE7, 0x82, 0xF1, 0x82, 0xE9, 0x81, 0x5B, 0x81, 0x99, 0x00};
	unsigned char eeStr[] = {
		0x4F, 0x72, 0x69, 0x6F, 0x73, 0x82, 0xCD, 0x8A, 0xF0, 0x82, 0xB5, 0x82, 0xAD, 0x82,
		0xC8, 0x82, 0xE9, 0x82, 0xC6, 0x82, 0xC2, 0x82, 0xA2, 0x82, 0xE2, 0x82, 0xC1, 0x82,
		0xBF, 0x82, 0xE1, 0x82, 0xA4, 0x82, 0xF1, 0x82, 0xBE, 0x81, 0x99, 0x00
	};
	if (lstrcmp(reinterpret_cast<LPCSTR>(text), reinterpret_cast<LPCSTR>(eePass)) == 0) MessageBox(NULL, reinterpret_cast<LPCSTR>(eeStr), STR_SOFTNAME, MB_OK);
	delete[] text;

	SendMessage(hWnd, WM_CLOSE, 0, 0);
}

#endif
