/*********************************************************************************

 C-SWAT Ver.2.1.2.0 (EBhEpwb_)


 Copyright (c) 2006-2013, Isao MORI (Orios)
 All rights reserved.

 Redistribution and use in source and binary forms, with or without modification,
 are permitted provided that the following conditions are met:
   * Redistributions of source code must retain the above copyright notice, this
     list of conditions and the following disclaimer.
   * Redistributions in binary form must reproduce the above copyright notice,
     this list of conditions and the following disclaimer in the documentation
     and/or other materials provided with the distribution.
 
 THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND
 ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
 WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
 DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT HOLDER OR CONTRIBUTORS BE LIABLE FOR
 ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
 (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
 LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON
 ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
 (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
 SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
*********************************************************************************/

#ifndef DECWND_HEADER
#define DECWND_HEADER

#include "c-swat.h"
#include "PathManagement.h"
#include "VerInfoWnd.h"
#include "CseFile.h"

//==================================================
// 萔̐錾
//==================================================
#define ID_WND_DEC_PASSWORD 0x00002100
#define ID_WND_DEC_AUTO_DELETE 0x00002101
#define ID_WND_DEC_OVERWRITE 0x00002102
#define ID_WND_DEC_NOT_WATCH 0x00002103
#define ID_WND_DEC_OK 0x00002104
#define ID_WND_DEC_CANCEL 0x00002105
#define ID_WND_DEC_HELP 0x00002106
#define ID_WND_DEC_VERINFO 0x2107
#define ID_WND_DEC_SHOW_OFN 0x00002108

//==================================================
// EBhENX
//==================================================
class DecWnd:public Window {
private:
	// ϐ̐錾
	char *pcFilePath;
	char *pcFileName;
	char *pcHintText;
	ChildWnds *poChildWnds;
	Label *poLabel01;
	Label *poDecFileName;
	Label *poLabel02;
	Label *poHintText;
	Label *poLabel03;
	Label *poLabel04;
	Label *poLabel05;
	Label *poLabel06;
	Label *poLabel07;
	Label *poOriginalFileName;
	Button *poShowOFN;
	PassBox *poPassword;
	Button *poOK;
	Button *poCancel;
	Button *poVerInfo;

	static bool bClosable;

	void CreateVerInfoWnd();

	// ֐̐錾
	void RegWndClass() const;
	void CloseDecWnd(HWND hWnd);
	void CreateDecWnd(const char *pcTitle, long nWidth, long nHeight);
	void CreateChildWnds();
	static LRESULT DecWndProc(HWND hWnd, UINT wMsg, WPARAM wParam, LPARAM lParam);
	void SetParams();
	void ShowOriginalFileName();

public:
	// ϐ̐錾
	PathManagement *poPathManagement;
	bool bAutoDel;
	bool bOverwrite;
	bool bNotWatch;
	CheckBox *poAutoDel;
	CheckBox *poOverwrite;
	CheckBox *poNotWatch;
	Button *poHelp;
	char *pcPassword;
	
	// ֐̐錾
	DecWnd(char* _pcFilePath, char* _pcFileName, char* _pcHintText, PathManagement *_poPathManagement);
	~DecWnd();
};

#endif