/*********************************************************************************

 C-SWAT Ver.2.2.0.0 (CEBhE)


 Copyright (c) 2006-2013, Isao MORI (Orios)
 All rights reserved.

 Redistribution and use in source and binary forms, with or without modification,
 are permitted provided that the following conditions are met:
   * Redistributions of source code must retain the above copyright notice, this
     list of conditions and the following disclaimer.
   * Redistributions in binary form must reproduce the above copyright notice,
     this list of conditions and the following disclaimer in the documentation
     and/or other materials provided with the distribution.
 
 THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND
 ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
 WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
 DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT HOLDER OR CONTRIBUTORS BE LIABLE FOR
 ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
 (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
 LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON
 ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
 (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
 SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
*********************************************************************************/

//==================================================
// CN[h
//==================================================
#include "EncWnd.h"

bool EncWnd::bClosable = true;
EncWnd* EncWnd::poThis = NULL;

//----------------------------------------
// RXgN^
//----------------------------------------
EncWnd::EncWnd(CSwatCipher *_poCSwatCipher, PathManagement *_poPathManagement)
{
	// 
	pfnWindowProc = &EncWndProc;
	poCSwatCipher = _poCSwatCipher;
	poPathManagement = _poPathManagement;
	
	// ֐̎s
	RegWndClass();
	CreateEncWnd(STR_SOFTNAME, 500, 550);
	CreateChildWnds();
	CreateFileListMenu();
}

//----------------------------------------
// fXgN^
//----------------------------------------
EncWnd::~EncWnd()
{
	// IuWFNg̉
	delete poPopupMenu;
	delete poVerInfo;
	delete poHelp;
	delete poCancel;
	delete poOK;
	delete poAbsolutePath;
	delete poCslFileName;
	delete poCreateList;
	delete poHint;
	delete poOverwrite;
	delete poChangeName;
	delete poAutoDel;
	delete poConfirmation;
	delete poPassword;
	delete poLabel05;
	delete poLabel04;
	delete poLabel03;
	delete poLabel02;
	delete poLabel01;
	delete poAddFile;
	delete poDeleteFile;
	delete poUpFile;
	delete poDownFile;
	delete poFileList;
	delete poChildWnds;
}

//----------------------------------------
// EBhENX̓o^
//----------------------------------------
void EncWnd::RegWndClass() const
{
	// ϐ̐錾
	WNDCLASSEX wcx;

	// NXf[^̑
	FillMemory(&wcx, sizeof(WNDCLASSEX), 0);
	wcx.cbSize = sizeof(WNDCLASSEX);
	wcx.style = CS_DBLCLKS | CS_HREDRAW | CS_VREDRAW;
	wcx.lpfnWndProc = &TempWindowProc;
	wcx.hInstance = GetModuleHandle(0);
	wcx.hIcon = static_cast<HICON>(LoadImage(wcx.hInstance, MAKEINTRESOURCE(C_SWAT_ICON), IMAGE_ICON, 32, 32, LR_CREATEDIBSECTION));
	wcx.hCursor = LoadCursor(NULL, IDC_ARROW);
	wcx.hbrBackground = hBrush;
	wcx.hIconSm = static_cast<HICON>(LoadImage(wcx.hInstance, MAKEINTRESOURCE(C_SWAT_ICON), IMAGE_ICON, 16, 16, LR_CREATEDIBSECTION));
	wcx.lpszClassName = "C-SWAT_MAINWND";

	// EBhENX̓o^
	RegisterClassEx(&wcx);
}

//----------------------------------------
// CEBhE쐬
//----------------------------------------
void EncWnd::CreateEncWnd(const char *pcTitle, long nWidth, long nHeight)
{
	hWnd = CreateWindowEx(
		NULL,
		"C-SWAT_MAINWND",
		pcTitle,
		WS_OVERLAPPED | WS_CAPTION | WS_SYSMENU | WS_MINIMIZEBOX,
		CW_USEDEFAULT,
		CW_USEDEFAULT,
		nWidth + GetSystemMetrics(SM_CXFIXEDFRAME) * 2,
		nHeight + GetSystemMetrics(SM_CYFIXEDFRAME) * 2 + GetSystemMetrics(SM_CYCAPTION),
		NULL,
		NULL,
		GetModuleHandle(0),
		this
	);
}

//----------------------------------------
// qEBhE쐬
//----------------------------------------
void EncWnd::CreateChildWnds()
{
	// qEBhENXIuWFNg
	poChildWnds = new ChildWnds();

	// qEBhE쐬
	poLabel01 = new Label(hWnd, STR_WND_ENC_ENCODING_FILE_LIST, 10, 13, 480, 14, NULL);

	poFileList = new ListView(hWnd, 10, 30, 480, 200, ID_WND_ENC_FILE_LIST);
	SendMessage(poFileList->hWnd, LVM_SETEXTENDEDLISTVIEWSTYLE, LVS_EX_CHECKBOXES, LVS_EX_CHECKBOXES);
	poFileList->InsertColumn(STR_WND_FILE_NAME, 150);
	poFileList->InsertColumn(STR_WND_FILE_PATH, 330);
	pfnOriginalListWndProc = (WNDPROC)GetWindowLong(poFileList->hWnd, GWL_WNDPROC);
	SetWindowLongPtr(poFileList->hWnd, GWL_WNDPROC, (LONG_PTR)&TempFileListWndProc);
	SetProp(poFileList->hWnd, "ThisPtr", this);
	poFileList->AddToolTip(STR_TT_ENC_FILE_LIST);

	poUpFile = new Button(hWnd, STR_WND_UP_FILE, 60, 240, 100, 21, ID_WND_ENC_UP_FILE, poChildWnds);
	poDownFile = new Button(hWnd, STR_WND_DOWN_FILE, 170, 240, 100, 21, ID_WND_ENC_DOWN_FILE, poChildWnds);
	poDeleteFile = new Button(hWnd, STR_WND_DELETE, 280, 240, 100, 21, ID_WND_ENC_DELETE_FILE, poChildWnds);
	poAddFile = new Button(hWnd, STR_WND_ADD, 390, 240, 100, 21, ID_WND_ENC_ADD_FILE, poChildWnds);
	poUpFile->AddToolTip(STR_TT_UP_FILE);
	poDownFile->AddToolTip(STR_TT_DOWN_FILE);
	poDeleteFile->AddToolTip(STR_TT_DELETE_FILE);
	poAddFile->AddToolTip(STR_TT_ADD_FILE);

	poLabel02 = new Label(hWnd, STR_WND_PASSWORD, 10, 278, 90, 14, NULL);
	poLabel03 = new Label(hWnd, STR_WND_ENC_CONFIRMATION, 10, 303, 90, 14, NULL);
	poLabel04 = new Label(hWnd, STR_WND_HINT, 10, 328, 90, 14, NULL);

	poPassword = new PassBox(hWnd, 100, 275, 390, 20, ID_WND_ENC_PASSWORD, poChildWnds);
	poConfirmation = new PassBox(hWnd, 100, 300, 390, 20, ID_WND_ENC_CONFIRMATION, poChildWnds);
	poHint = new TextBox(hWnd, 100, 325, 390, 20, ID_WND_ENC_HINT, false, poChildWnds);
	poPassword->AddToolTip(STR_TT_PASSWORD);
	poConfirmation->AddToolTip(STR_TT_ENC_CONFIRMATION);
	poHint->AddToolTip(STR_TT_HINT);

	poAutoDel = new CheckBox(hWnd, STR_WND_ENC_AUTO_DELETE, 10, 360, 480, 20, ID_WND_ENC_AUTO_DELETE, poChildWnds);
	poChangeName = new CheckBox(hWnd, STR_WND_ENC_CHANGE_NAME, 10, 385, 480, 20, ID_WND_ENC_CHANGE_NAME, poChildWnds);
	poOverwrite = new CheckBox(hWnd, STR_WND_OVERWRITE, 10, 410, 480, 20, ID_WND_ENC_OVERWRITE, poChildWnds);
	poCreateList = new CheckBox(hWnd, STR_WND_ENC_CREATE_LIST, 10, 435, 480, 20, ID_WND_ENC_CREATE_LIST, poChildWnds);
	poLabel05 = new Label(hWnd, STR_WND_ENC_CSL_FILE_NAME, 30, 463, 110, 20, NULL);
	poCslFileName = new TextBox(hWnd, 140, 460, 350, 20, ID_WND_ENC_LIST_FILE_NAME, false, poChildWnds);
	poAbsolutePath = new CheckBox(hWnd, STR_WND_ENC_ABSOLUTE_PATH, 30, 485, 460, 20, ID_WND_ENC_ABSOLUTE_PATH, poChildWnds);
	poAutoDel->AddToolTip(STR_TT_ENC_AUTO_DEL);
	poChangeName->AddToolTip(STR_TT_ENC_CHANGE_NAME);
	poOverwrite->AddToolTip(STR_TT_OVERWRITE);
	poCreateList->AddToolTip(STR_TT_ENC_CREATE_LIST);
	poCslFileName->AddToolTip(STR_TT_ENC_CSL_FILE_NAME);
	poAbsolutePath->AddToolTip(STR_TT_ENC_ABSOLUTE_PATH);

	poOK = new Button(hWnd, STR_WND_OK, 60, 515, 100, 21, ID_WND_ENC_OK, poChildWnds);
	poCancel = new Button(hWnd, STR_WND_CANCEL, 170, 515, 100, 21, ID_WND_ENC_CANCEL, poChildWnds);
	poHelp = new Button(hWnd, STR_WND_HELP, 280, 515, 100, 21, ID_WND_ENC_HELP, poChildWnds);
	poVerInfo = new Button(hWnd, STR_WND_VERSION_INFO, 390, 515, 100, 21, ID_WND_ENC_VERINFO, poChildWnds);
	poOK->SetDefButton();

	// p[^ݒ
	if (poCSwatCipher->bAutoDel) {
		SendMessage(poAutoDel->hWnd, BM_SETCHECK, BST_CHECKED, 0);
	}
	if (poCSwatCipher->bChangeName) {
		SendMessage(poChangeName->hWnd, BM_SETCHECK, BST_CHECKED, 0);
	}
	if (poCSwatCipher->bOverwrite) {
		SendMessage(poOverwrite->hWnd, BM_SETCHECK, BST_CHECKED, 0);
	}
	if (poCSwatCipher->bCreateList) {
		SendMessage(poCreateList->hWnd, BM_SETCHECK, BST_CHECKED, 0);
	}
	else {
		poChildWnds->ChangeWndStatus(poLabel05->hWnd, false);
		poChildWnds->ChangeWndStatus(poCslFileName->hWnd, false);
		poChildWnds->ChangeWndStatus(poAbsolutePath->hWnd, false);
	}
	if (poCSwatCipher->bAbsolutePath) {
		SendMessage(poAbsolutePath->hWnd, BM_SETCHECK, BST_CHECKED, 0);
	}
	SendMessage(poCslFileName->hWnd, WM_SETTEXT, 0, (LPARAM)poCSwatCipher->pcCslFileName_Config);

	// tH[JX̃Zbg
	SetFocus(poPassword->hWnd);
}

//----------------------------------------
// t@CXgpj[̍쐬
//----------------------------------------
void EncWnd::CreateFileListMenu()
{
	poPopupMenu = new PopupMenu();
	poPopupMenu->InsertItem(STR_MENU_ADD, ID_MENU_ADD);
	poPopupMenu->InsertItem(STR_MENU_DELETE, ID_MENU_DELETE);
	poPopupMenu->InsertItem(STR_MENU_OPEN, ID_MENU_OPEN);
}

//----------------------------------------
// t@CXgR[obN֐
//----------------------------------------
LRESULT CALLBACK EncWnd::TempFileListWndProc(HWND hWnd, UINT wMsg, WPARAM wParam, LPARAM lParam)
{
	poThis = (EncWnd*)GetProp(hWnd, "ThisPtr");
	return poThis->FileListWndProc(hWnd, wMsg, wParam, lParam);
}

//----------------------------------------
// CEBhER[obN֐
//----------------------------------------
LRESULT EncWnd::EncWndProc(HWND hWnd, UINT wMsg, WPARAM wParam, LPARAM lParam)
{
	switch(wMsg) {
	case WM_NOTIFY:
		// t@CXg̗̃o[NbNꂽƂ
		if (wParam == ID_WND_ENC_FILE_LIST) {
			if (((LV_DISPINFO*)lParam)->hdr.code == LVN_COLUMNCLICK) {
				poThis->poFileList->SortItems(((NM_LISTVIEW*)lParam)->iSubItem);
			}
		}
		break;

	case WM_COMMAND:
		switch(wParam & 0xFFFF) {
		// փ{^ꂽƂ
		case ID_WND_ENC_UP_FILE:
			poThis->poFileList->UpSelectedItems();
			break;

		// փ{^ꂽƂ
		case ID_WND_ENC_DOWN_FILE:
			poThis->poFileList->DownSelectedItems();
			break;

		case ID_WND_ENC_ADD_FILE:
		// ǉ{^ꂽƂ
			poThis->AddFile();
			break;

		case ID_WND_ENC_DELETE_FILE:
		// 폜{^ꂽƂ
			poThis->poFileList->DelSelectedItems();
			break;

		case ID_WND_ENC_CREATE_LIST:
			if (SendMessage((HWND__ *)lParam, BM_GETCHECK, 0, 0) == BST_CHECKED) {
				poThis->poChildWnds->ChangeWndStatus(poThis->poLabel05->hWnd, true);
				poThis->poChildWnds->ChangeWndStatus(poThis->poCslFileName->hWnd, true);
				poThis->poChildWnds->ChangeWndStatus(poThis->poAbsolutePath->hWnd, true);
			}
			else {
				poThis->poChildWnds->ChangeWndStatus(poThis->poLabel05->hWnd, false);
				poThis->poChildWnds->ChangeWndStatus(poThis->poCslFileName->hWnd, false);
				poThis->poChildWnds->ChangeWndStatus(poThis->poAbsolutePath->hWnd, false);
			}
			break;

		case ID_WND_ENC_OK:
		// OK{^ꂽƂ
			if (poThis->CheckPass()) {
				poThis->SetParams();
				poThis->bOK = true;
				SendMessage(hWnd, WM_CLOSE, 0, 0);
			}
			break;

		case ID_WND_ENC_CANCEL:
		// LZ{^ꂽƂ
			SendMessage(hWnd, WM_CLOSE, 0, 0);
			break;

		case ID_WND_ENC_HELP:
		// wv{^ꂽƂ
			ShellExecute(NULL, NULL, poThis->poPathManagement->pcHelpPath, NULL, NULL, SW_SHOW);
			break;

		case ID_WND_ENC_VERINFO:
		// wv{^ꂽƂ
			poThis->CreateVerInfoWnd();
			break;
		}
		break;

	case WM_CLOSE:
	// {^ꂽƂ
		if (bClosable) DestroyWindow(hWnd);
		break;

	case WM_DESTROY:
	// EBhE̔j
		PostQuitMessage(0);
		break;

	default:
	// ftHg̏
		return DefWindowProc(hWnd, wMsg, wParam, lParam);
	}
	return 0;
}

//----------------------------------------
// Íp[^̐ݒ
//----------------------------------------
void EncWnd::SetParams()
{
	// ϐ̐錾
	bool* pbOpen;
	int i;

	// Jۂ̃`FbN
	pbOpen = (bool*)malloc((poFileList->nNumOfItems) * sizeof(bool));
	for (i = 0; i < (poFileList->nNumOfItems); i++) {
		if (SendMessage(poFileList->hWnd, LVM_GETITEMSTATE, i, 0xF000) == 0x2000) {
			pbOpen[i] = true;
		}
		else {
			pbOpen[i] = false;
		}
	}
	
	// p[^̐ݒ
	poCSwatCipher->RegFiles(poFileList->pppcText[1], pbOpen, NULL, NULL, poFileList->nNumOfItems);
	if (SendMessage(poAutoDel->hWnd, BM_GETCHECK, 0, 0) == BST_CHECKED) {
		poCSwatCipher->bAutoDel = true;
	}
	else {
		poCSwatCipher->bAutoDel = false;
	}
	if (SendMessage(poChangeName->hWnd, BM_GETCHECK, 0, 0) == BST_CHECKED) {
		poCSwatCipher->bChangeName = true;
	}
	else {
		poCSwatCipher->bChangeName = false;
	}
	if (SendMessage(poOverwrite->hWnd, BM_GETCHECK, 0, 0) == BST_CHECKED) {
		poCSwatCipher->bOverwrite = true;
	}
	else {
		poCSwatCipher->bOverwrite = false;
	}
	if (SendMessage(poCreateList->hWnd, BM_GETCHECK, 0, 0) == BST_CHECKED) {
		poCSwatCipher->bCreateList = true;
	}
	else {
		poCSwatCipher->bCreateList = false;
	}
	poCslFileName->GetLatestText();
	poCSwatCipher->SetCslFileName(poCslFileName->pcText);
	if (SendMessage(poAbsolutePath->hWnd, BM_GETCHECK, 0, 0) == BST_CHECKED) {
		poCSwatCipher->bAbsolutePath = true;
	}
	else {
		poCSwatCipher->bAbsolutePath = false;
	}
	poHint->GetLatestText();
	poCSwatCipher->SetHintText(poHint->pcText);
	poPassword->GetLatestText();
	poCSwatCipher->SetPass(poPassword->pcText);

	// q[v̈̊J
	free(pbOpen);
}

//----------------------------------------
// t@Cǉ֐
//----------------------------------------
void EncWnd::AddFile()
{
	// ϐ̐錾
	OPENFILENAME ofn;

	// el̑
	FillMemory(&ofn, sizeof(OPENFILENAME), 0);
	ofn.lStructSize = sizeof(OPENFILENAME);
	ofn.hwndOwner = hWnd;
	ofn.lpstrFilter = STR_WND_FILE_FILTER_ALL;
	ofn.lpstrFile = (LPTSTR)malloc(MAX_PATH + 1);
	FillMemory(ofn.lpstrFile, MAX_PATH + 1, 0);
	ofn.nMaxFile = MAX_PATH + 1;
	ofn.lpstrFileTitle = (LPTSTR)malloc(MAX_PATH + 1);
	FillMemory(ofn.lpstrFileTitle, MAX_PATH + 1, 0);
	ofn.nMaxFileTitle = MAX_PATH + 1;
	ofn.lpstrTitle = STR_WND_ENC_OPEN_ENCODEING_FILE;
	ofn.Flags = OFN_FILEMUSTEXIST | OFN_HIDEREADONLY | OFN_PATHMUSTEXIST;

	// _CAO̕\
	if (GetOpenFileName(&ofn)) {
		InsertFile(ofn.lpstrFile);
	}

	// q[v̈̉
	free(ofn.lpstrFile);
	free(ofn.lpstrFileTitle);
}

//----------------------------------------
// t@C}֐
//----------------------------------------
void EncWnd::InsertFile(const char* pcFilePath)
{
	// ϐ̐錾
	DWORD dwAttr;
	char* pcSearchFilePath;
	WIN32_FIND_DATA wfd;
	char* pcFoundFilePath;
	HANDLE hFileSearch;
	char** ppcFileData;
	int nFilePathLen;
	int i;

	// t@C̎擾
	dwAttr = GetFileAttributes(pcFilePath);

	if (dwAttr == 0xFFFFFFFF) {
	// 擾Ɏsꍇ
		return;

	}
	else if (((dwAttr & FILE_ATTRIBUTE_DIRECTORY) == FILE_ATTRIBUTE_DIRECTORY)) {
	// ̃pXfBNg̏ꍇ
	
		// p̐
		pcSearchFilePath = (char*)malloc(lstrlen((LPCSTR)pcFilePath) + 3);
		pcSearchFilePath[0] = NULL;
		lstrcpy((LPSTR)pcSearchFilePath, pcFilePath);
		if (pcSearchFilePath[lstrlen((LPCSTR)pcSearchFilePath) - 1] != 0x5C) {
			lstrcat((LPSTR)pcSearchFilePath, "\\*");
		}
		else {
			lstrcat((LPSTR)pcSearchFilePath, "*");
		}

		// ŏ̃t@Č
		FillMemory(&wfd, sizeof(WIN32_FIND_DATA), 0);
		hFileSearch = FindFirstFile(pcSearchFilePath, &wfd);
		if (wfd.cFileName[0] != 0x2E) {
			pcFoundFilePath = (char*)malloc(lstrlen((LPCSTR)pcSearchFilePath) + lstrlen((LPCSTR)wfd.cFileName));
			pcFoundFilePath[0] = NULL;
			lstrcpy((LPSTR)pcFoundFilePath, pcSearchFilePath);
			pcFoundFilePath[lstrlen((LPCSTR)pcFoundFilePath) - 1] = NULL;
			lstrcat((LPSTR)pcFoundFilePath, wfd.cFileName);
			InsertFile(pcFoundFilePath);
			free(pcFoundFilePath);
		}

		// ̃t@Č
		FillMemory(&wfd, sizeof(WIN32_FIND_DATA), 0);
		while (FindNextFile(hFileSearch, &wfd) != 0) {
			if (wfd.cFileName[0] != 0x2E) {
				pcFoundFilePath = (char*)malloc(lstrlen((LPCSTR)pcSearchFilePath) + lstrlen((LPCSTR)wfd.cFileName));
				pcFoundFilePath[0] = NULL;
				lstrcpy((LPSTR)pcFoundFilePath, pcSearchFilePath);
				pcFoundFilePath[lstrlen((LPCSTR)pcFoundFilePath) - 1] = NULL;
				lstrcat((LPSTR)pcFoundFilePath, wfd.cFileName);
				InsertFile(pcFoundFilePath);
				free(pcFoundFilePath);
			}
			FillMemory(&wfd, sizeof(WIN32_FIND_DATA), 0);
		}

		// q[v̈̉
		free(pcSearchFilePath);

	}
	else {
	// ̃pXt@C̏ꍇ

		// q[v̈̊m
		nFilePathLen = lstrlen((LPCSTR)pcFilePath);
		ppcFileData = (char**)malloc(2 * sizeof(char*));
		ppcFileData[0] = (char*)malloc(2);
		ppcFileData[0][1] = ppcFileData[0][0] = NULL;
		ppcFileData[1] = (char*)malloc(nFilePathLen + 1);

		// t@Co^
		FillMemory(ppcFileData[1], nFilePathLen + 1, 0);
		lstrcpy((LPSTR)ppcFileData[1], pcFilePath);
		i = PathManagement::GetDirPathLen((unsigned  char*)ppcFileData[1]);
		ppcFileData[0] = (char*)malloc(nFilePathLen - i + 1);
		FillMemory(ppcFileData[0], nFilePathLen - i + 1, 0);
		lstrcpy((LPSTR)ppcFileData[0], ppcFileData[1] + i);
		poFileList->InsertItem((char**)ppcFileData, false);

		// q[v̈̉
		free(ppcFileData[0]);
		free(ppcFileData[1]);
		free(ppcFileData);
	}
}

//----------------------------------------
// pX[hmF֐
//----------------------------------------
bool EncWnd::CheckPass()
{
	// pX[h̎擾
	poPassword->GetLatestText();
	poConfirmation->GetLatestText();

	if (lstrlen((LPCSTR)poPassword->pcText) == 0) {
	// pX[h͂ĂȂꍇ
		MessageBox(hWnd, STR_MSG_PASSWORD_NULL, STR_SOFTNAME, MB_OK | MB_ICONEXCLAMATION);
		return false;
	}

	if (poFileList->nNumOfItems == 0) {
		MessageBox(hWnd, STR_MSG_FILE_NOT_DROPPED, STR_SOFTNAME, MB_OK | MB_ICONEXCLAMATION);
		return false;
	}

	if (lstrcmp(poPassword->pcText, poConfirmation->pcText) == 0) {
	// pX[hvꍇ
		return true;

	}
	else {
	// pX[hvȂꍇ
		MessageBox(hWnd, STR_MSG_PASSWORD_ERROR, STR_SOFTNAME, MB_OK | MB_ICONEXCLAMATION);
		return false;
	}
}

//----------------------------------------
// t@CXgR[obN֐
//----------------------------------------
LRESULT EncWnd::FileListWndProc(HWND hWnd, UINT wMsg, WPARAM wParam, LPARAM lParam)
{
	switch(wMsg) {
	case WM_DROPFILES:
		// t@Chbvꂽꍇ
		InsertDroppedFiles((HDROP)wParam);
		break;

	case WM_CONTEXTMENU:
		// ENbNꂽꍇ
		TrackPopupMenu(poPopupMenu->hPopupMenu, TPM_LEFTALIGN, (int)(lParam & 0x0000FFFF), (int)((lParam & 0xFFFF0000) >> 16), 0, hWnd, NULL);
		break;

	case WM_COMMAND:
		switch(wParam) {
		case ID_MENU_ADD:
			// ǉIꂽꍇ
			SendMessage(poAddFile->hWnd, BM_CLICK, 0, 0);
			break;

		case ID_MENU_DELETE:
			// 폜Iꂽꍇ
			SendMessage(poDeleteFile->hWnd, BM_CLICK, 0, 0);
			break;

		case ID_MENU_OPEN:
			// JIꂽꍇ
			OpenDoubleClickedFile();
			break;
		}
		break;

	case WM_LBUTTONDBLCLK:
		// _uNbNꂽꍇ
		OpenDoubleClickedFile();
		break;

	case WM_KEYDOWN:
		if (wParam == VK_DELETE) {
		// DELETEL[
			SendMessage(poDeleteFile->hWnd, BM_CLICK, 0, 0);
			break;
		}
		else if ((wParam == VK_UP)) {
		// L[
			SendMessage(poUpFile->hWnd, BM_CLICK, 0, 0);
			break;
		}
		else if ((wParam == VK_DOWN)) {
		// L[
			SendMessage(poDownFile->hWnd, BM_CLICK, 0, 0);
			break;
		}
		else if ((((wParam == 0x41) || (wParam == 0x61)) && (GetKeyState(VK_CONTROL) < 0))) {
		// "Ctrl"+"a"/"A"
			SendMessage(poAddFile->hWnd, BM_CLICK, 0, 0);
			break;
		}
		else if ((wParam == VK_RETURN)) {
		// "Enter"
			OpenDoubleClickedFile();
			break;
		}
		
	default:
	// ftHg̏
		return CallWindowProc(pfnOriginalListWndProc, hWnd, wMsg, wParam, lParam);
	}
	return 0;
}

//----------------------------------------
// hbvt@C}֐
//----------------------------------------
void EncWnd::InsertDroppedFiles(HDROP hDrop)
{
	// ϐ̐錾
	unsigned int unNumberOfDroppedFiles;
	char *pcFilePath;
	int i;

	// hbvt@C̑}
	unNumberOfDroppedFiles = DragQueryFile(hDrop, -1, NULL, 0);
	pcFilePath = (char*)malloc(MAX_PATH + 1);
	for (i = 0; i < unNumberOfDroppedFiles; i++) {
		FillMemory(pcFilePath, MAX_PATH + 1, 0);
		DragQueryFile(hDrop, i, pcFilePath, MAX_PATH);
		InsertFile(pcFilePath);
	}
	DragFinish(hDrop);

	// q[v̈̉
	free(pcFilePath);
}

//----------------------------------------
// _uNbNt@CI[v֐
//----------------------------------------
void EncWnd::OpenDoubleClickedFile()
{
	// ϐ̐錾E
	int nClickedItem = -1;

	// t@ČEI[v
	while (true) {
		nClickedItem = (int)SendMessage(poFileList->hWnd, LVM_GETNEXTITEM, nClickedItem, LVNI_SELECTED);
		if (nClickedItem != -1) {
			ShellExecute(hWnd, "open", poFileList->pppcText[1][nClickedItem], NULL, NULL, SW_SHOW);
		}
		else {
			break;
		}
	}
}

//----------------------------------------
// o[WEBhE֐
//----------------------------------------
void EncWnd::CreateVerInfoWnd()
{
	VerInfoWnd *poVerInfoWnd;

	bClosable = false;
	poVerInfoWnd = new VerInfoWnd();
	delete poVerInfoWnd;
	bClosable = true;
}
