/*********************************************************************************

 C-SWAT Ver.2.2.0.0 (CEBhEpwb_)


 Copyright (c) 2006-2013, Isao MORI (Orios)
 All rights reserved.

 Redistribution and use in source and binary forms, with or without modification,
 are permitted provided that the following conditions are met:
   * Redistributions of source code must retain the above copyright notice, this
     list of conditions and the following disclaimer.
   * Redistributions in binary form must reproduce the above copyright notice,
     this list of conditions and the following disclaimer in the documentation
     and/or other materials provided with the distribution.
 
 THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND
 ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
 WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
 DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT HOLDER OR CONTRIBUTORS BE LIABLE FOR
 ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
 (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
 LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON
 ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
 (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
 SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
*********************************************************************************/

#ifndef ENCWND_HEADER
#define ENCWND_HEADER

#include "c-swat.h"
#include "PathManagement.h"
#include "CSwatCipher.h"
#include "VerInfoWnd.h"

//==================================================
// 萔̐錾
//==================================================
#define ID_WND_ENC_DELETE_FILE 0x00002000
#define ID_WND_ENC_ADD_FILE 0x00002001
#define ID_WND_ENC_PASSWORD 0x00002002
#define ID_WND_ENC_CONFIRMATION 0x00002003
#define ID_WND_ENC_AUTO_DELETE 0x00002004
#define ID_WND_ENC_CHANGE_NAME 0x00002005
#define ID_WND_ENC_HINT 0x00002006
#define ID_WND_ENC_OK 0x00002007
#define ID_WND_ENC_CANCEL 0x00002008
#define ID_WND_ENC_HELP 0x00002009
#define ID_WND_ENC_FILE_LIST 0x0000200A
#define ID_WND_ENC_OVERWRITE 0x0000200B
#define ID_WND_ENC_CREATE_LIST 0x200C
#define ID_WND_ENC_UP_FILE 0x200D
#define ID_WND_ENC_DOWN_FILE 0x200E
#define ID_WND_ENC_LIST_FILE_NAME 0x200F
#define ID_WND_ENC_VERINFO 0x2010
#define ID_WND_ENC_ABSOLUTE_PATH 0x2011

#define ID_MENU_ADD 0x00003000
#define ID_MENU_DELETE 0x00003001
#define ID_MENU_OPEN 0x00003002


//==================================================
// CEBhENX
//==================================================
class EncWnd:public Window {
private:
	// ϐ̐錾
	ChildWnds *poChildWnds;
	ListView *poFileList;
	Button *poUpFile;
	Button *poDownFile;
	Button *poDeleteFile;
	Button *poAddFile;
	Label *poLabel01;
	Label *poLabel02;
	Label *poLabel03;
	Label *poLabel04;
	Label *poLabel05;
	PassBox *poPassword;
	PassBox *poConfirmation;
	TextBox *poHint;
	CheckBox *poAutoDel;
	CheckBox *poChangeName;
	CheckBox *poOverwrite;
	CheckBox *poCreateList;
	TextBox *poCslFileName;
	CheckBox *poAbsolutePath;
	Button *poOK;
	Button *poCancel;
	Button *poHelp;
	Button *poVerInfo;
	PopupMenu* poPopupMenu;

	static bool bClosable;
	static EncWnd* poThis;

	void RegWndClass() const;
	void CreateEncWnd(const char *pcTitle, long nWidth, long nHeight);
	void CreateChildWnds();
	void CreateFileListMenu();
	static LRESULT EncWndProc(HWND hWnd, UINT wMsg, WPARAM wParam, LPARAM lParam);
	LRESULT FileListWndProc(HWND hWnd, UINT wMsg, WPARAM wParam, LPARAM lParam);
	void InsertDroppedFiles(HDROP hDrop);
	void AddFile();
	bool CheckPass();
	void SetParams();
	void OpenDoubleClickedFile();
	void CreateVerInfoWnd();

	
	WNDPROC pfnOriginalListWndProc;
	

public:
	// ϐ̐錾
	CSwatCipher *poCSwatCipher;
	PathManagement *poPathManagement;
	
	// ֐̐錾
	EncWnd(CSwatCipher *_poCSwatCipher, PathManagement *_poPathManagement);
	~EncWnd();

	static LRESULT CALLBACK TempFileListWndProc(HWND hWnd, UINT wMsg, WPARAM wParam, LPARAM lParam);
	void InsertFile(const char* pcFilePath);

};

#endif