/*********************************************************************************
 
 MD5NXpwb_


 Copyright (c) 2005-2013, Isao MORI (Orios)
 All rights reserved.

 Redistribution and use in source and binary forms, with or without modification,
 are permitted provided that the following conditions are met:
   * Redistributions of source code must retain the above copyright notice, this
     list of conditions and the following disclaimer.
   * Redistributions in binary form must reproduce the above copyright notice,
     this list of conditions and the following disclaimer in the documentation
     and/or other materials provided with the distribution.
 
 THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND
 ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
 WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
 DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT HOLDER OR CONTRIBUTORS BE LIABLE FOR
 ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
 (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
 LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON
 ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
 (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
 SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
*********************************************************************************/

#ifndef MD5_HEADER
#define MD5_HEADER

#include <math.h>
#include <windows.h>
#include <stdlib.h>

//==================================================
// MD5NX
//==================================================
class MD5 {
private:
	// ֐̐錾
	unsigned long F(unsigned long X, unsigned long Y, unsigned long Z) const;
	unsigned long G(unsigned long X, unsigned long Y, unsigned long Z) const;
	unsigned long H(unsigned long X, unsigned long Y, unsigned long Z) const;
	unsigned long I(unsigned long X, unsigned long Y, unsigned long Z) const;
	unsigned long ROTATE_LEFT(unsigned long X, short n) const;
	void FF(unsigned long &a, unsigned long b, unsigned long c, unsigned long d, unsigned long Xk, short s, unsigned long Ti) const;
	void GG(unsigned long &a, unsigned long b, unsigned long c, unsigned long d, unsigned long Xk, short s, unsigned long Ti) const;
	void HH(unsigned long &a, unsigned long b, unsigned long c, unsigned long d, unsigned long Xk, short s, unsigned long Ti) const;
	void II(unsigned long &a, unsigned long b, unsigned long c, unsigned long d, unsigned long Xk, short s, unsigned long Ti) const;
	void ConvDecToHex(unsigned long ulDecNum, char *pcHexStr) const;

public:
	// ֐̐錾
	bool ProduceMD5(const char *pcData, DWORD dwNumOfBytes, unsigned long *pulResults) const;
	void FormatMD5(const unsigned long *pulResults, char *pcMD5) const;
};

#endif
