/*********************************************************************************

 C-SWAT Ver.2.2.0.0 (pXǗNX)


 Copyright (c) 2006-2013, Isao MORI (Orios)
 All rights reserved.

 Redistribution and use in source and binary forms, with or without modification,
 are permitted provided that the following conditions are met:
   * Redistributions of source code must retain the above copyright notice, this
     list of conditions and the following disclaimer.
   * Redistributions in binary form must reproduce the above copyright notice,
     this list of conditions and the following disclaimer in the documentation
     and/or other materials provided with the distribution.
 
 THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND
 ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
 WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
 DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT HOLDER OR CONTRIBUTORS BE LIABLE FOR
 ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
 (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
 LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON
 ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
 (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
 SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
*********************************************************************************/

#include "PathManagement.h"

//----------------------------------------
// ȃfBNg擾֐
//----------------------------------------
void PathManagement::GetSelfDir()
{
	// ϐ̐錾
	int nDirPathLen = GetDirPathLen((unsigned char*)pcSelfPath);
	
	// 
	pcSelfDir = (char*)malloc(MAX_PATH + 1);
	FillMemory(pcSelfDir, MAX_PATH + 1, 0);

	// ȃpX̎擾
	memcpy(pcSelfDir, pcSelfPath, nDirPathLen);
}

//----------------------------------------
// RXgN^
//----------------------------------------
PathManagement::PathManagement()
{
	// ȃpX̎擾
	pcSelfPath = (char*)malloc(MAX_PATH + 1);
	FillMemory(pcSelfPath, MAX_PATH + 1, 0);
	GetModuleFileName(NULL, pcSelfPath, MAX_PATH);
	
	// ȃfBNg̎擾
	GetSelfDir();

	// wvpXEݒt@CpX̐ݒ
	pcHelpPath = (char*)malloc(lstrlen((LPCSTR)pcSelfDir) + 9);
	FillMemory(pcHelpPath, lstrlen((LPCSTR)pcSelfDir) + 9, 0);
	lstrcpy((LPSTR)pcHelpPath, pcSelfDir);
	lstrcat((LPSTR)pcHelpPath, "help.chm");

	/* ݒt@CpX̎擾 */
	char appPath_array[MAX_PATH + 1];
	SHGetFolderPath(0, CSIDL_APPDATA, 0, SHGFP_TYPE_CURRENT, appPath_array);
	pcConfigPath = new char[lstrlen(reinterpret_cast<LPSTR>(appPath_array)) + 25];
	lstrcpy(static_cast<LPSTR>(pcConfigPath), reinterpret_cast<LPSTR>(appPath_array));
	lstrcat(static_cast<LPSTR>(pcConfigPath), "\\Orios\\C-SWAT\\config.xml");

	/* st@CpX̎擾 */
	pcCSwatPath = new char[lstrlen(static_cast<LPSTR>(pcSelfDir)) + 11];
	lstrcpy(static_cast<LPSTR>(pcCSwatPath), static_cast<LPSTR>(pcSelfDir));
	lstrcat(static_cast<LPSTR>(pcCSwatPath), "C-SWAT.exe");
}

//----------------------------------------
// fXgN^
//----------------------------------------
PathManagement::~PathManagement()
{
	delete[] pcCSwatPath;
	delete[] pcConfigPath;
	free(pcHelpPath);
	free(pcSelfDir);
	free(pcSelfPath);
}

//----------------------------------------
// fBNgpX̎擾
//----------------------------------------
int PathManagement::GetDirPathLen(const unsigned char* pucFilePath)
{
	// ϐ̐錾
	int nPathLen = lstrlen((LPCSTR)pucFilePath);
	int nBackSlashPos = 0;
	int i;
	
	// fBNg̎擾
	for (i = 0; i < nPathLen; i++) {
		if (pucFilePath[i] == 0x5C) {
			nBackSlashPos = i + 1;
		}
		else if (
			   ((pucFilePath[i] > 0x81) && (pucFilePath[i] < 0x9F))
			||  (pucFilePath[i] > 0xE0)
		) {
			i++;
		}
	}

	// obNXbVʒu̕ԋp
	return nBackSlashPos;
}
