/*********************************************************************************

 C-SWAT Ver.2.2.0.0 (ĈÍEBhE)


 Copyright (c) 2006-2013, Isao MORI (Orios)
 All rights reserved.

 Redistribution and use in source and binary forms, with or without modification,
 are permitted provided that the following conditions are met:
   * Redistributions of source code must retain the above copyright notice, this
     list of conditions and the following disclaimer.
   * Redistributions in binary form must reproduce the above copyright notice,
     this list of conditions and the following disclaimer in the documentation
     and/or other materials provided with the distribution.
 
 THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND
 ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
 WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
 DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT HOLDER OR CONTRIBUTORS BE LIABLE FOR
 ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
 (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
 LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON
 ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
 (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
 SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
*********************************************************************************/

#include "ReEncWnd.h"


//----------------------------------------
// RXgN^
//----------------------------------------
ReEncWnd::ReEncWnd(CSwatCipher *_poCSwatCipher, char* _pcSHA1, PathManagement *_poPathManagement)
{
	// 
	pfnWindowProc = &ReEncWndProc;
	poPathManagement = _poPathManagement;
	poCSwatCipher = _poCSwatCipher;
	pcSHA1 = _pcSHA1;
	bOK = false;

	// ֐̎s
	RegWndClass();
	CreateReEncWnd(STR_SOFTNAME, 500, 320);
	CreateChildWnds();
}

//----------------------------------------
// fXgN^
//----------------------------------------
ReEncWnd::~ReEncWnd()
{
	// IuWFNg̉
	delete poLabel01;
	delete poFileList;
	delete poLabel02;
	delete poPassword;
	delete poLabel03;
	delete poHint;
	delete poOK;
	delete poCancel;
	delete poHelp;
	delete poVerInfo;
	delete poChildWnds;

	// q[v̈̉
}

//----------------------------------------
// EBhENX̓o^
//----------------------------------------
void ReEncWnd::RegWndClass() const
{
	// ϐ̐錾
	WNDCLASSEX wcx;

	// NXf[^̑
	FillMemory(&wcx, sizeof(WNDCLASSEX), 0);
	wcx.cbSize = sizeof(WNDCLASSEX);
	wcx.style = CS_DBLCLKS | CS_HREDRAW | CS_VREDRAW;
	wcx.lpfnWndProc = &TempWindowProc;
	wcx.hInstance = GetModuleHandle(0);
	wcx.hIcon = static_cast<HICON>(LoadImage(wcx.hInstance, MAKEINTRESOURCE(C_SWAT_ICON), IMAGE_ICON, 32, 32, LR_CREATEDIBSECTION));
	wcx.hCursor = LoadCursor(NULL, IDC_ARROW);
	wcx.hbrBackground = hBrush;
	wcx.hIconSm = static_cast<HICON>(LoadImage(wcx.hInstance, MAKEINTRESOURCE(C_SWAT_ICON), IMAGE_ICON, 16, 16, LR_CREATEDIBSECTION));
	wcx.lpszClassName = "C-SWAT_DECWND";

	// EBhENX̓o^
	RegisterClassEx(&wcx);
}

//----------------------------------------
// EBhE쐬
//----------------------------------------
void ReEncWnd::CreateReEncWnd(const char *pcTitle, long nWidth, long nHeight)
{
	hWnd = CreateWindowEx(
		NULL,
		"C-SWAT_DECWND",
		pcTitle,
		WS_OVERLAPPED | WS_CAPTION | WS_SYSMENU | WS_MINIMIZEBOX,
		CW_USEDEFAULT,
		CW_USEDEFAULT,
		nWidth + GetSystemMetrics(SM_CXFIXEDFRAME) * 2,
		nHeight + GetSystemMetrics(SM_CYFIXEDFRAME) * 2 + GetSystemMetrics(SM_CYCAPTION),
		NULL,
		NULL,
		GetModuleHandle(0),
		this
	);
}

//----------------------------------------
// qEBhE쐬
//----------------------------------------
void ReEncWnd::CreateChildWnds()
{
	// qEBhENXIuWFNg
	poChildWnds = new ChildWnds();

	// qEBhE쐬
	poLabel01 = new Label(hWnd, STR_WND_REENC_REENCODING, 10, 10, 480, 35, NULL);
	poFileList = new TextArea(hWnd, 10, 55, 480, 150, ID_WND_REENC_FILELIST, true, poChildWnds);
	poLabel02 = new Label(hWnd, STR_WND_PASSWORD, 10, 223, 70, 14, NULL);
	poPassword = new PassBox(hWnd, 80, 220, 410, 21, ID_WND_REENC_PASSWORD, poChildWnds);
	poLabel03 = new Label(hWnd, STR_WND_HINT, 10, 253, 70, 14, NULL);
	poHint = new TextBox(hWnd, 80, 250, 410, 21, ID_WND_REENC_HINT, false, poChildWnds);
	poOK = new Button(hWnd, STR_WND_OK, 60, 285, 100, 21, ID_WND_REENC_OK, poChildWnds);
	poCancel = new Button(hWnd, STR_WND_CANCEL, 170, 285, 100, 21, ID_WND_REENC_CANCEL, poChildWnds);
	poHelp = new Button(hWnd, STR_WND_HELP, 280, 285, 100, 21, ID_WND_REENC_HELP, poChildWnds);
	poVerInfo = new Button(hWnd, STR_WND_VERSION_INFO, 390, 285, 100, 21, ID_WND_REENC_VERINFO, poChildWnds);
	poOK->SetDefButton();

	// tH[JX̃Zbg
	SetFocus(poPassword->hWnd);
}

//----------------------------------------
// CEBhER[obN֐
//----------------------------------------
LRESULT ReEncWnd::ReEncWndProc(HWND hWnd, UINT wMsg, WPARAM wParam, LPARAM lParam)
{
	switch(wMsg) {
	case WM_COMMAND:
		switch(wParam & 0xFFFF) {
		case ID_WND_REENC_OK:
		// OK{^ꂽƂ
			if (((ReEncWnd*)GetProp(hWnd, "ThisPtr"))->SetParams()) {
				((ReEncWnd*)GetProp(hWnd, "ThisPtr"))->bOK = true;
				SendMessage(hWnd, WM_CLOSE, 0, 0);
			}
			break;

		case ID_WND_REENC_CANCEL:
		// LZ{^ꂽƂ
			SendMessage(hWnd, WM_CLOSE, 0, 0);
			break;

		case ID_WND_REENC_HELP:
		// wv{^ꂽƂ
			ShellExecute(NULL, NULL, ((ReEncWnd*)GetProp(hWnd, "ThisPtr"))->poPathManagement->pcHelpPath, NULL, NULL, SW_SHOW);
			break;

		case ID_WND_REENC_VERINFO:
		// wv{^ꂽƂ
			((ReEncWnd*)GetProp(hWnd, "ThisPtr"))->CreateVerInfoWnd();
			break;

		}
		break;

	case WM_CLOSE:
	// {^ꂽƂ
		DestroyWindow(hWnd);
		break;

	case WM_DESTROY:
	// EBhE̔j
		PostQuitMessage(0);
		break;

	default:
	// ftHg̏
		return DefWindowProc(hWnd, wMsg, wParam, lParam);
	}
	return 0;
}

//----------------------------------------
// Íp[^̐ݒ
//----------------------------------------
bool ReEncWnd::SetParams()
{
	SHA1 sha1_obj;
	char passHashSHA1_le[41]; // Little Endian
	char acInputSHA1[41];
	
	poPassword->GetLatestText();
	poCSwatCipher->SetPass(poPassword->pcText);
	poHint->GetLatestText();
	poCSwatCipher->SetHintText(poHint->pcText);
	for (int i4 = 0; i4 < 40; i4 += 4) {
		passHashSHA1_le[i4    ] = poCSwatCipher->pcPassHash[i4 + 3];
		passHashSHA1_le[i4 + 1] = poCSwatCipher->pcPassHash[i4 + 2];
		passHashSHA1_le[i4 + 2] = poCSwatCipher->pcPassHash[i4 + 1];
		passHashSHA1_le[i4 + 3] = poCSwatCipher->pcPassHash[i4    ];
	}
	sha1_obj.FormatSHA1(reinterpret_cast<unsigned long*>(passHashSHA1_le), acInputSHA1);
	acInputSHA1[40] = NULL;
	if (lstrcmpi(acInputSHA1, pcSHA1) != 0) {
		MessageBox(NULL, STR_MSG_PASSWORD_ERROR, STR_SOFTNAME, MB_ICONEXCLAMATION);
		return false;
	}
	else {
		return true;
	}
}

//----------------------------------------
// o[WEBhE֐
//----------------------------------------
void ReEncWnd::CreateVerInfoWnd()
{
	VerInfoWnd *poVerInfoWnd;

	poVerInfoWnd = new VerInfoWnd();
	delete poVerInfoWnd;
}
