/*********************************************************************************

 C-SWAT Ver.2.2.0.0 (ĈÍEBhEpwb_)


 Copyright (c) 2006-2013, Isao MORI (Orios)
 All rights reserved.

 Redistribution and use in source and binary forms, with or without modification,
 are permitted provided that the following conditions are met:
   * Redistributions of source code must retain the above copyright notice, this
     list of conditions and the following disclaimer.
   * Redistributions in binary form must reproduce the above copyright notice,
     this list of conditions and the following disclaimer in the documentation
     and/or other materials provided with the distribution.
 
 THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND
 ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
 WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
 DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT HOLDER OR CONTRIBUTORS BE LIABLE FOR
 ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
 (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
 LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON
 ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
 (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
 SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
*********************************************************************************/

#ifndef REENCWND_HEADER
#define REENCWND_HEADER

//==================================================
// CN[h
//==================================================
#include "c-swat.h"
#include "PathManagement.h"
#include "CSwatCipher.h"
#include "VerInfoWnd.h"

//==================================================
// 萔̐錾
//==================================================
#define ID_WND_REENC_PASSWORD 0x00002200
#define ID_WND_REENC_OK 0x00002201
#define ID_WND_REENC_CANCEL 0x00002202
#define ID_WND_REENC_HELP 0x00002203
#define ID_WND_REENC_VERINFO 0x00002204
#define ID_WND_REENC_FILELIST 0x00002205
#define ID_WND_REENC_HINT 0x00002206

//==================================================
// EBhENX
//==================================================
class ReEncWnd:public Window {
private:
	// ϐ̐錾
	ChildWnds *poChildWnds;
	Label *poLabel01;
	Label *poLabel02;
	Label *poLabel03;
	PassBox *poPassword;
	TextBox *poHint;
	Button *poOK;
	Button *poCancel;
	Button *poVerInfo;
	char* pcSHA1;

	// ֐̐錾
	void RegWndClass() const;
	void CreateReEncWnd(const char *pcTitle, long nWidth, long nHeight);
	void CreateChildWnds();
	static LRESULT ReEncWndProc(HWND hWnd, UINT wMsg, WPARAM wParam, LPARAM lParam);
	bool SetParams();
	void CreateVerInfoWnd();

public:
	// ϐ̐錾
	PathManagement *poPathManagement;
	CSwatCipher* poCSwatCipher;
	Button *poHelp;
	TextArea *poFileList;
	
	// ֐̐錾
	ReEncWnd(CSwatCipher *_poCSwatCipher, char* _pcMD5, PathManagement *_poPathManagement);
	~ReEncWnd();
};

#endif