/*********************************************************************************

 C-SWAT Ver.2.2.0.0 (o[WEBhE)


 Copyright (c) 2006-2013, Isao MORI (Orios)
 All rights reserved.

 Redistribution and use in source and binary forms, with or without modification,
 are permitted provided that the following conditions are met:
   * Redistributions of source code must retain the above copyright notice, this
     list of conditions and the following disclaimer.
   * Redistributions in binary form must reproduce the above copyright notice,
     this list of conditions and the following disclaimer in the documentation
     and/or other materials provided with the distribution.
 
 THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND
 ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
 WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
 DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT HOLDER OR CONTRIBUTORS BE LIABLE FOR
 ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
 (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
 LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON
 ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
 (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
 SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
*********************************************************************************/

#include "VerInfoWnd.h"

bool VerInfoWnd::bIsRunning = false;

//----------------------------------------
// RXgN^
//----------------------------------------
VerInfoWnd::VerInfoWnd()
{
	// 
	bIsWindowCreated = false;
	if (!bIsRunning) {
		bIsRunning = true;
		pfnWindowProc = &VerInfoWndProc;
	
		// ֐̎s
		RegWndClass();
		CreateVerInfoWnd(STR_WND_VERSION_INFO, 300, 200);
		CreateChildWnds();
		bIsWindowCreated = true;
		Run(SW_SHOW);
	}
}

//----------------------------------------
// fXgN^
//----------------------------------------
VerInfoWnd::~VerInfoWnd()
{
	// IuWFNg̉
	if (bIsWindowCreated) {
		delete poOK;
		delete poHomePage;
		delete poMail;
		delete poVerInfo;
		delete poChildWnds;
	
		// EBhENX̔j
		UnregisterClass("C-SWAT_VERINFOWND", GetModuleHandle(0));
		bIsRunning = false;
	}
}

//----------------------------------------
// EBhENX̓o^
//----------------------------------------
void VerInfoWnd::RegWndClass() const
{
	// ϐ̐錾
	WNDCLASSEX wcx;

	// NXf[^̑
	FillMemory(&wcx, sizeof(WNDCLASSEX), 0);
	wcx.cbSize = sizeof(WNDCLASSEX);
	wcx.style = CS_DBLCLKS | CS_HREDRAW | CS_VREDRAW;
	wcx.lpfnWndProc = &TempWindowProc;
	wcx.hInstance = GetModuleHandle(0);
	wcx.hIcon = static_cast<HICON>(LoadImage(wcx.hInstance, MAKEINTRESOURCE(C_SWAT_ICON), IMAGE_ICON, 32, 32, LR_CREATEDIBSECTION));
	wcx.hCursor = LoadCursor(NULL, IDC_ARROW);
	wcx.hbrBackground = hBrush;
	wcx.hIconSm = static_cast<HICON>(LoadImage(wcx.hInstance, MAKEINTRESOURCE(C_SWAT_ICON), IMAGE_ICON, 16, 16, LR_CREATEDIBSECTION));
	wcx.lpszClassName = "C-SWAT_VERINFOWND";

	// EBhENX̓o^
	RegisterClassEx(&wcx);
}

//----------------------------------------
// EBhE쐬
//----------------------------------------
void VerInfoWnd::CreateVerInfoWnd(const char *pcTitle, long nWidth, long nHeight)
{
	hWnd = CreateWindowEx(
		NULL,
		"C-SWAT_VERINFOWND",
		pcTitle,
		WS_OVERLAPPED | WS_CAPTION | WS_SYSMENU | WS_MINIMIZEBOX,
		CW_USEDEFAULT,
		CW_USEDEFAULT,
		nWidth + GetSystemMetrics(SM_CXFIXEDFRAME) * 2,
		nHeight + GetSystemMetrics(SM_CYFIXEDFRAME) * 2 + GetSystemMetrics(SM_CYCAPTION),
		NULL,
		NULL,
		GetModuleHandle(0),
		this
	);
}

//----------------------------------------
// qEBhE쐬
//----------------------------------------
void VerInfoWnd::CreateChildWnds()
{
	char* apc[2];
	apc[0] = (char*)malloc(100);
	apc[1] = (char*)malloc(100);
	
	// qEBhENXIuWFNg
	poChildWnds = new ChildWnds();

	// qEBhE쐬
	poVerInfo = new ListView(hWnd, 10, 10, 280, 100, NULL);
	SendMessage(poVerInfo->hWnd, LVM_SETEXTENDEDLISTVIEWSTYLE, LVS_EX_GRIDLINES, LVS_EX_GRIDLINES);
	poVerInfo->InsertColumn(STR_WND_VI_ITEM, 80);
	poVerInfo->InsertColumn(STR_WND_VI_VALUE, 190);
	lstrcpy((LPSTR)apc[0], STR_WND_VI_ITEM_NAME);
	lstrcpy((LPSTR)apc[1], STR_SOFTNAME);
	poVerInfo->InsertItem((char**)&apc, false);
	lstrcpy((LPSTR)apc[0], STR_WND_VI_ITEM_VERSION);
	lstrcpy((LPSTR)apc[1], STR_VERSION);
	poVerInfo->InsertItem((char**)&apc, false);
	lstrcpy((LPSTR)apc[0], STR_WND_VI_ITEM_DATE);
	lstrcpy((LPSTR)apc[1], STR_RELEASE_DATE);
	poVerInfo->InsertItem((char**)&apc, false);
	lstrcpy((LPSTR)apc[0], STR_WND_VI_ITEM_AUTHOR);
	lstrcpy((LPSTR)apc[1], STR_AUTHOR);
	poVerInfo->InsertItem((char**)&apc, false);
	poMail = new Button(hWnd, STR_WND_VI_MAIL, 10, 120, 280, 20, ID_WND_VER_MAIL, poChildWnds);
	poHomePage = new Button(hWnd, STR_WND_VI_HOMEPAGE, 10, 140, 280, 20, ID_WND_VER_HOMEPAGE, poChildWnds);
	poOK = new Button(hWnd, STR_WND_OK, 100, 170, 100, 21, ID_WND_VER_OK, poChildWnds);
	poOK->SetDefButton();

	// tH[JX̃Zbg
	SetFocus(poOK->hWnd);
	
	free(apc[0]);
	free(apc[1]);
}

//----------------------------------------
// CEBhER[obN֐
//----------------------------------------
LRESULT VerInfoWnd::VerInfoWndProc(HWND hWnd, UINT wMsg, WPARAM wParam, LPARAM lParam)
{
	switch(wMsg) {
	case WM_COMMAND:
		switch(wParam & 0xFFFF) {
		case ID_WND_VER_OK:
		// OK{^ꂽƂ
			PostMessage(hWnd, WM_CLOSE, 0, 0);
			break;
					
		case ID_WND_VER_MAIL:
			ShellExecute(NULL, "open", STR_MAIL_ADDRESS, NULL, NULL, SW_SHOW);
			break;

		case ID_WND_VER_HOMEPAGE:
			ShellExecute(NULL, "open", STR_HOMEPAGE_ADDRESS, NULL, NULL, SW_SHOW);
			break;
		}
		break;

	case WM_CLOSE:
	// {^ꂽƂ
		DestroyWindow(hWnd);
		break;

	case WM_DESTROY:
	// EBhE̔j
		PostQuitMessage(0);
		break;

	default:
	// ftHg̏
		return DefWindowProc(hWnd, wMsg, wParam, lParam);
	}
	return 0;
}
