/*********************************************************************************

 EBhE֘ANXQ


 Copyright (c) 2006-2013, Isao MORI (Orios)
 All rights reserved.

 Redistribution and use in source and binary forms, with or without modification,
 are permitted provided that the following conditions are met:
   * Redistributions of source code must retain the above copyright notice, this
     list of conditions and the following disclaimer.
   * Redistributions in binary form must reproduce the above copyright notice,
     this list of conditions and the following disclaimer in the documentation
     and/or other materials provided with the distribution.
 
 THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND
 ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
 WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
 DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT HOLDER OR CONTRIBUTORS BE LIABLE FOR
 ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
 (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
 LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON
 ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
 (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
 SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
*********************************************************************************/

#ifndef WINDOWCLASSES_HEADER
#define WINDOWCLASSES_HEADER

//==================================================
// CN[h
//==================================================
#include <windows.h>
#include <commctrl.h>

//==================================================
// 萔̐錾
//==================================================
#define ID_WNDTYPE_BUTTON 0x00000001
#define ID_WNDTYPE_PASSWORD_BOX 0x00000002
#define ID_WNDTYPE_CHECKBOX 0x00000003
#define ID_WNDTYPE_TEXT_BOX 0x00000004
#define ID_WNDTYPE_RADIO 0x00000005
#define ID_WNDTYPE_TEXT_AREA 0x00000006

//==================================================
// EBhE{NX
//==================================================
class WndBase {
public:
	// ϐ̐錾
	HWND hWnd; // EBhEnh
	HFONT hFont; // tHgnh
	HBRUSH hBrush; // uVnh
	HWND hToolTip; // c[`bvnh

	// ֐̐錾
	WndBase(); // RXgN^
	~WndBase(); // fXgN^

	void ChangeWndStyle(DWORD dwNewStyle, bool bAdd) const; // EBhEX^CύX֐
	void AddToolTip(char* pcText);
};

//==================================================
// qEBhEʏNX
//==================================================
class ChildWnds {
private:
	// ϐ̐錾
	int nNumOfChildWnds; // qEBhE
	WNDPROC *ppfnDefProc; // ftHg֐e[u
	HWND *phWnd; // EBhEnhe[u
	DWORD *pdwID; // IDe[u
	int *pnWndType; // EBhE^Cve[u
	bool *pbWndFocusable; // tH[JXۃe[u

	mutable int nWndCode;
	mutable int nNextWndCode;
	mutable bool bIsShiftPushed;

	// ֐̐錾
	LRESULT ChildWndProc(HWND hWnd, UINT wMsg, WPARAM wParam, LPARAM lParam) const; // qEBhEvV[W

public:
	// ϐ̐錾
	HWND hDefButton; // ftHg{^nh

	// ֐̐錾
	ChildWnds(); // RXgN^
	~ChildWnds(); // fXgN^

	void RegisterChildWnd(HWND hWnd, DWORD dwID, int nWndType); // qEBhEo^֐
	void ChangeWndStatus(HWND hWnd, bool bState);

	static LRESULT CALLBACK TempChildWndProc(HWND hWnd, UINT wMsg, WPARAM wParam, LPARAM lParam); // EqEBhER[obN֐

};

//==================================================
// Xgr[NX
//==================================================
class ListView:public WndBase {
private:
	// ϐ̐錾
	int nNumOfColumns; // 
	int nMaxTextLen; // őeLXg
	int* pnOrder; // ȅe[u (0: Ȃ, 1: , 2: ~)

public:
	// ϐ̐錾
	char*** pppcText; // eZ̃eLXge[u
	int nNumOfItems; // ڐ

	// ֐̐錾
	ListView(HWND hParentWnd, int cx, int cy, int nWidth, int nHeight, DWORD dwID); // RXgN^
	~ListView(); // fXgN^

	void InsertColumn(char *pcColumnName, int nWidth); // }֐
	void InsertItem(char **ppcItemElms, bool bState); // ڑ}֐
	void DelSelectedItems(); // Iڍ폜֐
	void ChangeItemData(int nItemNum, char** ppcItems, bool bState); // ڃf[^ύX֐
	void SortItems(int nCriterionColumn); // \[g֐
	void UpSelectedItems(); // Iڏړ֐
	void DownSelectedItems(); // Iډړ֐
	bool getState(int pos); // `FbNԎ擾֐
};

//==================================================
// {^NX
//==================================================
class Button:public WndBase {
private:
	ChildWnds* poChildWnds; // qEBhENXIuWFNg̃AhX

public:
	Button(HWND hParentWnd, char *pcText, int cx, int cy, int nWidth, int nHeight, DWORD dwID, ChildWnds *poParamChildWnds); // RXgN^
	void SetDefButton() const; // ftHg{^ݒ֐
};

//==================================================
// xNX
//==================================================
class Label:public WndBase {
public:
	// ֐̐錾
	Label(HWND hParentWnd, char *pcText, int cx, int cy, int nWidth, int nHeight, DWORD dwID); // RXgN^
	void changeText(const char* pcNewText);
};

//==================================================
// eLXg{bNXNX
//==================================================
class TextBox:public WndBase {
public:
	// ϐ̐錾
	char* pcText; // 

	// ֐̐錾
	TextBox(HWND hParentWnd, int cx, int cy, int nWidth, int nHeight, DWORD dwID, bool bReadOnly, ChildWnds *poChildWnds); // RXgN^
	~TextBox(); // fXgN^

	void GetLatestText(); // ŐV擾֐
};

//==================================================
// eLXgGANX
//==================================================
class TextArea:public WndBase {
public:
	// ϐ̐錾
	char* pcText; // 

	// ֐̐錾
	TextArea(HWND hParentWnd, int cx, int cy, int nWidth, int nHeight, DWORD dwID, bool bReadOnly, ChildWnds *poChildWnds); // RXgN^
	~TextArea(); // fXgN^

	void GetLatestText(); // ŐV擾֐
	void AddText(char *pcText, bool bAddToEnd) const; // ǉ֐

private:
};

//==================================================
// pX[h{bNXNX
//==================================================
class PassBox:public WndBase {
public:
	// ϐ̐錾
	char *pcText; // 

	// ֐̐錾
	PassBox(HWND hParentWnd, int cx, int cy, int nWidth, int nHeight, DWORD dwID, ChildWnds* poChildWnds); // RXgN^
	~PassBox(); // fXgN^

	void GetLatestText(); // ŏI擾֐
};

//==================================================
// `FbN{bNXNX
//==================================================
class CheckBox:public WndBase {
public:
	// ֐̐錾
	CheckBox(HWND hParentWnd, char* pcText, int cx, int cy, int nWidth, int nHeight, DWORD dwID, ChildWnds *poChildWnds); // RXgN^
};

//==================================================
// vOXo[
//==================================================
class ProgressBar:public WndBase {
public:
	// ֐̐錾
	ProgressBar(HWND hParentWnd, int cx, int cy, int nWidth, int nHeight, DWORD dwID, bool bSmooth); // RXgN^
};

//==================================================
// EBhENX
//==================================================
class Window:public WndBase {
private:
	// ֐̐錾
	void Initialize() const; // 

public:
	// ϐ̐錾
	LRESULT (*pfnWindowProc)(HWND, UINT, WPARAM, LPARAM); // R[obN֐̃AhX
	bool bOK; // OK{^ꂽۂ

	// ֐̐錾
	Window(); // RXgN^

	bool Run(int nCmdShow) const; // EBhEs֐

	static LRESULT CALLBACK TempWindowProc(HWND hWnd, UINT wMsg, WPARAM wParam, LPARAM lParam); // R[obN֐
};



#endif