/*********************************************************************************

 EBhE֘ANXQ


 Copyright (c) 2006-2013, Isao MORI (Orios)
 All rights reserved.

 Redistribution and use in source and binary forms, with or without modification,
 are permitted provided that the following conditions are met:
   * Redistributions of source code must retain the above copyright notice, this
     list of conditions and the following disclaimer.
   * Redistributions in binary form must reproduce the above copyright notice,
     this list of conditions and the following disclaimer in the documentation
     and/or other materials provided with the distribution.
 
 THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND
 ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
 WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
 DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT HOLDER OR CONTRIBUTORS BE LIABLE FOR
 ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
 (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
 LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON
 ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
 (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
 SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
*********************************************************************************/

#include "WindowClasses.h"

//----------------------------------------
// RXgN^
//----------------------------------------
WndBase::WndBase()
{
	hFont = CreateFont(-12, 0, 0, 0, FW_NORMAL, 0, 0, 0, SHIFTJIS_CHARSET, OUT_DEFAULT_PRECIS, CLIP_DEFAULT_PRECIS, DRAFT_QUALITY, 32, "");
	hBrush = CreateSolidBrush(GetSysColor(COLOR_3DFACE));
	hToolTip = NULL;
}

//----------------------------------------
// fXgN^
//----------------------------------------
WndBase::~WndBase() { }

//----------------------------------------
//
//  EBhEX^CύX֐
//
//  []
//    (DWORD)dwNewStyle: ύXEǉEBhEX^C
//    (bool)bAdd: [h (true: ǉ, false: ύX)
//
//  [߂l]
//    (void) Ȃ
//----------------------------------------
void WndBase::ChangeWndStyle(DWORD dwNewStyle, bool bAdd) const
{
	// ϐ̐錾
	DWORD dwStyle = 0;

	// EBhEX^C̕ύXEǉ
	if (bAdd) {
		dwStyle = GetWindowLong(hWnd, GWL_STYLE);
	}
	dwStyle |= dwNewStyle;
	SetWindowLong(hWnd, GWL_STYLE, dwStyle);
}


//----------------------------------------
//
//  c[`bv쐬֐
//
//  []
//    (const char*)pcText: c[`bvɕ\镶
//
//  [߂l]
//    (void) Ȃ
//----------------------------------------
void WndBase::AddToolTip(char* pcText)
{	
	TOOLINFO ti;

	hToolTip = CreateWindowEx(NULL, "tooltips_class32", NULL, TTS_ALWAYSTIP, CW_USEDEFAULT, CW_USEDEFAULT, CW_USEDEFAULT, CW_USEDEFAULT, hWnd, NULL, GetModuleHandle(0), NULL);
	GetClientRect(hWnd, &ti.rect);

	ti.cbSize = sizeof (TOOLINFO);
	ti.uFlags = TTF_SUBCLASS;
	ti.hwnd = hWnd;
	ti.lpszText = pcText;
	SendMessage(hToolTip, TTM_ADDTOOL, 0, (LPARAM)&ti);
}



//----------------------------------------
// qEBhER[obN֐
//----------------------------------------
LRESULT ChildWnds::ChildWndProc(HWND hWnd, UINT wMsg, WPARAM wParam, LPARAM lParam) const
{
	// ĂяoEBhE̔
	for (nWndCode = 0; nWndCode < nNumOfChildWnds; nWndCode++) {
		if (phWnd[nWndCode] == hWnd) {
			break;
		}
	}
	if (nWndCode == nNumOfChildWnds) {
		return 0;
	}

	if ((wMsg == WM_CHAR) && (wParam == VK_TAB)) {
	// ^uړ
		if (GetKeyState(VK_SHIFT) < 0) {
			bIsShiftPushed = true;
		}
		else {
			bIsShiftPushed = false;
		}
		nNextWndCode = nWndCode;
		do {
			if (bIsShiftPushed) {
				nNextWndCode--;
			}
			else {
				nNextWndCode++;
			}

			if (nNextWndCode < 0) {
				nNextWndCode = nNumOfChildWnds - 1;
			}
			else if ((nNextWndCode >= nNumOfChildWnds)) {
				nNextWndCode = 0;
			}
		} while(!pbWndFocusable[nNextWndCode]);
		
		SetFocus(phWnd[nNextWndCode]);
	
	}
	else if (((wMsg == WM_CHAR) && (wParam == VK_RETURN) && ((pnWndType[nWndCode] == ID_WNDTYPE_BUTTON) || (pnWndType[nWndCode] == ID_WNDTYPE_CHECKBOX) || (pnWndType[nWndCode] == ID_WNDTYPE_RADIO)))) {
	// EnterL[ɂNbN
		SendMessage(hWnd, BM_CLICK, 0, 0);

	}
	else if (((wMsg == WM_CHAR) && (wParam == VK_RETURN) && (hDefButton != 0))) {
	// EnterL[ɂftHg{^NbN
		SendMessage(hDefButton, BM_CLICK, 0, 0);

	}
	else {
		// ftHg
		return CallWindowProc(ppfnDefProc[nWndCode], hWnd, wMsg, wParam, lParam);
	}

	// ߂l
	return 0;
}

//----------------------------------------
// qEBhEԕύX֐
//----------------------------------------
void ChildWnds::ChangeWndStatus(HWND hWnd, bool bState)
{
	int i;

	EnableWindow(hWnd, bState);

	for (i = 0; i < nNumOfChildWnds; i++) {
		if (phWnd[i] == hWnd) {
			break;
		}
	}
	if (i == nNumOfChildWnds) {
		return;
	}
	if (pnWndType[i] != ID_WNDTYPE_RADIO) {
		pbWndFocusable[i] = bState;
	}
	else {
		pbWndFocusable[i] = bState;
	}
}

//----------------------------------------
// RXgN^
//----------------------------------------
ChildWnds::ChildWnds()
{
	ppfnDefProc = (WNDPROC*)malloc(1);
	phWnd = (HWND*)malloc(1);
	pdwID = (DWORD*)malloc(1);
	pnWndType = (int*)malloc(1);
	pbWndFocusable = (bool*)malloc(1);
	nNumOfChildWnds = 0;
	hDefButton = NULL;
}

//----------------------------------------
// fXgN^
//----------------------------------------
ChildWnds::~ChildWnds()
{
	free(ppfnDefProc);
	free(phWnd);
	free(pdwID);
	free(pnWndType);
	free(pbWndFocusable);
}

//----------------------------------------
//
//  qEBhEo^֐
//
//  []
//    (HWND) hWnd: qEBhẼnh
//    (DWORD) dwID: qEBhEID
//    (int) nWndType: EBhE̎
//----------------------------------------
void ChildWnds::RegisterChildWnd(HWND hWnd, DWORD dwID, int nWndType)
{
	// e[uTCY̕ύX
	nNumOfChildWnds++;
	ppfnDefProc = (WNDPROC*)realloc(ppfnDefProc, nNumOfChildWnds * sizeof(WNDPROC));
	phWnd = (HWND*)realloc(phWnd, nNumOfChildWnds * sizeof(HWND));
	pdwID = (DWORD*)realloc(pdwID, nNumOfChildWnds * sizeof(DWORD));
	pnWndType = (int*)realloc(pnWndType, nNumOfChildWnds * sizeof(int));
	pbWndFocusable = (bool*)realloc(pbWndFocusable, nNumOfChildWnds * sizeof(bool));

	// e퍀ڂ̓o^
	ppfnDefProc[nNumOfChildWnds - 1] = (WNDPROC)GetWindowLong(hWnd, GWL_WNDPROC);
	phWnd[nNumOfChildWnds - 1] = hWnd;
	pdwID[nNumOfChildWnds - 1] = dwID;
	pnWndType[nNumOfChildWnds - 1] = nWndType;
	pbWndFocusable[nNumOfChildWnds - 1] = true;

	// TuNX
	SetWindowLongPtr(hWnd, GWL_WNDPROC, (LONG_PTR)&TempChildWndProc);
	SetProp(hWnd, "ThisPtr", this);
}

//----------------------------------------
// EqEBhER[obN֐
//----------------------------------------
LRESULT CALLBACK ChildWnds::TempChildWndProc(HWND hWnd, UINT wMsg, WPARAM wParam, LPARAM lParam)
{
	return ((ChildWnds*)GetProp(hWnd, "ThisPtr"))->ChildWndProc(hWnd, wMsg, wParam, lParam);
}



//----------------------------------------
//
//  RXgN^
//
//  []
//    (HWND)hParentWnd: eEBhE
//    (int)cx: ōxW
//    (int)cx: ŏyW
//    (int)nWidth: 
//    (int)nHeight: 
//    (DWORD)dwID: EBhEID
//
//  [߂l]
//    Ȃ
//----------------------------------------
ListView::ListView(HWND hParentWnd, int cx, int cy, int nWidth, int nHeight, DWORD dwID)
{
	// ϐ̏
	nNumOfColumns = 0;
	nNumOfItems = 0;
	nMaxTextLen = 0;
	pppcText = (char***)malloc(1);
	pnOrder = (int*)malloc(1);

	// Xgr[쐬
	hWnd = CreateWindowEx(WS_EX_CLIENTEDGE, "SysListView32", "", WS_CHILD | WS_VISIBLE | LVS_REPORT, cx, cy, nWidth, nHeight, hParentWnd, (HMENU)dwID, GetModuleHandle(0), NULL);
	SendMessage(hWnd, WM_SETFONT, (WPARAM)hFont, 0);
	SendMessage(hWnd, LVM_SETEXTENDEDLISTVIEWSTYLE, 0, LVS_EX_FULLROWSELECT);
	DragAcceptFiles(hWnd, 1);
}

//----------------------------------------
// fXgN^
//----------------------------------------
ListView::~ListView()
{
	// ϐ̐錾
	int i;
	int j;

	// q[v̈̉
	for (j = 0; j < nNumOfColumns; j++) {
		for (i = 0; i < nNumOfItems; i++) {
			free(pppcText[j][i]);
		}
		free(pppcText[j]);
	}
	free(pppcText);
	free(pnOrder);
}

//----------------------------------------
//
//  }֐
//
//  []
//    (char*)pcColumnName: 
//    (int)nWidth: 
//
//  [߂l]
//    (void) Ȃ
//----------------------------------------
void ListView::InsertColumn(char *pcColumnName, int nWidth)
{
	// ϐ̐錾
	LVCOLUMN lvcol;

	// 
	FillMemory(&lvcol, sizeof(LVCOLUMN), 0);
	
	// el̑
	lvcol.mask = LVCF_FMT | LVCF_SUBITEM | LVCF_TEXT | LVCF_WIDTH;
	lvcol.fmt = LVCFMT_LEFT;
	lvcol.cx = nWidth;
	lvcol.pszText = pcColumnName;
	lvcol.cchTextMax = lstrlen((LPCSTR)lvcol.pszText) + 1;
	lvcol.iSubItem = nNumOfColumns;

	// ̑}
	SendMessage(hWnd, LVM_INSERTCOLUMN, nNumOfColumns, (LPARAM)&lvcol);

	// ee[ůg
	nNumOfColumns++;
	pppcText = (char***)realloc(pppcText, nNumOfColumns * sizeof(char**));
	pppcText[nNumOfColumns - 1] = (char**)malloc(1);
	pnOrder = (int*)realloc(pnOrder, nNumOfColumns * sizeof(int));
	pnOrder[nNumOfColumns - 1] = 0;
}

//----------------------------------------
//
//  ڑ}֐
//
//  []
//    (char**)pcItemElms: eZ̗vf
//
//  [߂l]
//    (void) Ȃ
//----------------------------------------
void ListView::InsertItem(char **ppcItemElms, bool bState)
{
	// ϐ̐錾
	LVITEM lvItem;
	int i;

	// 
	nNumOfItems++;
	FillMemory(&lvItem, sizeof(LVITEM), 0);
	lvItem.mask = LVIF_TEXT | LVIF_PARAM;
	lvItem.iItem = nNumOfItems - 1;

	for (i = 0; i < nNumOfColumns; i++) {

		// evf̒ǉ
		if (i != 0) {
			lvItem.mask = LVIF_TEXT;
		}
		lvItem.iSubItem = i;
		lvItem.pszText = ppcItemElms[i];
		lvItem.cchTextMax = lstrlen((LPCSTR)lvItem.pszText) + 1;
		if (nMaxTextLen < lvItem.cchTextMax) {
			nMaxTextLen = lvItem.cchTextMax;
		}
		if (i == 0) {
			SendMessage(hWnd, LVM_INSERTITEM, 0, (LPARAM)&lvItem);
		}
		else {
			SendMessage(hWnd, LVM_SETITEM, 0, (LPARAM)&lvItem);
		}

		// ee[ůg
		pppcText[i] = (char**)realloc(pppcText[i], nNumOfItems * sizeof(char*));
		pppcText[i][nNumOfItems - 1] = (char*)malloc(lvItem.cchTextMax);
		memcpy(pppcText[i][nNumOfItems - 1], lvItem.pszText, lvItem.cchTextMax);
		pnOrder[i] = 0;
	}
	
	FillMemory(&lvItem, sizeof(LVITEM), 0);
	lvItem.state = (bState)? 0x2000: 0x1000;
	lvItem.stateMask = 0xF000;
	SendMessage(hWnd, LVM_SETITEMSTATE, nNumOfItems - 1, (LPARAM)&lvItem);
}

//----------------------------------------
//
//  ړeύX֐
//
//  []
//    (int)nItemNum: ڔԍ
//    (char**)pcItemElms: eZ̗vf
//
//  [߂l]
//    (void) Ȃ
//----------------------------------------
void ListView::ChangeItemData(int nItemNum, char **ppcItemElms, bool bState)
{
	// ϐ̐錾
	LVITEM lvItem;
	int i;

	// 
	FillMemory(&lvItem, sizeof(LVITEM), 0);
	lvItem.mask = LVIF_TEXT | LVIF_PARAM;
	lvItem.iItem = nItemNum;

	for (i = 0; i < nNumOfColumns; i++) {

		// evf̕ύX
		if (i != 0) {
			lvItem.mask = LVIF_TEXT;
		}
		lvItem.iSubItem = i;
		lvItem.pszText = ppcItemElms[i];
		lvItem.cchTextMax = lstrlen((LPCSTR)lvItem.pszText) + 1;
		if (nMaxTextLen < lvItem.cchTextMax) {
			nMaxTextLen = lvItem.cchTextMax;
		}
		SendMessage(hWnd, LVM_SETITEM, 0, (LPARAM)&lvItem);

		// ee[u̕ύX
		pppcText[i][nItemNum] = (char*)realloc(pppcText[i][nItemNum], lvItem.cchTextMax);
		memcpy(pppcText[i][nItemNum], lvItem.pszText, lvItem.cchTextMax);
	}
	
	FillMemory(&lvItem, sizeof(LVITEM), 0);
	lvItem.state = (bState)? 0x2000: 0x1000;
	lvItem.stateMask = 0xF000;
	SendMessage(hWnd, LVM_SETITEMSTATE, nItemNum, (LPARAM)&lvItem);
}

//----------------------------------------
//
//  Iڍ폜֐
//
//  []
//    Ȃ
//
//  [߂l]
//    (void) Ȃ
//----------------------------------------
void ListView::DelSelectedItems()
{
	// ϐ̐錾E
	int nSelectedItem = 0;
	int i;
	int j;

	// Iڂ̌
	while (true) {
		nSelectedItem = (int)SendMessage(hWnd, LVM_GETNEXTITEM, nSelectedItem - 1, LVNI_SELECTED);

		if (nSelectedItem != -1) {
		// Iڂꍇ

			// ڂ̍폜
			SendMessage(hWnd, LVM_DELETEITEM, nSelectedItem, 0);

			// ee[u̕ύX
			nNumOfItems--;
			for (j = 0; j < nNumOfColumns; j++) {
				free(pppcText[j][nSelectedItem]);
				for (i = nSelectedItem; i <= nNumOfItems; i++) {
					pppcText[j][i] = pppcText[j][i + 1];
				}
				pppcText[j] = (char**)realloc(pppcText[j], nNumOfItems * sizeof(char*));
			}

		}
		else {
		// IڂȂꍇ

			break;
		}
	}
}

//----------------------------------------
//
//  \[g֐
//
//  []
//    (int)nCriterionColumn: 
//
//  [߂l]
//    (void) Ȃ
//----------------------------------------
void ListView::SortItems(int nCriterionColumn)
{
	// ϐ̐錾
	char*** pppcTempText;
	bool* pbTempState;
	char** ppcItemElms;
	int i;
	int j;
	int k;
	int l;

	// 
	pppcTempText = (char***)malloc(nNumOfColumns * sizeof(char**));
	pbTempState = (bool*)malloc(nNumOfItems * sizeof(bool));
	FillMemory(pbTempState, nNumOfItems * sizeof(bool), 0);
	for (i = 0; i < nNumOfColumns; i++) {
		pppcTempText[i] = (char**)malloc(nNumOfItems * sizeof(char*));
	}

	// rE\[g
	for (i = 0; i < nNumOfItems; i++) {

		// r
		for (j = 0; j < i; j++) {
			if (pnOrder[nCriterionColumn] == 1) {
				if (lstrcmp(pppcText[nCriterionColumn][i], pppcTempText[nCriterionColumn][j]) > 0) {
					break;
				}
			}
			else {
				if (lstrcmp(pppcText[nCriterionColumn][i], pppcTempText[nCriterionColumn][j]) < 0) {
					break;
				}
			}
		}

		// \[g
		for (k = i - 1; k >= j; k--) {
			for (l = 0; l < nNumOfColumns; l++) {
				pppcTempText[l][k + 1] = pppcTempText[l][k];
			}
			pbTempState[k + 1] = pbTempState[k];
		}
		for (l = 0; l < nNumOfColumns; l++) {
			pppcTempText[l][j] = (char*)malloc(lstrlen((LPCSTR)pppcText[l][i]) + 1);
			memcpy(pppcTempText[l][j], pppcText[l][i], lstrlen((LPCSTR)pppcText[l][i]) + 1);
		}
		if (SendMessage(hWnd, LVM_GETITEMSTATE, i, 0xF000) == 0x2000) {
			pbTempState[j] = true;
		}
		else {
			pbTempState[j] = false;
		}
	}

	// ̋L^
	if (pnOrder[nCriterionColumn] == 1) {
		pnOrder[nCriterionColumn] = 2;
	}
	else {
		pnOrder[nCriterionColumn] = 1;
	}
	for (i = 0; i < nNumOfColumns; i++) {
		if (i != nCriterionColumn) {
			pnOrder[i] = 0;
		}
	}
	
	// \[gʂ̔f
	ppcItemElms = (char**)malloc(nNumOfColumns * sizeof(char*));
	for (i = 0; i < nNumOfItems; i++) {
		for (j = 0; j < nNumOfColumns; j++) {
			ppcItemElms[j] = pppcTempText[j][i];
		}
		ChangeItemData(i, ppcItemElms, pbTempState[i]);
	}
	
	// q[v̈̉
	free(ppcItemElms);
	for (i = 0; i < nNumOfColumns; i++) {
		for (j = 0; j < nNumOfItems; j++) {
			free(pppcTempText[i][j]);
		}
		free(pppcTempText[i]);
	}
	free(pppcTempText);
	free(pbTempState);
}

//----------------------------------------
//
//  Iڏړ֐
//
//  []
//    Ȃ
//
//  [߂l]
//    (void) Ȃ
//----------------------------------------
void ListView::UpSelectedItems()
{
	// ϐ̐錾E
	int nSelectedItem;
	char** appcTempText[2];
	bool abTempState[2];
	LVITEM lvItem;
	int nUppestSelectedItem = -1;
	int i;

	appcTempText[0] = (char**)malloc(nNumOfColumns * sizeof(char*));
	appcTempText[1] = (char**)malloc(nNumOfColumns * sizeof(char*));

	// Iڂ̌
	SetFocus(hWnd);
	for (nSelectedItem = 0; nSelectedItem < nNumOfItems; nSelectedItem++) {

		if (SendMessage(hWnd, LVM_GETITEMSTATE, nSelectedItem, 0x0002) == 0x0002) {
		// IĂꍇ
		
			if (nUppestSelectedItem == -1) {
				nUppestSelectedItem = nSelectedItem;
			}
			if (nSelectedItem == 0) {
				break;
			}

			for (i = 0; i < nNumOfColumns; i++) {
				appcTempText[0][i] = (char*)malloc(lstrlen((LPCSTR)pppcText[i][nSelectedItem - 1]) + 1);
				appcTempText[1][i] = (char*)malloc(lstrlen((LPCSTR)pppcText[i][nSelectedItem]) + 1);
				lstrcpy((LPSTR)appcTempText[0][i], pppcText[i][nSelectedItem - 1]);
				lstrcpy((LPSTR)appcTempText[1][i], pppcText[i][nSelectedItem]);
			}
			if (SendMessage(hWnd, LVM_GETITEMSTATE, nSelectedItem - 1, 0xF000) == 0x2000) {
				abTempState[0] = true;
			}
			else {
				abTempState[0] = false;
			}
			if (SendMessage(hWnd, LVM_GETITEMSTATE, nSelectedItem, 0xF000) == 0x2000) {
				abTempState[1] = true;
			}
			else {
				abTempState[1] = false;
			}
			ChangeItemData(nSelectedItem - 1, appcTempText[1], abTempState[1]);
			ChangeItemData(nSelectedItem, appcTempText[0], abTempState[0]);
			for (i = 0; i < nNumOfColumns; i++) {
				free(appcTempText[0][i]);
				free(appcTempText[1][i]);
			}
			lvItem.state = LVIS_SELECTED | LVIS_FOCUSED ;
			lvItem.stateMask = LVIS_SELECTED | LVIS_FOCUSED ;
			SendMessage(hWnd, LVM_SETITEMSTATE, nSelectedItem - 1, (LPARAM)&lvItem);
			lvItem.state = 0;
			SendMessage(hWnd, LVM_SETITEMSTATE, nSelectedItem, (LPARAM)&lvItem);
		}
	}
	
	SendMessage(hWnd, LVM_ENSUREVISIBLE, nUppestSelectedItem - 1, false);
	
	free(appcTempText[0]);
	free(appcTempText[1]);

}

//----------------------------------------
//
//  Iډړ֐
//
//  []
//    Ȃ
//
//  [߂l]
//    (void) Ȃ
//----------------------------------------
void ListView::DownSelectedItems()
{
	// ϐ̐錾E
	int nSelectedItem;
	int nDownestSelectedItem = -1;
	char** appcTempText[2];
	bool abTempState[2];
	LVITEM lvItem;
	int i;

	appcTempText[0] = (char**)malloc(nNumOfColumns * sizeof(char*));
	appcTempText[1] = (char**)malloc(nNumOfColumns * sizeof(char*));

	// Iڂ̌
	SetFocus(hWnd);
	for (nSelectedItem = nNumOfItems - 1; nSelectedItem >= 0; nSelectedItem--) {

		if (SendMessage(hWnd, LVM_GETITEMSTATE, nSelectedItem, 0x0002) == 0x0002) {
		// IĂꍇ
		
			if (nDownestSelectedItem == -1) {
				nDownestSelectedItem = nSelectedItem;
			}
			if (nSelectedItem == nNumOfItems - 1) {
				break;
			}

			for (i = 0; i < nNumOfColumns; i++) {
				appcTempText[0][i] = (char*)malloc(lstrlen((LPCSTR)pppcText[i][nSelectedItem + 1]) + 1);
				appcTempText[1][i] = (char*)malloc(lstrlen((LPCSTR)pppcText[i][nSelectedItem]) + 1);
				lstrcpy((LPSTR)appcTempText[0][i], pppcText[i][nSelectedItem + 1]);
				lstrcpy((LPSTR)appcTempText[1][i], pppcText[i][nSelectedItem]);
			}
			if (SendMessage(hWnd, LVM_GETITEMSTATE, nSelectedItem + 1, 0xF000) == 0x2000) {
				abTempState[0] = true;
			}
			else {
				abTempState[0] = false;
			}
			if (SendMessage(hWnd, LVM_GETITEMSTATE, nSelectedItem, 0xF000) == 0x2000) {
				abTempState[1] = true;
			}
			else {
				abTempState[1] = false;
			}
			ChangeItemData(nSelectedItem + 1, appcTempText[1], abTempState[1]);
			ChangeItemData(nSelectedItem, appcTempText[0], abTempState[0]);
			for (i = 0; i < nNumOfColumns; i++) {
				free(appcTempText[0][i]);
				free(appcTempText[1][i]);
			}
			lvItem.state = LVIS_SELECTED | LVIS_FOCUSED;
			lvItem.stateMask = LVIS_SELECTED | LVIS_FOCUSED ;
			SendMessage(hWnd, LVM_SETITEMSTATE, nSelectedItem + 1, (LPARAM)&lvItem);
			lvItem.state = 0;
			SendMessage(hWnd, LVM_SETITEMSTATE, nSelectedItem, (LPARAM)&lvItem);
		}
	}
	
	SendMessage(hWnd, LVM_ENSUREVISIBLE, nDownestSelectedItem + 1, false);
	
	free(appcTempText[0]);
	free(appcTempText[1]);

}


//----------------------------------------
//
//  `FbNԎ擾֐
//
//  []
//    int pos: Ԃ𒲂ׂڂ̔ԍ
//
//  [߂l]
//    (bool) true: `FbNĂ, false: `FbNĂȂ
//----------------------------------------
bool ListView::getState(int pos)
{
	return SendMessage(hWnd, LVM_GETITEMSTATE, pos, 0xF000) == 0x2000;
}


//----------------------------------------
//
//  RXgN^
//
//  []
//    (HWND)hParentWnd: eEBhE
//    (char*)pcText: \eLXg
//    (int)cx: ōxW
//    (int)cx: ŏyW
//    (int)nWidth: 
//    (int)nHeight: 
//    (DWORD)dwID: EBhEID
//    (ChildWnds*) _poChildWnds: qEBhENXIuWFNg
//
//  [߂l]
//    Ȃ
//----------------------------------------
Button::Button(HWND hParentWnd, char *pcText, int cx, int cy, int nWidth, int nHeight, DWORD dwID, ChildWnds *poParamChildWnds)
{
	// EBhE쐬
	hWnd = CreateWindowEx(NULL, "BUTTON", pcText, WS_CHILD | WS_VISIBLE, cx, cy, nWidth, nHeight, hParentWnd, (HMENU)dwID, GetModuleHandle(0), NULL);
	SendMessage(hWnd, WM_SETFONT, (WPARAM)hFont, 0);

	// qEBhEo^
	poChildWnds = poParamChildWnds;
	if (poChildWnds != NULL) {
		poChildWnds->RegisterChildWnd(hWnd, dwID, ID_WNDTYPE_BUTTON);
	}
}

//----------------------------------------
//
//  ftHg{^ݒ֐
//
//  []
//    Ȃ
//
//  [߂l]
//    (void) Ȃ
//----------------------------------------
void Button::SetDefButton() const
{
	ChangeWndStyle(BS_DEFPUSHBUTTON, true);
	poChildWnds->hDefButton = hWnd;
}



//----------------------------------------
//
//  RXgN^
//
//  []
//    (HWND)hParentWnd: eEBhE
//    (char*)pcText: \eLXg
//    (int)cx: ōxW
//    (int)cx: ŏyW
//    (int)nWidth: 
//    (int)nHeight: 
//    (DWORD)dwID: EBhEID
//
//  [߂l]
//    Ȃ
//----------------------------------------
Label::Label(HWND hParentWnd, char *pcText, int cx, int cy, int nWidth, int nHeight, DWORD dwID)
{
	hWnd = CreateWindowEx(NULL, "STATIC", pcText, WS_CHILD | WS_VISIBLE, cx, cy, nWidth, nHeight, hParentWnd, (HMENU)dwID, GetModuleHandle(0), NULL);
	SendMessage(hWnd, WM_SETFONT, (WPARAM)hFont, 0);
}

//----------------------------------------
// 擾֐
//----------------------------------------
void Label::changeText(const char *pcNewText)
{
	SendMessage(hWnd, WM_SETTEXT, 0, reinterpret_cast<LPARAM>(pcNewText));
}



//----------------------------------------
//
//  RXgN^
//
//  []
//    (HWND)hParentWnd: eEBhE
//    (char*)pcText: \eLXg
//    (int)cx: ōxW
//    (int)cx: ŏyW
//    (int)nWidth: 
//    (int)nHeight: 
//    (DWORD)dwID: EBhEID
//    (ChildWnds*) poChildWnds: qEBhENXIuWFNg
//
//  [߂l]
//    Ȃ
//----------------------------------------
TextBox::TextBox(HWND hParentWnd, int cx, int cy, int nWidth, int nHeight, DWORD dwID, bool bReadOnly, ChildWnds *poChildWnds)
{
	// ϐ̐錾
	DWORD dwStyle;

	// 
	pcText = (char*)malloc(1);

	// EBhEX^C̐ݒ
	dwStyle = WS_CHILD | WS_VISIBLE | ES_AUTOHSCROLL;
	if (bReadOnly) {
		dwStyle |= ES_READONLY;
	}

	// EBhE쐬
	hWnd = CreateWindowEx(WS_EX_CLIENTEDGE, "EDIT", "", dwStyle, cx, cy, nWidth, nHeight, hParentWnd, (HMENU)dwID, GetModuleHandle(0), NULL);
	SendMessage(hWnd, WM_SETFONT, (WPARAM)hFont, 0);

	// qEBhEo^
	if (poChildWnds != NULL) {
		poChildWnds->RegisterChildWnd(hWnd, dwID, ID_WNDTYPE_TEXT_BOX);
	}
}

//----------------------------------------
// fXgN^
//----------------------------------------
TextBox::~TextBox()
{
	free(pcText);
}

//----------------------------------------
//
//  ŐV擾֐
//
//  []
//    Ȃ
//
//  [߂l]
//    Ȃ
//----------------------------------------
void TextBox::GetLatestText()
{
	// ϐ̐錾
	int nStrLen;

	// ̎擾
	nStrLen = (int)SendMessage(hWnd, WM_GETTEXTLENGTH, 0, 0);
	pcText = (char*)realloc(pcText, nStrLen + 1);
	FillMemory(pcText, nStrLen + 1, 0);
	SendMessage(hWnd, WM_GETTEXT, nStrLen + 1, (LPARAM)pcText);
}




//----------------------------------------
//
//  RXgN^
//
//  []
//    (HWND)hParentWnd: eEBhE
//    (char*)pcText: \eLXg
//    (int)cx: ōxW
//    (int)cx: ŏyW
//    (int)nWidth: 
//    (int)nHeight: 
//    (DWORD)dwID: EBhEID
//    (bool)bReadOnly: ǂݎp
//    (ChildWnds*) poChildWnds: qEBhENXIuWFNg
//
//  [߂l]
//    Ȃ
//----------------------------------------
TextArea::TextArea(HWND hParentWnd, int cx, int cy, int nWidth, int nHeight, DWORD dwID, bool bReadOnly, ChildWnds *poChildWnds)
{
	// ϐ̐錾
	DWORD dwStyle;

	// 
	pcText = (char*)malloc(1);

	// EBhEX^C̐ݒ
	dwStyle = WS_CHILD | WS_VISIBLE | WS_HSCROLL | WS_VSCROLL | ES_AUTOHSCROLL | ES_AUTOVSCROLL | ES_MULTILINE | ES_WANTRETURN;
	if (bReadOnly) {
		dwStyle |= ES_READONLY;
	}
		
	// EBhE̍쐬
	hWnd = CreateWindowEx(WS_EX_CLIENTEDGE, "EDIT", "", dwStyle, cx, cy, nWidth, nHeight, hParentWnd, (HMENU)dwID, GetModuleHandle(0), NULL);
	SendMessage(hWnd, WM_SETFONT, (WPARAM)hFont, 0);

	// qEBhEo^
	if (poChildWnds != NULL) {
		poChildWnds->RegisterChildWnd(hWnd, dwID, ID_WNDTYPE_TEXT_AREA);
	}
}

//----------------------------------------
// fXgN^
//----------------------------------------
TextArea::~TextArea()
{
	free(pcText);
}

//----------------------------------------
//
//  ŐV擾֐
//
//  []
//    Ȃ
//
//  [߂l]
//    Ȃ
//----------------------------------------
void TextArea::GetLatestText()
{
	// ϐ̐錾
	int nStrLen;

	// ̎擾
	nStrLen = (int)SendMessage(hWnd, WM_GETTEXTLENGTH, 0, 0);
	pcText = (char*)realloc(pcText, nStrLen + 1);
	FillMemory(pcText, nStrLen + 1, 0);
	SendMessage(hWnd, WM_GETTEXT, nStrLen + 1, (LPARAM)pcText);
}

//----------------------------------------
//
//  ǉ֐
//
//  []
//    (char*)pcText: ǉ
//    (bool)bAddToEnd: ǉꏊ(true: , false: Iʒu)
//
//  [߂l]
//    Ȃ
//----------------------------------------
void TextArea::AddText(char *pcText, bool bAddToEnd) const
{
	// ϐ̐錾
	int nStrLen;
	
	// ̒ǉ
	if (bAddToEnd) {
		nStrLen = (int)SendMessage(hWnd, WM_GETTEXTLENGTH, 0, 0);
		SendMessage(hWnd, EM_SETSEL, nStrLen, nStrLen);
	}
	SendMessage(hWnd, EM_REPLACESEL, true, (LPARAM)pcText);
}




//----------------------------------------
//
//  RXgN^
//
//  []
//    (HWND)hParentWnd: eEBhE
//    (char*)pcText: \eLXg
//    (int)cx: ōxW
//    (int)cx: ŏyW
//    (int)nWidth: 
//    (int)nHeight: 
//    (DWORD)dwID: EBhEID
//    (ChildWnds*) poChildWnds: qEBhENXIuWFNg
//
//  [߂l]
//    Ȃ
//----------------------------------------
PassBox::PassBox(HWND hParentWnd, int cx, int cy, int nWidth, int nHeight, DWORD dwID, ChildWnds *poChildWnds)
{
	// 
	pcText = (char*)malloc(1);

	// EBhE쐬
	hWnd = CreateWindowEx(WS_EX_CLIENTEDGE, "EDIT", "", WS_CHILD | WS_VISIBLE | ES_PASSWORD | ES_AUTOHSCROLL, cx, cy, nWidth, nHeight, hParentWnd, (HMENU)dwID, GetModuleHandle(0), NULL);
	SendMessage(hWnd, WM_SETFONT, (WPARAM)hFont, 0);

	// qEBhEo^
	if (poChildWnds != NULL) {
		poChildWnds->RegisterChildWnd(hWnd, dwID, ID_WNDTYPE_PASSWORD_BOX);
	}

}

//----------------------------------------
// fXgN^
//----------------------------------------
PassBox::~PassBox()
{
	free(pcText);
}

//----------------------------------------
//
//  ŐV擾֐
//
//  []
//    Ȃ
//
//  [߂l]
//    Ȃ
//----------------------------------------
void PassBox::GetLatestText()
{
	// ϐ錾
	int nStrLen;

	// 擾
	nStrLen = (int)SendMessage(hWnd, WM_GETTEXTLENGTH, 0, 0);
	pcText = (char*)realloc(pcText, nStrLen + 1);
	FillMemory(pcText, nStrLen + 1, 0);
	SendMessage(hWnd, WM_GETTEXT, nStrLen + 1, (LPARAM)pcText);
}




//----------------------------------------
//
//  RXgN^
//
//  []
//    (HWND)hParentWnd: eEBhE
//    (char*)pcText: \eLXg
//    (int)cx: ōxW
//    (int)cx: ŏyW
//    (int)nWidth: 
//    (int)nHeight: 
//    (DWORD)dwID: EBhEID
//    (ChildWnds*) poChildWnds: qEBhENXIuWFNg
//
//  [߂l]
//    Ȃ
//----------------------------------------
CheckBox::CheckBox(HWND hParentWnd, char *pcText, int cx, int cy, int nWidth, int nHeight, DWORD dwID, ChildWnds *poChildWnds)
{
	// EBhE쐬
	hWnd = CreateWindowEx(NULL, "BUTTON", pcText, WS_CHILD | WS_VISIBLE | BS_AUTOCHECKBOX | BS_MULTILINE, cx, cy, nWidth, nHeight, hParentWnd, (HMENU)dwID, GetModuleHandle(0), NULL);
	SendMessage(hWnd, WM_SETFONT, (WPARAM)hFont, 0);

	// qEBhEo^
	if (poChildWnds != NULL) {
		poChildWnds->RegisterChildWnd(hWnd, dwID, ID_WNDTYPE_CHECKBOX);
	}
}




//----------------------------------------
//
//  RXgN^
//
//  []
//    (HWND)hParentWnd: eEBhE
//    (char*)pcText: \eLXg
//    (int)cx: ōxW
//    (int)cx: ŏyW
//    (int)nWidth: 
//    (int)nHeight: 
//    (DWORD)dwID: EBhEID
//    (ChildWnds*) poChildWnds: qEBhENXIuWFNg
//
//  [߂l]
//    Ȃ
//----------------------------------------
ProgressBar::ProgressBar(HWND hParentWnd, int cx, int cy, int nWidth, int nHeight, DWORD dwID, bool bSmooth)
{
	// ϐ̐錾
	DWORD dwStyle;

	// EBhEX^C̐ݒ
	dwStyle = WS_CHILD | WS_VISIBLE;
	if (bSmooth) {
		dwStyle |= PBS_SMOOTH;
	}
		
	// EBhE̍쐬
	hWnd = CreateWindowEx(NULL, "msctls_progress32", "", dwStyle, cx, cy, nWidth, nHeight, hParentWnd, (HMENU)dwID, GetModuleHandle(0), NULL);
}




//----------------------------------------
// RXgN^
//----------------------------------------
Window::Window()
{
	bOK = false;
	Initialize();
}

//----------------------------------------
// Rg[̏
//----------------------------------------
void Window::Initialize() const
{
	// ϐ̐錾
	INITCOMMONCONTROLSEX iccex;

	// Rg[̏
	FillMemory(&iccex, sizeof(INITCOMMONCONTROLSEX), 0);
	iccex.dwICC = ICC_WIN95_CLASSES;
	iccex.dwSize = sizeof(INITCOMMONCONTROLSEX);
	InitCommonControlsEx(&iccex);
}

//----------------------------------------
// R[obN֐
//----------------------------------------
LRESULT CALLBACK Window::TempWindowProc(HWND hWnd, UINT wMsg, WPARAM wParam, LPARAM lParam)
{
	if (GetProp(hWnd, "ThisPtr") != 0) {
		return ((Window*)GetProp(hWnd, "ThisPtr"))->pfnWindowProc(hWnd, wMsg, wParam, lParam);
	}
	else {
		if (wMsg == WM_CREATE) {
			SetProp(hWnd, "ThisPtr", ((CREATESTRUCT*)lParam)->lpCreateParams);
			SendMessage(hWnd, wMsg, wParam, lParam);
			return 0;
		}
		return DefWindowProc(hWnd, wMsg, wParam, lParam);
	}
}

//----------------------------------------
// EBhEs֐
//----------------------------------------
bool Window::Run(int nCmdShow) const
{
	// ϐ̐錾
	MSG msg;

	// EBhE̕\
	ShowWindow(hWnd, nCmdShow);

	// bZ[W[v
	while (GetMessage(&msg, 0, 0, 0) > 0) {
		TranslateMessage(&msg);
		DispatchMessage(&msg);
	}
	
	// ߂l
	return bOK;
}
