/*********************************************************************************
 
 BadRijndaelNXpwb_


 Copyright (c) 2005, Isao MORI (Orios)
 All rights reserved.

 Redistribution and use in source and binary forms, with or without modification,
 are permitted provided that the following conditions are met:
   * Redistributions of source code must retain the above copyright notice, this
     list of conditions and the following disclaimer.
   * Redistributions in binary form must reproduce the above copyright notice,
     this list of conditions and the following disclaimer in the documentation
     and/or other materials provided with the distribution.
 
 THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND
 ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
 WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
 DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT HOLDER OR CONTRIBUTORS BE LIABLE FOR
 ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
 (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
 LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON
 ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
 (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
 SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
*********************************************************************************/

#ifndef BAD_RIJNDAEL_HEADER
#define BAD_RIJNDAEL_HEADER

//==================================================
// CN[h
//==================================================
#include <math.h>
#include <windows.h>
#include <stdlib.h>
#include "cipher.h"

//==================================================
// BadRijndaelNX
//==================================================
class BadRijndael: public Cipher {
private:

	// ϐ錾
	static const unsigned char ucSBox[256]; // SBoxe[u
	static const unsigned char ucInvSBox[256]; // tSBoxe[u
	unsigned long ulTBox[4][256]; // TBoxe[u0
	unsigned long ulInvTBox[4][256]; // tTBoxe[u
	short Nb, Nk, Nr; // () ubNEEEh
	short Nb2, Nb3; // () ubN2{, 3{
	short sBytesOfBlock; // ubN(oCgP)
	short sBytesOfKey; // (oCgP)
	char *pcShift; // Vtgʒue[u
	char *pcInvShift; // tVtgʒue[u
	unsigned char* apucTempBlock[2]; // ꎞƗp̈
	unsigned char* pucExpandedKey; // gp̈

	mutable unsigned long ulTemp; // EhϊŎgp4oCgꎞϐ
	mutable short k; // EhϊŎgp郋[vpꎞϐ

	UINT wMsgToSend; // bZ[WR[h
	HWND hWndToSend; // bZ[WM

	// ֐錾
	unsigned char GF8_Multi(unsigned char ucNumber, short sTimes) const; // GF8ł̏Z֐
	unsigned long SubLong(unsigned long ulNumber) const; // 4oCgϐSBoxϊ
	unsigned long RotBytes(unsigned long ulNumber) const; // 4oCgϐ1oCgVtg
	void ProduceTBox(); // TBoxEtTBox̐
	bool SetParameters(short sBlockLen, short sKeyLen); // Í̃p[^ݒ
	bool KeyExpansion(const char* pcKey, unsigned char* pucExpandedKey) const; // g֐
	void Round(unsigned char* pucEncBlockData, unsigned char* pucTempBlock, const unsigned char* pucRoundKey, bool bFinal) const; // Eh֐
	void InvRound(unsigned char* pucDecBlockData, unsigned char* pucTempBlock, const unsigned char* pucRoundKey, bool bFinal) const; // tEh֐
	
public:

	// ֐錾
	BadRijndael();
	~BadRijndael();
	unsigned __int64 GetNeededBufSize(unsigned __int64 dwNumOfBytes) const; // obt@TCY擾֐
	bool Encrypt(const unsigned char* pucData, DWORD dwNumOfBytes, const char* pcEncKey, unsigned char* pucEncData, unsigned char* pucVector); // Í֐
	bool Decrypt(const unsigned char* pucData, DWORD dwNumOfBytes, const char* pcDecKey, unsigned char* pucDecData, unsigned char* pucInitVector); // ֐
	void RegWndToSendMsg(HWND hWnd, UINT wMsg); // bZ[WMEBhEo^֐
};

#endif
