/*********************************************************************************

 t@CXg쐬vO Ver.1.2.0.2


 Copyright (c) 2006-2013, Isao MORI (Orios)
 All rights reserved.

 Redistribution and use in source and binary forms, with or without modification,
 are permitted provided that the following conditions are met:
   * Redistributions of source code must retain the above copyright notice, this
     list of conditions and the following disclaimer.
   * Redistributions in binary form must reproduce the above copyright notice,
     this list of conditions and the following disclaimer in the documentation
     and/or other materials provided with the distribution.
 
 THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND
 ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
 WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
 DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT HOLDER OR CONTRIBUTORS BE LIABLE FOR
 ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
 (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
 LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON
 ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
 (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
 SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
*********************************************************************************/

//==================================================
// CN[h
//==================================================
#include "c-swat.h"
#include "CseFile.h"
#include "PathManagement.h"


//==================================================
// 萔̐錾
//==================================================
#define ID_WND_DFLM_DELETE_FILE 0x00002000
#define ID_WND_DFLM_ADD_FILE 0x00002001
#define ID_WND_DFLM_HINT 0x00002006
#define ID_WND_DFLM_OK 0x00002007
#define ID_WND_DFLM_CANCEL 0x00002008
#define ID_WND_DFLM_HELP 0x00002009
#define ID_WND_DFLM_FILE_LIST 0x0000200A
#define ID_WND_DFLM_UP_FILE 0x200D
#define ID_WND_DFLM_DOWN_FILE 0x200E
#define ID_WND_DFLM_LIST_FILE_NAME 0x200F
#define ID_WND_DFLM_VERINFO 0x2010
#define ID_WND_DFLM_ABSOLUTE_PATH 0x2011
#define ID_WND_DFLM_REFERENCE 0x2012
#define ID_WND_DFLM_PASSWORD 0x2013
#define ID_WND_DFLM_SHOW_OFN 0x2014

#define ID_WND_DFLM_VER_OK 0x00002200
#define ID_WND_DFLM_VER_MAIL 0x00002201
#define ID_WND_DFLM_VER_HOMEPAGE 0x00002202

#define ID_MENU_DFLM_ADD 0x00003000
#define ID_MENU_DFLM_DELETE 0x00003001
#define ID_MENU_DFLM_OPEN 0x00003002


//==================================================
// EBhENX
//==================================================
class DFLMVerInfoWnd:public Window
{
private:
	// ϐ̐錾
	ChildWnds *poChildWnds;
	ListView *poVerInfo;
	Button *poMail;
	Button *poHomePage;
	Button *poOK;
	static bool bIsRunning;
	bool bIsWindowCreated;


	// ֐̐錾
	void RegWndClass() const;
	void CreateDFLMVerInfoWnd(const char *pcTitle, long nWidth, long nHeight);
	void CreateChildWnds();
	static LRESULT DFLMVerInfoWndProc(HWND hWnd, UINT wMsg, WPARAM wParam, LPARAM lParam);

public:
	// ֐̐錾
	DFLMVerInfoWnd();
	~DFLMVerInfoWnd();
};

bool DFLMVerInfoWnd::bIsRunning = false;

//----------------------------------------
// RXgN^
//----------------------------------------
DFLMVerInfoWnd::DFLMVerInfoWnd()
{
	bIsWindowCreated = false;

	if (!bIsRunning) {
		// 
		bIsRunning = true;
		pfnWindowProc = &DFLMVerInfoWndProc;
	
		// ֐̎s
		RegWndClass();
		CreateDFLMVerInfoWnd(STR_WND_VERSION_INFO, 300, 200);
		CreateChildWnds();
		bIsWindowCreated = true;
		Run(SW_SHOW);
	}
}

//----------------------------------------
// fXgN^
//----------------------------------------
DFLMVerInfoWnd::~DFLMVerInfoWnd()
{
	if (bIsWindowCreated) {
		// IuWFNg̉
		delete poOK;
		delete poHomePage;
		delete poMail;
		delete poVerInfo;
		delete poChildWnds;
	
		// EBhENX̔j
		UnregisterClass("DFLM_VERINFOWND", GetModuleHandle(0));

		bIsRunning = false;
	}
}

//----------------------------------------
// EBhENX̓o^
//----------------------------------------
void DFLMVerInfoWnd::RegWndClass() const
{
	// ϐ̐錾
	WNDCLASSEX wcx;

	// NXf[^̑
	FillMemory(&wcx, sizeof(WNDCLASSEX), 0);
	wcx.cbSize = sizeof(WNDCLASSEX);
	wcx.style = CS_DBLCLKS | CS_HREDRAW | CS_VREDRAW;
	wcx.lpfnWndProc = &TempWindowProc;
	wcx.hInstance = GetModuleHandle(0);
	wcx.hIcon = static_cast<HICON>(LoadImage(wcx.hInstance, MAKEINTRESOURCE(C_SWAT_DFLM_ICON), IMAGE_ICON, 32, 32, LR_CREATEDIBSECTION));
	wcx.hCursor = LoadCursor(NULL, IDC_ARROW);
	wcx.hbrBackground = hBrush;
	wcx.hIconSm = static_cast<HICON>(LoadImage(wcx.hInstance, MAKEINTRESOURCE(C_SWAT_DFLM_ICON), IMAGE_ICON, 16, 16, LR_CREATEDIBSECTION));
	wcx.lpszClassName = "DFLM_VERINFOWND";

	// EBhENX̓o^
	RegisterClassEx(&wcx);
}

//----------------------------------------
// EBhE쐬
//----------------------------------------
void DFLMVerInfoWnd::CreateDFLMVerInfoWnd(const char *pcTitle, long nWidth, long nHeight)
{
	hWnd = CreateWindowEx(
		NULL,
		"DFLM_VERINFOWND",
		pcTitle,
		WS_OVERLAPPED | WS_CAPTION | WS_SYSMENU | WS_MINIMIZEBOX,
		CW_USEDEFAULT,
		CW_USEDEFAULT,
		nWidth + GetSystemMetrics(SM_CXFIXEDFRAME) * 2,
		nHeight + GetSystemMetrics(SM_CYFIXEDFRAME) * 2 + GetSystemMetrics(SM_CYCAPTION),
		NULL,
		NULL,
		GetModuleHandle(0),
		this
	);
}

//----------------------------------------
// qEBhE쐬
//----------------------------------------
void DFLMVerInfoWnd::CreateChildWnds()
{
	char* apc[2];
	apc[0] = (char*)malloc(100);
	apc[1] = (char*)malloc(100);
	
	// qEBhENXIuWFNg
	poChildWnds = new ChildWnds();

	// qEBhE쐬
	poVerInfo = new ListView(hWnd, 10, 10, 280, 100, NULL);
	SendMessage(poVerInfo->hWnd, LVM_SETEXTENDEDLISTVIEWSTYLE, LVS_EX_GRIDLINES, LVS_EX_GRIDLINES);
	poVerInfo->InsertColumn(STR_WND_VI_ITEM, 80);
	poVerInfo->InsertColumn(STR_WND_VI_VALUE, 190);
	lstrcpy((LPSTR)apc[0], STR_WND_VI_ITEM_NAME);
	lstrcpy((LPSTR)apc[1], STR_DFLM_SOFTNAME);
	poVerInfo->InsertItem((char**)&apc, false);
	lstrcpy((LPSTR)apc[0], STR_WND_VI_ITEM_VERSION);
	lstrcpy((LPSTR)apc[1], STR_DFLM_VERSION);
	poVerInfo->InsertItem((char**)&apc, false);
	lstrcpy((LPSTR)apc[0], STR_WND_VI_ITEM_DATE);
	lstrcpy((LPSTR)apc[1], STR_RELEASE_DATE);
	poVerInfo->InsertItem((char**)&apc, false);
	lstrcpy((LPSTR)apc[0], STR_WND_VI_ITEM_AUTHOR);
	lstrcpy((LPSTR)apc[1], STR_AUTHOR);
	poVerInfo->InsertItem((char**)&apc, false);
	poMail = new Button(hWnd, STR_WND_VI_MAIL, 10, 120, 280, 20, ID_WND_DFLM_VER_MAIL, poChildWnds);
	poHomePage = new Button(hWnd, STR_WND_VI_HOMEPAGE, 10, 140, 280, 20, ID_WND_DFLM_VER_HOMEPAGE, poChildWnds);
	poOK = new Button(hWnd, STR_WND_OK, 100, 170, 100, 21, ID_WND_DFLM_VER_OK, poChildWnds);
	poOK->SetDefButton();

	// tH[JX̃Zbg
	SetFocus(poOK->hWnd);
	
	free(apc[0]);
	free(apc[1]);
}

//----------------------------------------
// CEBhER[obN֐
//----------------------------------------
LRESULT DFLMVerInfoWnd::DFLMVerInfoWndProc(HWND hWnd, UINT wMsg, WPARAM wParam, LPARAM lParam)
{
	switch(wMsg) {
	case WM_COMMAND:
		switch(wParam & 0xFFFF) {
		case ID_WND_DFLM_VER_OK:
		// OK{^ꂽƂ
			PostMessage(hWnd, WM_CLOSE, 0, 0);
			break;
					
		case ID_WND_DFLM_VER_MAIL:
			ShellExecute(NULL, NULL, STR_MAIL_ADDRESS, NULL, NULL, SW_SHOW);
			break;

		case ID_WND_DFLM_VER_HOMEPAGE:
			ShellExecute(NULL, NULL, STR_HOMEPAGE_ADDRESS, NULL, NULL, SW_SHOW);
			break;
		}
		break;

	case WM_CLOSE:
	// {^ꂽƂ
		DestroyWindow(hWnd);
		break;

	case WM_DESTROY:
	// EBhE̔j
		PostQuitMessage(0);
		break;

	default:
	// ftHg̏
		return DefWindowProc(hWnd, wMsg, wParam, lParam);
	}
	return 0;
}


//==================================================
// CEBhENX
//==================================================
class DFLMaker:public Window
{
private:
	// ϐ̐錾
	ChildWnds *poChildWnds;
	ListView *poFileList;
	Button *poUpFile;
	Button *poDownFile;
	Button *poDeleteFile;
	Button *poAddFile;
	Label *poLabel01;
	Label *poLabel04;
	Label *poLabel05;
	Label *poLabel03;
	PassBox *poPassword;
	Button *poShowOfn;
	TextBox *poHint;
	TextBox *poCslFileName;
	Button *poReference;
	Button *poOK;
	Button *poCancel;
	Button *poHelp;
	Button *poVerInfo;
	PopupMenu* poPopupMenu;
	
	static bool bClosable;
	static DFLMaker* poThis;

	void RegWndClass() const;
	void CreateDFLMaker(const char *pcTitle, long nWidth, long nHeight);
	void CreateChildWnds();
	void CreateFileListMenu();
	static LRESULT DFLMakerProc(HWND hWnd, UINT wMsg, WPARAM wParam, LPARAM lParam);
	LRESULT FileListWndProc(HWND hWnd, UINT wMsg, WPARAM wParam, LPARAM lParam);
	void CreateDFL();
	void InsertDroppedFiles(HDROP hDrop);
	void AddFile();
	void GetCslFilePath();
	void OpenDoubleClickedFile();
	void CreateVerInfoWnd();
	void ShowOriginalFileName();

	WNDPROC pfnOriginalListWndProc;
	
public:
	// ϐ̐錾
	PathManagement *poPathManagement;
	
	// ֐̐錾
	DFLMaker(PathManagement *_poPathManagement);
	~DFLMaker();

	static LRESULT CALLBACK TempFileListWndProc(HWND hWnd, UINT wMsg, WPARAM wParam, LPARAM lParam);
	void InsertFile(const char* pcFilePath, bool bState = false);

};

bool DFLMaker::bClosable = true;
DFLMaker* DFLMaker::poThis = NULL;

//----------------------------------------
// RXgN^
//----------------------------------------
DFLMaker::DFLMaker(PathManagement *_poPathManagement)
{
	// 
	pfnWindowProc = &DFLMakerProc;
	poPathManagement = _poPathManagement;
	
	// ֐̎s
	RegWndClass();
	CreateDFLMaker(STR_DFLM_SOFTNAME, 600, 410);
	CreateChildWnds();
	CreateFileListMenu();
}

//----------------------------------------
// fXgN^
//----------------------------------------
DFLMaker::~DFLMaker()
{
	// IuWFNg̉
	delete poPopupMenu;
	delete poVerInfo;
	delete poHelp;
	delete poCancel;
	delete poOK;
	delete poReference;
	delete poCslFileName;
	delete poHint;
	delete poLabel03;
	delete poPassword;
	delete poShowOfn;
	delete poLabel05;
	delete poLabel04;
	delete poLabel01;
	delete poAddFile;
	delete poDeleteFile;
	delete poUpFile;
	delete poDownFile;
	delete poFileList;
	delete poChildWnds;
}

//----------------------------------------
// EBhENX̓o^
//----------------------------------------
void DFLMaker::RegWndClass() const
{
	// ϐ̐錾
	WNDCLASSEX wcx;

	// NXf[^̑
	FillMemory(&wcx, sizeof(WNDCLASSEX), 0);
	wcx.cbSize = sizeof(WNDCLASSEX);
	wcx.style = CS_DBLCLKS | CS_HREDRAW | CS_VREDRAW;
	wcx.lpfnWndProc = &TempWindowProc;
	wcx.hInstance = GetModuleHandle(0);
	wcx.hIcon = static_cast<HICON>(LoadImage(wcx.hInstance, MAKEINTRESOURCE(C_SWAT_DFLM_ICON), IMAGE_ICON, 32, 32, LR_CREATEDIBSECTION));
	wcx.hCursor = LoadCursor(NULL, IDC_ARROW);
	wcx.hbrBackground = hBrush;
	wcx.hIconSm = static_cast<HICON>(LoadImage(wcx.hInstance, MAKEINTRESOURCE(C_SWAT_DFLM_ICON), IMAGE_ICON, 16, 16, LR_CREATEDIBSECTION));
	wcx.lpszClassName = "DFLM_MAINWND";

	// EBhENX̓o^
	RegisterClassEx(&wcx);
}

//----------------------------------------
// CEBhE쐬
//----------------------------------------
void DFLMaker::CreateDFLMaker(const char *pcTitle, long nWidth, long nHeight)
{
	hWnd = CreateWindowEx(
		NULL,
		"DFLM_MAINWND",
		pcTitle,
		WS_OVERLAPPED | WS_CAPTION | WS_SYSMENU | WS_MINIMIZEBOX,
		CW_USEDEFAULT,
		CW_USEDEFAULT,
		nWidth + GetSystemMetrics(SM_CXFIXEDFRAME) * 2,
		nHeight + GetSystemMetrics(SM_CYFIXEDFRAME) * 2 + GetSystemMetrics(SM_CYCAPTION),
		NULL,
		NULL,
		GetModuleHandle(0),
		this
	);
}

//----------------------------------------
// qEBhE쐬
//----------------------------------------
void DFLMaker::CreateChildWnds()
{
	// qEBhENXIuWFNg
	poChildWnds = new ChildWnds();

	// qEBhE쐬
	poLabel01 = new Label(hWnd, STR_WND_DFLM_FILE_TO_INCLUDE, 10, 13, 580, 14, NULL);

	poFileList = new ListView(hWnd, 10, 30, 580, 200, ID_WND_DFLM_FILE_LIST);
	SendMessage(poFileList->hWnd, LVM_SETEXTENDEDLISTVIEWSTYLE, LVS_EX_CHECKBOXES, LVS_EX_CHECKBOXES);
	poFileList->InsertColumn(STR_WND_FILE_NAME, 150);
	poFileList->InsertColumn(STR_WND_ORIGINAL_FILE_NAME, 150);
	poFileList->InsertColumn(STR_WND_FILE_PATH, 280);
	pfnOriginalListWndProc = (WNDPROC)GetWindowLong(poFileList->hWnd, GWL_WNDPROC);
	SetWindowLongPtr(poFileList->hWnd, GWL_WNDPROC, (LONG_PTR)&TempFileListWndProc);
	SetProp(poFileList->hWnd, "ThisPtr", this);
	poFileList->AddToolTip(STR_TT_DFLM_FILE_LIST);

	poUpFile = new Button(hWnd, STR_WND_UP_FILE, 160, 240, 100, 21, ID_WND_DFLM_UP_FILE, poChildWnds);
	poDownFile = new Button(hWnd, STR_WND_DOWN_FILE, 270, 240, 100, 21, ID_WND_DFLM_DOWN_FILE, poChildWnds);
	poDeleteFile = new Button(hWnd, STR_WND_DELETE, 380, 240, 100, 21, ID_WND_DFLM_DELETE_FILE, poChildWnds);
	poAddFile = new Button(hWnd, STR_WND_ADD, 490, 240, 100, 21, ID_WND_DFLM_ADD_FILE, poChildWnds);
	poUpFile->AddToolTip(STR_TT_UP_FILE);
	poDownFile->AddToolTip(STR_TT_DOWN_FILE);
	poDeleteFile->AddToolTip(STR_TT_DELETE_FILE);
	poAddFile->AddToolTip(STR_TT_ADD_FILE);

	poLabel03 = new Label(hWnd, STR_WND_PASSWORD, 10, 283, 90, 14, NULL);
	poPassword = new PassBox(hWnd, 100, 280, 350, 20, ID_WND_DFLM_PASSWORD, poChildWnds);
	poShowOfn = new Button(hWnd, STR_WND_SHOW_OFN, 460, 280, 130, 21, ID_WND_DFLM_SHOW_OFN, poChildWnds);
	poPassword->AddToolTip(STR_TT_PASSWORD_FOR_OFN);
	poShowOfn->AddToolTip(STR_TT_SHOW_OFN);

	poLabel04 = new Label(hWnd, STR_WND_DFLM_HINT, 10, 313, 120, 14, NULL);
	poHint = new TextBox(hWnd, 130, 310, 460, 20, ID_WND_DFLM_HINT, false, poChildWnds);
	poHint->AddToolTip(STR_TT_HINT);

	poLabel05 = new Label(hWnd, STR_WND_DFLM_CSL_FILE_PATH, 10, 343, 130, 20, NULL);
	poCslFileName = new TextBox(hWnd, 140, 340, 360, 20, ID_WND_DFLM_LIST_FILE_NAME, false, poChildWnds);
	poReference = new Button(hWnd, STR_WND_DFLM_REFERENCE, 510, 340, 80, 21, ID_WND_DFLM_REFERENCE, poChildWnds);
	poCslFileName->AddToolTip(STR_TT_DFLM_CSL_FILE_NAME);
	poReference->AddToolTip(STR_TT_DFLM_REFERENCE);

	poOK = new Button(hWnd, STR_WND_OK, 160, 380, 100, 21, ID_WND_DFLM_OK, poChildWnds);
	poCancel = new Button(hWnd, STR_WND_CANCEL, 270, 380, 100, 21, ID_WND_DFLM_CANCEL, poChildWnds);
	poHelp = new Button(hWnd, STR_WND_HELP, 380, 380, 100, 21, ID_WND_DFLM_HELP, poChildWnds);
	poVerInfo = new Button(hWnd, STR_WND_VERSION_INFO, 490, 380, 100, 21, ID_WND_DFLM_VERINFO, poChildWnds);
	poOK->SetDefButton();

	// tH[JX̃Zbg
	SetFocus(poHint->hWnd);
}

//----------------------------------------
// t@CXgpj[̍쐬
//----------------------------------------
void DFLMaker::CreateFileListMenu()
{
	poPopupMenu = new PopupMenu();
	poPopupMenu->InsertItem(STR_MENU_ADD, ID_MENU_DFLM_ADD);
	poPopupMenu->InsertItem(STR_MENU_DELETE, ID_MENU_DFLM_DELETE);
	poPopupMenu->InsertItem(STR_MENU_OPEN, ID_MENU_DFLM_OPEN);
}

//----------------------------------------
// t@CXgR[obN֐
//----------------------------------------
LRESULT CALLBACK DFLMaker::TempFileListWndProc(HWND hWnd, UINT wMsg, WPARAM wParam, LPARAM lParam)
{
	poThis = (DFLMaker*)GetProp(hWnd, "ThisPtr");
	return poThis->FileListWndProc(hWnd, wMsg, wParam, lParam);
}

//----------------------------------------
// CEBhER[obN֐
//----------------------------------------
LRESULT DFLMaker::DFLMakerProc(HWND hWnd, UINT wMsg, WPARAM wParam, LPARAM lParam)
{
	switch(wMsg) {
	case WM_NOTIFY:
	// t@CXg̗̃o[NbNꂽƂ
		if (wParam == ID_WND_DFLM_FILE_LIST) {
			if (((LV_DISPINFO*)lParam)->hdr.code == LVN_COLUMNCLICK) {
				poThis->poFileList->SortItems(((NM_LISTVIEW*)lParam)->iSubItem);
			}
		}
		break;

	case WM_COMMAND:
		switch(wParam & 0xFFFF) {
		// փ{^ꂽƂ
		case ID_WND_DFLM_UP_FILE:
			poThis->poFileList->UpSelectedItems();
			break;

		// փ{^ꂽƂ
		case ID_WND_DFLM_DOWN_FILE:
			poThis->poFileList->DownSelectedItems();
			break;

		case ID_WND_DFLM_ADD_FILE:
		// ǉ{^ꂽƂ
			poThis->AddFile();
			break;

		case ID_WND_DFLM_DELETE_FILE:
		// 폜{^ꂽƂ
			poThis->poFileList->DelSelectedItems();
			break;

		case ID_WND_DFLM_SHOW_OFN:
		// t@C\{^ꂽƂ
			poThis->ShowOriginalFileName();
			break;

		case ID_WND_DFLM_REFERENCE:
		// CSLt@CpXQƃ{^Ƃ
			poThis->GetCslFilePath();
			break;

		case ID_WND_DFLM_OK:
		// OK{^ꂽƂ
			poThis->poCslFileName->GetLatestText();
			if (lstrlen((LPCSTR)poThis->poCslFileName->pcText) == 0) {
				MessageBox(NULL, STR_MSG_CSL_PATH_NOT_SET, STR_DFLM_SOFTNAME, MB_OK);
			}
			else {
				poThis->CreateDFL();
				SendMessage(hWnd, WM_CLOSE, 0, 0);
			}
			break;

		case ID_WND_DFLM_CANCEL:
		// LZ{^ꂽƂ
			SendMessage(hWnd, WM_CLOSE, 0, 0);
			break;

		case ID_WND_DFLM_HELP:
		// wv{^ꂽƂ
			ShellExecute(NULL, NULL, poThis->poPathManagement->pcHelpPath, NULL, NULL, SW_SHOW);
			break;

		case ID_WND_DFLM_VERINFO:
		// wv{^ꂽƂ
			poThis->CreateVerInfoWnd();
			break;
		}
		break;

	case WM_CLOSE:
	// {^ꂽƂ
		if (bClosable) DestroyWindow(hWnd);
		break;

	case WM_DESTROY:
	// EBhE̔j
		PostQuitMessage(0);
		break;

	default:
	// ftHg̏
		return DefWindowProc(hWnd, wMsg, wParam, lParam);
	}
	return 0;
}

//----------------------------------------
// Íp[^̐ݒ
//----------------------------------------
void DFLMaker::CreateDFL()
{
	// ϐ̐錾
	XML* poDecFileList;
	int i;
	int nElmID;
	int nStrLen;
	char* pcText;
	char acNumOfFiles[10];

	// Jۂ̃`FbN
	poDecFileList = new XML();
	poDecFileList->poRoot->SetElmName("decFileList");
	poDecFileList->poRoot->AddAttr("version", "1.0");
	poDecFileList->poRoot->AddAttr("path", "absolute");
	poDecFileList->poRoot->ChangeContent("\r\n", true);
	FillMemory(&acNumOfFiles, 10, 0);
	_ltoa(poFileList->nNumOfItems, (char*)&acNumOfFiles, 10);
	poDecFileList->poRoot->AddElm("fileNum", (char*)&acNumOfFiles, true);

	poHint->GetLatestText();
	nStrLen = CharSet::ConvertText((unsigned char*)poHint->pcText, SHIFTJIS_TO_UTF8);
	pcText = (char*)malloc(nStrLen + 1);
	CharSet::CopyText((unsigned char*)pcText);
	pcText[nStrLen] = NULL;
	poDecFileList->poRoot->AddElm("hintText", pcText, true);

	for (i = 0; i < (poFileList->nNumOfItems); i++) {
		nStrLen = CharSet::ConvertText((unsigned char*)poFileList->pppcText[2][i], SHIFTJIS_TO_UTF8);
		pcText = (char*)malloc(nStrLen + 1);
		CharSet::CopyText((unsigned char*)pcText);
		pcText[nStrLen] = NULL;

		nElmID = poDecFileList->poRoot->AddElm("decFile", pcText, true);
		if (SendMessage(poFileList->hWnd, LVM_GETITEMSTATE, i, 0xF000) == 0x2000) {
			poDecFileList->poRoot->ppoElms[nElmID]->AddAttr("open", "yes");
		}

		free(pcText);
	}

	poDecFileList->Save(poCslFileName->pcText, true);

	free(pcText);
	delete poDecFileList;
}

//----------------------------------------
// t@Cǉ֐
//----------------------------------------
void DFLMaker::AddFile()
{
	// ϐ̐錾
	OPENFILENAME ofn;

	// el̑
	FillMemory(&ofn, sizeof(OPENFILENAME), 0);
	ofn.lStructSize = sizeof(OPENFILENAME);
	ofn.hwndOwner = hWnd;
	ofn.lpstrFilter = STR_WND_FILE_FILTER_ALL;
	ofn.lpstrFile = (LPTSTR)malloc(MAX_PATH + 1);
	FillMemory(ofn.lpstrFile, MAX_PATH + 1, 0);
	ofn.nMaxFile = MAX_PATH + 1;
	ofn.lpstrFileTitle = (LPTSTR)malloc(MAX_PATH + 1);
	FillMemory(ofn.lpstrFileTitle, MAX_PATH + 1, 0);
	ofn.nMaxFileTitle = MAX_PATH + 1;
	ofn.lpstrTitle = STR_WND_DFLM_OPEN_FILE_TO_INCLUDE;
	ofn.Flags = OFN_FILEMUSTEXIST | OFN_HIDEREADONLY | OFN_PATHMUSTEXIST;

	// _CAO̕\
	if (GetOpenFileName(&ofn)) {
		InsertFile(ofn.lpstrFile);
	}

	// q[v̈̉
	free(ofn.lpstrFile);
	free(ofn.lpstrFileTitle);
}

//----------------------------------------
// CSLt@CpXݒ֐
//----------------------------------------
void DFLMaker::GetCslFilePath()
{
	// ϐ̐錾
	OPENFILENAME ofn;

	// el̑
	FillMemory(&ofn, sizeof(OPENFILENAME), 0);
	ofn.lStructSize = sizeof(OPENFILENAME);
	ofn.hwndOwner = hWnd;
	ofn.lpstrFilter = STR_WND_DFLM_CSL_FILE_FILTER;
	ofn.lpstrFile = (LPTSTR)malloc(MAX_PATH + 1);
	FillMemory(ofn.lpstrFile, MAX_PATH + 1, 0);
	ofn.nMaxFile = MAX_PATH + 1;
	ofn.lpstrFileTitle = (LPTSTR)malloc(MAX_PATH + 1);
	FillMemory(ofn.lpstrFileTitle, MAX_PATH + 1, 0);
	ofn.nMaxFileTitle = MAX_PATH + 1;
	ofn.lpstrTitle = STR_WND_DFLM_SAVE_CSL_FILE_PATH;
	ofn.Flags = OFN_HIDEREADONLY | OFN_OVERWRITEPROMPT;
	ofn.lpstrDefExt = "csl";

	// _CAO̕\
	if (GetSaveFileName(&ofn)) {
		SendMessage(poCslFileName->hWnd, WM_SETTEXT, 0, (LPARAM)ofn.lpstrFile);
	}

	// q[v̈̉
	free(ofn.lpstrFile);
	free(ofn.lpstrFileTitle);
}

//----------------------------------------
// t@C}֐
//----------------------------------------
void DFLMaker::InsertFile(const char* pcFilePath, bool bState)
{
	// ϐ̐錾
	DWORD dwAttr;
	char* pcSearchFilePath;
	WIN32_FIND_DATA wfd;
	char* pcFoundFilePath;
	HANDLE hFileSearch;
	char** ppcFileData;
	int nFilePathLen;
	int i;
	int j;

	// t@C̎擾
	dwAttr = GetFileAttributes(pcFilePath);

	if (dwAttr == 0xFFFFFFFF) {
	// 擾Ɏsꍇ
		return;

	}
	else if (((dwAttr & FILE_ATTRIBUTE_DIRECTORY) == FILE_ATTRIBUTE_DIRECTORY)) {
	// ̃pXfBNg̏ꍇ
	
		// p̐
		pcSearchFilePath = (char*)malloc(lstrlen((LPCSTR)pcFilePath) + 3);
		pcSearchFilePath[0] = NULL;
		lstrcpy((LPSTR)pcSearchFilePath, pcFilePath);
		if (pcSearchFilePath[lstrlen((LPCSTR)pcSearchFilePath) - 1] != 0x5C) {
			lstrcat((LPSTR)pcSearchFilePath, "\\*");
		}
		else {
			lstrcat((LPSTR)pcSearchFilePath, "*");
		}

		// ŏ̃t@Č
		FillMemory(&wfd, sizeof(WIN32_FIND_DATA), 0);
		hFileSearch = FindFirstFile(pcSearchFilePath, &wfd);
		if (wfd.cFileName[0] != 0x2E) {
			pcFoundFilePath = (char*)malloc(lstrlen((LPCSTR)pcSearchFilePath) + lstrlen((LPCSTR)wfd.cFileName));
			pcFoundFilePath[0] = NULL;
			lstrcpy((LPSTR)pcFoundFilePath, pcSearchFilePath);
			pcFoundFilePath[lstrlen((LPCSTR)pcFoundFilePath) - 1] = NULL;
			lstrcat((LPSTR)pcFoundFilePath, wfd.cFileName);
			InsertFile(pcFoundFilePath);
			free(pcFoundFilePath);
		}

		// ̃t@Č
		FillMemory(&wfd, sizeof(WIN32_FIND_DATA), 0);
		while (FindNextFile(hFileSearch, &wfd) != 0) {
			if (wfd.cFileName[0] != 0x2E) {
				pcFoundFilePath = (char*)malloc(lstrlen((LPCSTR)pcSearchFilePath) + lstrlen((LPCSTR)wfd.cFileName));
				pcFoundFilePath[0] = NULL;
				lstrcpy((LPSTR)pcFoundFilePath, pcSearchFilePath);
				pcFoundFilePath[lstrlen((LPCSTR)pcFoundFilePath) - 1] = NULL;
				lstrcat((LPSTR)pcFoundFilePath, wfd.cFileName);
				InsertFile(pcFoundFilePath);
				free(pcFoundFilePath);
			}
			FillMemory(&wfd, sizeof(WIN32_FIND_DATA), 0);
		}

		// q[v̈̉
		free(pcSearchFilePath);

	}
	else {
	// ̃pXt@C̏ꍇ

		for (j = lstrlen(pcFilePath) - 1; j > 0; j--) {
			if (pcFilePath[j] == '.') {
				break;
			}
		}
		// CSLt@C̏ꍇ
		if ((j >= 0) && (lstrcmp(&pcFilePath[j], ".csl") == 0)) {
			int nDirPathLen = PathManagement::GetDirPathLen((unsigned char*)pcFilePath);
			bool bAbsolutePath = false;
			XML oCSWATFileList;
			int nElmID;
			int nAttrID;
			int nFilePathLen;
			char* pcPathOfFileInList;
			bool bOpen;
			oCSWATFileList.Load(pcFilePath);

			nElmID = oCSWATFileList.poRoot->GetElmID("fileNum", 0);
			nAttrID = oCSWATFileList.poRoot->GetAttrID("version");

			if (nAttrID != -1) {
				double dVersion = strtod(oCSWATFileList.poRoot->psAttr[nAttrID].pcAttrValue, NULL);
				if (dVersion > CSL_SUPPORT_VERSION) {
					MessageBox(NULL, STR_MSG_NOT_SUPPORTED, STR_DFLM_SOFTNAME, MB_OK);
					return;
				}
			}
			nAttrID = oCSWATFileList.poRoot->GetAttrID("path");
			if (nAttrID != -1) {
				if (lstrcmp("absolute", oCSWATFileList.poRoot->psAttr[nAttrID].pcAttrValue) == 0) {
					bAbsolutePath = true;
				}
				else {
					bAbsolutePath = false;
				}
			}

			nElmID = -1;
			while (true) {
				bOpen = false;
				nElmID = oCSWATFileList.poRoot->GetElmID("decFile", nElmID + 1);
				if (nElmID == -1) {
					break;
				}
				else {
					nFilePathLen = CharSet::ConvertText((unsigned char*)oCSWATFileList.poRoot->ppoElms[nElmID]->pcContent, UTF8_TO_SHIFTJIS);
					if (bAbsolutePath) {
						pcPathOfFileInList = (char*)malloc(nFilePathLen + 1);
						CharSet::CopyText((unsigned char*)pcPathOfFileInList);
						pcPathOfFileInList[nFilePathLen] = NULL;
					}
					else {
						pcPathOfFileInList = (char*)malloc(nDirPathLen + nFilePathLen + 1);
						memcpy(pcPathOfFileInList, pcFilePath, nDirPathLen);
						CharSet::CopyText((unsigned char*)pcPathOfFileInList + nDirPathLen);
						pcPathOfFileInList[nDirPathLen + nFilePathLen] = NULL;
					}
					nAttrID = oCSWATFileList.poRoot->ppoElms[nElmID]->GetAttrID("open");
					if ((nAttrID != -1) && (lstrcmp("yes", oCSWATFileList.poRoot->ppoElms[nElmID]->psAttr[nAttrID].pcAttrValue) == 0)) {
						bOpen = true;
					}
					InsertFile(pcPathOfFileInList, bOpen);
				}
			}

		// CSEt@C̏ꍇ
		}
		else if (((j >= 0) && (lstrcmp(&pcFilePath[j], ".cse") == 0))) {

			// q[v̈̊m
			nFilePathLen = lstrlen((LPCSTR)pcFilePath);
			ppcFileData = (char**)malloc(3 * sizeof(char*));
			ppcFileData[0] = (char*)malloc(2);
			ppcFileData[0][1] = ppcFileData[0][0] = NULL;
			ppcFileData[1] = (char*)malloc(2);
			ppcFileData[1][1] = ppcFileData[1][0] = NULL;
			ppcFileData[2] = (char*)malloc(nFilePathLen + 1);

			// t@Co^
			FillMemory(ppcFileData[2], nFilePathLen + 1, 0);
			lstrcpy((LPSTR)ppcFileData[2], pcFilePath);
			i = PathManagement::GetDirPathLen((unsigned char*)ppcFileData[2]);
			ppcFileData[0] = (char*)realloc(ppcFileData[0], nFilePathLen - i + 1);
			FillMemory(ppcFileData[0], nFilePathLen - i + 1, 0);
			lstrcpy((LPSTR)ppcFileData[0], ppcFileData[2] + i);
			poFileList->InsertItem((char**)ppcFileData, bState);

			// q[v̈̉
			free(ppcFileData[0]);
			free(ppcFileData[1]);
			free(ppcFileData[2]);
			free(ppcFileData);

		// ȊȌꍇ
		}
		else {
			char* pcMessage = (char*)malloc(lstrlen(pcFilePath) + 32);
			lstrcpy(pcMessage, STR_DFLM_MSG_NOT_CSE_FILE_01);
			lstrcat(pcMessage, pcFilePath);
			lstrcat(pcMessage, STR_DFLM_MSG_NOT_CSE_FILE_02);
			MessageBox(NULL, pcMessage, STR_DFLM_SOFTNAME, MB_OK);
		}
	}
}

//----------------------------------------
// t@CXgR[obN֐
//----------------------------------------
LRESULT DFLMaker::FileListWndProc(HWND hWnd, UINT wMsg, WPARAM wParam, LPARAM lParam)
{
	switch(wMsg) {
	case WM_DROPFILES:
	// t@Chbvꂽꍇ
		InsertDroppedFiles((HDROP)wParam);
		break;

	case WM_CONTEXTMENU:
	// ENbNꂽꍇ
		TrackPopupMenu(poPopupMenu->hPopupMenu, TPM_LEFTALIGN, (int)(lParam & 0x0000FFFF), (int)((lParam & 0xFFFF0000) >> 16), 0, hWnd, NULL);
		break;

	case WM_COMMAND:
		switch(wParam) {
		case ID_MENU_DFLM_ADD:
		// ǉIꂽꍇ
			SendMessage(poAddFile->hWnd, BM_CLICK, 0, 0);
			break;

		case ID_MENU_DFLM_DELETE:
		// 폜Iꂽꍇ
			SendMessage(poDeleteFile->hWnd, BM_CLICK, 0, 0);
			break;

		case ID_MENU_DFLM_OPEN:
		// JIꂽꍇ
			OpenDoubleClickedFile();
			break;
		}
		break;

	case WM_LBUTTONDBLCLK:
	// _uNbNꂽꍇ
		OpenDoubleClickedFile();
		break;

	case WM_KEYDOWN:
		if (wParam == VK_DELETE) {
		// DELETEL[
			SendMessage(poDeleteFile->hWnd, BM_CLICK, 0, 0);
			break;
		}
		else if ((wParam == VK_UP)) {
		// L[
			SendMessage(poUpFile->hWnd, BM_CLICK, 0, 0);
			break;
		}
		else if ((wParam == VK_DOWN)) {
		// L[
			SendMessage(poDownFile->hWnd, BM_CLICK, 0, 0);
			break;
		}
		else if ((((wParam == 0x41) || (wParam == 0x61)) && (GetKeyState(VK_CONTROL) < 0))) {
		// "Ctrl"+"a"/"A"
			SendMessage(poAddFile->hWnd, BM_CLICK, 0, 0);
			break;
		}
		else if ((wParam == VK_RETURN)) {
		// "Enter"
			OpenDoubleClickedFile();
			break;
		}
		
	default:
	// ftHg̏
		return CallWindowProc(pfnOriginalListWndProc, hWnd, wMsg, wParam, lParam);
	}
	return 0;
}

//----------------------------------------
// hbvt@C}֐
//----------------------------------------
void DFLMaker::InsertDroppedFiles(HDROP hDrop)
{
	// ϐ̐錾
	int nNumberOfDroppedFiles;
	char *pcFilePath;
	int i;

	// hbvt@C̑}
	nNumberOfDroppedFiles = DragQueryFile(hDrop, -1, NULL, 0);
	pcFilePath = (char*)malloc(MAX_PATH + 1);
	for (i = 0; i < nNumberOfDroppedFiles; i++) {
		FillMemory(pcFilePath, MAX_PATH + 1, 0);
		DragQueryFile(hDrop, i, pcFilePath, MAX_PATH);
		InsertFile(pcFilePath);
	}
	DragFinish(hDrop);

	// q[v̈̉
	free(pcFilePath);
}

//----------------------------------------
// _uNbNt@CI[v֐
//----------------------------------------
void DFLMaker::OpenDoubleClickedFile()
{
	// ϐ̐錾E
	int nClickedItem = -1;

	// t@ČEI[v
	while (true) {
		nClickedItem = (int)SendMessage(poFileList->hWnd, LVM_GETNEXTITEM, nClickedItem, LVNI_SELECTED);
		if (nClickedItem != -1) {
			ShellExecute(hWnd, "open", poFileList->pppcText[2][nClickedItem], NULL, NULL, SW_SHOW);
		}
		else {
			break;
		}
	}
}

//----------------------------------------
// o[WEBhE֐
//----------------------------------------
void DFLMaker::CreateVerInfoWnd()
{
	DFLMVerInfoWnd *poVerInfoWnd;

	bClosable = false;
	poVerInfoWnd = new DFLMVerInfoWnd();
	delete poVerInfoWnd;
	bClosable = true;
}

//----------------------------------------
// t@C\֐
//----------------------------------------
void DFLMaker::ShowOriginalFileName()
{
	// pX[h̎擾
	poPassword->GetLatestText();
	unsigned char* password = new unsigned char[lstrlen((LPCSTR)poPassword->pcText) + 1];
	lstrcpy(reinterpret_cast<LPSTR>(password), poPassword->pcText);

	// eɌt@C\
	unsigned char originalFileName[MAX_PATH + 1];
	char* ppcFileData[3];
	CseFile cse_obj;
	for (int i = 0; i < (poFileList->nNumOfItems); i++) {
		originalFileName[0] = 0;
		cse_obj.getOriginalFileName(reinterpret_cast<const unsigned char*>(poFileList->pppcText[2][i]), originalFileName, password);

		ppcFileData[0] = new char[lstrlen(reinterpret_cast<LPCSTR>(poFileList->pppcText[0][i])) + 1];
		lstrcpy(reinterpret_cast<LPSTR>(ppcFileData[0]), reinterpret_cast<LPCSTR>(poFileList->pppcText[0][i]));
		ppcFileData[1] = new char[lstrlen(reinterpret_cast<LPCSTR>(originalFileName)) + 1];
		lstrcpy(reinterpret_cast<LPSTR>(ppcFileData[1]), reinterpret_cast<LPCSTR>(originalFileName));
		ppcFileData[2] = new char[lstrlen(reinterpret_cast<LPCSTR>(poFileList->pppcText[2][i])) + 1];
		lstrcpy(reinterpret_cast<LPSTR>(ppcFileData[2]), reinterpret_cast<LPCSTR>(poFileList->pppcText[2][i]));

		poFileList->ChangeItemData(i, ppcFileData, poFileList->getState(i));

		delete[] ppcFileData[0];
		delete[] ppcFileData[1];
		delete[] ppcFileData[2];
	}
}


//==================================================
// C֐
//==================================================
int WINAPI WinMain(HINSTANCE, HINSTANCE, LPSTR pcCmdLine, int)
{
	// ϐ̐錾
	CmdLine *poCmdLine;
	PathManagement *poPathManagement;
	DFLMaker *poDFLM;
	int i;

	// eIuWFNg̐
	poCmdLine = new CmdLine(pcCmdLine);
	poPathManagement = new PathManagement();
	poDFLM = new DFLMaker(poPathManagement);

	// t@C̓o^
	for (i = 0; i < (poCmdLine->nArgc); i++) {
		poDFLM->InsertFile(poCmdLine->ppcArgv[i]);
	}
	poDFLM->Run(SW_SHOW);

	delete poCmdLine;
	delete poPathManagement;
	delete poDFLM;
	
	// ߂l
	return 0;
}
