/*********************************************************************************

 Í`FbJ[ Ver.1.0.0.3


 Copyright (c) 2008-2013, Isao MORI (Orios)
 All rights reserved.

 Redistribution and use in source and binary forms, with or without modification,
 are permitted provided that the following conditions are met:
   * Redistributions of source code must retain the above copyright notice, this
     list of conditions and the following disclaimer.
   * Redistributions in binary form must reproduce the above copyright notice,
     this list of conditions and the following disclaimer in the documentation
     and/or other materials provided with the distribution.
 
 THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND
 ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
 WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
 DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT HOLDER OR CONTRIBUTORS BE LIABLE FOR
 ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
 (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
 LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON
 ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
 (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
 SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
*********************************************************************************/


//==================================================
// CN[h
//==================================================
#include <iostream>
#include "c-swat.h"
#include "Rijndael.h"

using namespace std;

//==================================================
// 16i  l
//==================================================
int convertHexTextToNum(const char hexText_char2[2])
{
	int results;
	if (hexText_char2[0] >= 'a') {
		results = (hexText_char2[0] - 'a' + 10) * 16;
	}
	else {
		results = (hexText_char2[0] - '0') * 16;
	}
	if (hexText_char2[1] >= 'a') {
		results += hexText_char2[1] - 'a' + 10;
	}
	else {
		results += hexText_char2[1] - '0';
	}
	return results;
}

//==================================================
// C֐
//==================================================
int main(int argc, char* argv[])
{
	// ϐ̐錾
	unsigned char encInitVector_a[16];
	unsigned char decInitVector_a[16];
	unsigned char key_a[32];
	unsigned char* plainText_p = NULL;
	unsigned char* encText_p = NULL;
	unsigned char* decText_p = NULL;
	int plainTextLen = 0;
	int bufSize = 0;
	Rijndael rijndael_obj;

	// R}hC̏
	bool doesPlainTextExist = false;
	bool doesIVExist = false;
	bool doesKeyExist = false;
	if ((argc <= 1) || (lstrcmp(argv[1], "--help") == 0) || (lstrcmp(argv[1], "-h") == 0)) {
		cout << endl << STR_ENCCHECK_TITLE << endl;
		cout << STR_ENCCHECK_COPYLEFT << endl << endl;
		cout << STR_ENCCHECK_USAGE << endl << endl;
		cout << STR_ENCCHECK_I << endl;
		cout << STR_ENCCHECK_I_EX << endl;
		cout << STR_ENCCHECK_K << endl;
		cout << STR_ENCCHECK_K_EX << endl;
		cout << STR_ENCCHECK_P << endl;
		cout << STR_ENCCHECK_P_EX << endl;

		return 0; // newɂ郁mۂ͂ȂƂmF

	}
	else {
		char tmp_char2[2];
		for (int i = 1; i < argc; i++) {
			if (lstrcmp(argv[i], "-i") == 0 && !doesIVExist) {
				i++;
				if (lstrlen(argv[i]) == 32) {
					for (int j = 0; j < 16; j++) {
						tmp_char2[0] = argv[i][j * 2];
						tmp_char2[1] = argv[i][j * 2 + 1];
						decInitVector_a[j] = encInitVector_a[j] = convertHexTextToNum(tmp_char2);
					}
					doesIVExist = true;
				}
			}
			else if ((lstrcmp(argv[i], "-k") == 0 && !doesKeyExist)) {
				i++;
				if (lstrlen(argv[i]) == 64) {
					for (int j = 0; j < 32; j++) {
						tmp_char2[0] = argv[i][j * 2];
						tmp_char2[1] = argv[i][j * 2 + 1];
						key_a[j] = convertHexTextToNum(tmp_char2);
					}
					doesKeyExist = true;
				}
			}
			else if ((lstrcmp(argv[i], "-p") == 0 && !doesPlainTextExist)) {
				i++;
				plainTextLen = lstrlen(argv[i]) / 2 + lstrlen(argv[i]) % 2;
				bufSize = static_cast<int>(rijndael_obj.GetNeededBufSize(plainTextLen));
				plainText_p = new unsigned char[bufSize];
				encText_p = new unsigned char[bufSize];
				decText_p = new unsigned char[bufSize];
				FillMemory(plainText_p, bufSize, 0);
				for (int j = 0; j < plainTextLen; j++) {
					tmp_char2[0] = argv[i][j * 2];
					tmp_char2[1] = argv[i][j * 2 + 1];
					plainText_p[j] = convertHexTextToNum(tmp_char2);
				}
				doesPlainTextExist = true;
			}
		}
	}

	// p[^Ă邩̊mF
	if (!doesIVExist || !doesKeyExist || !doesPlainTextExist) {
		cout << STR_ENCCHECK_ERROR << endl;
		cout << STR_ENCCHECK_PARAM_INVALID << endl;
	}
	else {

		// f[^̕\
		ios_base::fmtflags poshex = ios_base::hex | ios_base::right;
		ios_base::fmtflags poshexmask = ios_base::basefield | ios_base::adjustfield;
		cout.setf(poshex, poshexmask);
		cout.fill('0');
		cout << endl << STR_ENCCHECK_PLAIN_TEXT;
		for (int i16 = 0; i16 < plainTextLen; i16 += 16) {
			if (i16 != 0) {
				cout << STR_ENCCHECK_INDENT_SPACE;
			}
			for (int j = 0; (i16 + j) < plainTextLen && j < 16; j++) {
				cout.width(2);
				cout << static_cast<int>(plainText_p[i16 + j]) << " ";
			}
			cout << endl;
		}
		cout << STR_ENCCHECK_KEY;
		for (int i = 0; i < 16; i++) {
			cout.width(2);
			cout << static_cast<int>(key_a[i]) << " ";
		}
		cout << endl << STR_ENCCHECK_INDENT_SPACE;
		for (int i = 16; i < 32; i++) {
			cout.width(2);
			cout << static_cast<int>(key_a[i]) << " ";
		}
		cout << endl;
		cout << STR_ENCCHECK_IV;
		for (int i = 0; i < 16; i++) {
			cout.width(2);
			cout << static_cast<int>(encInitVector_a[i]) << " ";
		}
		cout << endl;
	
		// ÍE
		rijndael_obj.Encrypt(plainText_p, bufSize, reinterpret_cast<const char*>(key_a), encText_p, encInitVector_a);
		rijndael_obj.Decrypt(encText_p, bufSize, reinterpret_cast<const char*>(key_a), decText_p, decInitVector_a);

		// ʂ̕\
		cout << STR_ENCCHECK_ENC;
		for (int i16 = 0; i16 < bufSize; i16 += 16) {
			if (i16 != 0) {
				cout << STR_ENCCHECK_INDENT_SPACE;
			}
			for (int j = 0; (i16 + j) < bufSize && j < 16; j++) {
				cout.width(2);
				cout << static_cast<int>(encText_p[i16 + j]) << " ";
			}
			cout << endl;
		}
		cout << STR_ENCCHECK_DEC;
		for (int i16 = 0; i16 < plainTextLen; i16 += 16) {
			if (i16 != 0) {
				cout << STR_ENCCHECK_INDENT_SPACE;
			}
			for (int j = 0; (i16 + j) < plainTextLen && j < 16; j++) {
				cout.width(2);
			cout << static_cast<int>(decText_p[i16 + j]) << " ";
			}
			cout << endl;
		}
	}

	if (plainText_p != NULL) delete[] plainText_p;
	if (encText_p != NULL) delete[] encText_p;
	if (decText_p != NULL) delete[] decText_p;
	return 0;
}
