/*********************************************************************************

 C-SWAT Ver.2.2.0.0 (String Definition Part)


 Copyright (c) 2006-2013, Isao MORI (Orios)
 All rights reserved.

 Redistribution and use in source and binary forms, with or without modification,
 are permitted provided that the following conditions are met:
   * Redistributions of source code must retain the above copyright notice, this
     list of conditions and the following disclaimer.
   * Redistributions in binary form must reproduce the above copyright notice,
     this list of conditions and the following disclaimer in the documentation
     and/or other materials provided with the distribution.
 
 THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND
 ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
 WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
 DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT HOLDER OR CONTRIBUTORS BE LIABLE FOR
 ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
 (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
 LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON
 ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
 (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
 SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
*********************************************************************************/

#ifndef CSWAT_STRINGS
#define CSWAT_STRINGS

#define STR_AUTHOR "Isao MORI (Orios)"
#define STR_HOMEPAGE_ADDRESS "http://orios.s151.xrea.com/"
#define STR_MAIL_ADDRESS "mailto:orios814@gmail.com"
#define STR_RELEASE_DATE "Mar 2, 2013"
#define STR_SOFTNAME "C-SWAT (English ver.)"
#define STR_VERSION "2.2.0.0"

#define STR_DFLM_MSG_NOT_CSE_FILE_01 "\""
#define STR_DFLM_MSG_NOT_CSE_FILE_02 "\" is NOT a CSE file."
#define STR_DFLM_SOFTNAME "Decoding File List Maker"
#define STR_DFLM_VERSION "1.2.0.1"
#define STR_ENCCHECK_COPYLEFT "Copyright (c) 2008-2013, Isao MORI (Orios)\nAll rights reserved."
#define STR_ENCCHECK_DEC "Decryption Result: "
#define STR_ENCCHECK_ENC "Cipher Text      : "
#define STR_ENCCHECK_ERROR "***** ERROR *****"
#define STR_ENCCHECK_I "-i <InitVector>: Designate a 16-byte initial vector in a hex form."
#define STR_ENCCHECK_I_EX "     e.g. -i 00112233445566778899aabbccddeeff"
#define STR_ENCCHECK_INDENT_SPACE "@@@@@@@"
#define STR_ENCCHECK_IV "Initial Vector   : "
#define STR_ENCCHECK_K "-k <Key>: Designate a 32-byte key to use in encryption in a hex form."
#define STR_ENCCHECK_K_EX "     e.g. -k 00112233445566778899aabbccddeeffffeeddccbbaa99887766554433221100"
#define STR_ENCCHECK_KEY "Key              : "
#define STR_ENCCHECK_P "-p <PlainText>: Designate a plain text in a hex form. The length is free."
#define STR_ENCCHECK_PARAM_INVALID "Some of the parameters are invalid."
#define STR_ENCCHECK_P_EX "     e.g. -p 0123456789abcdef"
#define STR_ENCCHECK_PLAIN_TEXT "Plain Text       : "
#define STR_ENCCHECK_TITLE "***** Encryption Process Checker Ver.1.0.0.3 *****"
#define STR_ENCCHECK_USAGE "Usage: enccheck -i <InitVector> -k <Key> -p <PlainText>"
#define STR_INFO_CSL_FILE_CANNOT_CREATE "The CSL file CANNOT be created."
#define STR_INFO_ENCODING_01 "Now Encoding \""
#define STR_INFO_ENCODING_02 "\"\r\n"
#define STR_INFO_DECODING_01 "Now Decoding \""
#define STR_INFO_DECODING_02 "\"\r\n"
#define STR_INFO_DELETING_01 "Now Deleting \""
#define STR_INFO_DELETING_02 "\"\r\n"
#define STR_INFO_FAIL_ENCODING_01 "Fail to Encode \""
#define STR_INFO_FAIL_ENCODING_02 "\" ("
#define STR_INFO_FAIL_ENCODING_03 ")\r\n"
#define STR_INFO_FILE_CANNOT_OPEN "The file CANNOT be open."
#define STR_INFO_FILE_CANNOT_READ "The file CANNOT be read."
#define STR_INFO_FILE_CANNOT_SAVE "The file CANNOT be saved."
#define STR_INFO_FILE_CANNOT_WRITE "The file CANNOT be written."
#define STR_INFO_FINISH_PROCESS_01 "Finished Processing \""
#define STR_INFO_FINISH_PROCESS_02 "\"\r\n"
#define STR_INSTALLER_DESKTOP_ICON "Would you like to create the icon on the desktop?"
#define STR_INSTALLER_START_MENU_ICON "Would you like to register the application in your start menu?"
#define STR_INSTALLER_CSWAT_DESCRIPTION "Auto \"Re\"-Encoding Software C-SWAT"
#define STR_INSTALLER_DFLM_DESCRIPTION "Decoding File List Maker"
#define STR_INSTALLER_SOFTNAME "C-SWAT Installer"
#define STR_INSTALLER_UNINSTALLER_DESCRIPTION "C-SWAT Uninstaller"
#define STR_MENU_ADD "Add (&A)"
#define STR_MENU_DELETE "Delete (&A)"
#define STR_MENU_OPEN "Open (&A)"
#define STR_MSG_CSL_PATH_NOT_SET "The path of CSL file is NOT set."
#define STR_MSG_FILE_NOT_DROPPED "The files to encode is NOT chosen."
#define STR_MSG_FILE_CANNOT_OPEN "The file CANNOT be open."
#define STR_MSG_INSTALL "Would you like to install \"C-SWAT\" on your computer?"
#define STR_MSG_INSTALL_CANCEL "The installation of \"C-SWAT\" is cancelled."
#define STR_MSG_INSTALL_FINISHED "The installation of \"C-SWAT\" is completed."
#define STR_MSG_NO_EXTENTION "The file CANNOT be open because of lack of its extension."
#define STR_MSG_NOT_CSE_FILE "This file is NOT an CSL file."
#define STR_MSG_NOT_SUPPORTED "This version of the file is NOT supported."
#define STR_MSG_PASSWORD_ERROR "The password is wrong."
#define STR_MSG_PASSWORD_NULL "The password is NOT set."
#define STR_MSG_REENC_TOO_EARLY "The file is about to be re-encoded within 10 seconds from its open. The end of using it may not be detected correctly.\n\
The re-encoding will start when you close this dialog box.\n\n\
* This message may be shown when you use a software which avoids double running.\n\
  When you use such a software, please close it before decoding the file."
#define STR_MSG_REGISTRY_CANNOT_DELETE "This program has failed in deleting some or all parts of the registry information.\r\n\r\n* Still, the uninstall will be continued."
#define STR_MSG_UNINSTALL "Are you sure to uninstall \"C-SWAT\"?"
#define STR_MSG_UNINSTALL_COMPLETE "The uninstall of \"C-SWAT\" is finished. Please delete the remaining files."
#define STR_MSG_WAITING "None of the files in the list are opened.\r\n\r\n* Re-encoding will start when this message box is closed."
#define STR_TT_ADD_FILE "Add an file to the list."
#define STR_TT_DELETE_FILE "Delete the selected file from the list."
#define STR_TT_DOWN_FILE "Move down the selected rows in the list by one row."
#define STR_TT_HINT "Please input a reminder of the password, if necessary."
#define STR_TT_OVERWRITE "Please check this box when you want to overwrite the file if a file of the same name has already existed."
#define STR_TT_PASSWORD "Please input the password to decode."
#define STR_TT_PASSWORD_FOR_OFN "Input the password if you'd like to show the original file name."
#define STR_TT_SHOW_OFN "The original file name will be shown when you fill the password box and click here."
#define STR_TT_UP_FILE "Move up the selected rows in the list by one row."
#define STR_TT_DEC_HINT "Hint of the Password"
#define STR_TT_DEC_NOT_WATCH "Please check this box only when re-encoding is not necessary."
#define STR_TT_DEC_AUTO_DEL "Please check this box when you want the original encoded files to be automatically deleted after decoding."
#define STR_TT_DFLM_CSL_FILE_NAME "Please input the name or path of the CSL file."
#define STR_TT_DFLM_FILE_LIST "Please drag and drop files you want to add to the decoding file list."
#define STR_TT_DFLM_REFERENCE "You can chose the path in which CSL file will be saved."
#define STR_TT_ENC_ABSOLUTE_PATH "You can move the decoding file list independently if you check this box."
#define STR_TT_ENC_AUTO_DEL "Please check this box when you want the original files to be automatically deleted after encoding"
#define STR_TT_ENC_CHANGE_NAME "Please check this box when you want the encoded files to have random names."
#define STR_TT_ENC_CONFIRMATION "Please input the same password as above to confirm."
#define STR_TT_ENC_CREATE_LIST "Please check this box when you want to manage all files en bloc."
#define STR_TT_ENC_CSL_FILE_NAME "Please input the name of the CSL file. It will be created in the directory where the encoded files exist."
#define STR_TT_ENC_FILE_LIST "Please drag and drop files you want to encode."
#define STR_UNINSTALLER_SOFTNAME "C-SWAT Uninstaller"
#define STR_WND_ADD "Add"
#define STR_WND_CANCEL "Cancel"
#define STR_WND_COLON ":"
#define STR_WND_DELETE "Delete"
#define STR_WND_DOWN_FILE "Move Down"
#define STR_WND_FILE_FILTER_ALL "All Files (*.*)\0*.*\0\0"
#define STR_WND_FILE_NAME "File Name"
#define STR_WND_FILE_PATH "File Path"
#define STR_WND_HELP "Help"
#define STR_WND_HINT "Reminder:"
#define STR_WND_OK "OK"
#define STR_WND_ORIGINAL_FILE_NAME "Original Name"
#define STR_WND_OVERWRITE "Overwrite Files of the Same Name"
#define STR_WND_PASSWORD "Password:"
#define STR_WND_SHOW_OFN "Show Original Name"
#define STR_WND_UP_FILE "Move Up"
#define STR_WND_VERSION_INFO "Version Info"
#define STR_WND_CW_PROCESS_STATUS "Status:"
#define STR_WND_DEC_AUTO_DELETE "Delete Original Encoded Files After Decoding"
#define STR_WND_DEC_DECODING_FILE_NAME "Name of File to Decode :"
#define STR_WND_DEC_HINT "Reminder"
#define STR_WND_DEC_NOT_WATCH "Do Not Open And Re-encode Decoded Files (Not Recommended)"
#define STR_WND_DEC_PASSWORD "Password"
#define STR_WND_DFLM_CSL_FILE_FILTER "C-SWAT File List (*.csl)\0*.csl\0\0"
#define STR_WND_DFLM_CSL_FILE_PATH "CSL File Path:"
#define STR_WND_DFLM_FILE_TO_INCLUDE "Files to Include in Decoding File List(DFL) (Please Check Files to Open After Decode)"
#define STR_WND_DFLM_HINT "Reminder of Password:"
#define STR_WND_DFLM_OPEN_FILE_TO_INCLUDE "Open Files to Add to Decoding File List"
#define STR_WND_DFLM_REFERENCE "Save as ..."
#define STR_WND_DFLM_SAVE_CSL_FILE_PATH "Save CSL File"
#define STR_WND_ENC_ABSOLUTE_PATH "Use Absolute Path"
#define STR_WND_ENC_AUTO_DELETE "Delete Files After Encoding"
#define STR_WND_ENC_CHANGE_NAME "Change Names Of Encoded File at Random"
#define STR_WND_ENC_CONFIRMATION "Confirmation:"
#define STR_WND_ENC_CREATE_LIST "Create Decoding File List(DFL) (Check Files in List Above To Open After Decode)"
#define STR_WND_ENC_CSL_FILE_NAME "DFL Name:"
#define STR_WND_ENC_ENCODING_FILE_LIST "Files to Encode (You can drag && drop)"
#define STR_WND_ENC_OPEN_ENCODEING_FILE "Open Files to Encode"
#define STR_WND_ORIGINAL_FILE_NAME "Original Name"
#define STR_WND_REENC_REENCODING "This program will encode the following files not re-encoded because of some reason.\r\nPlease use the same password."
#define STR_WND_VI_HOMEPAGE "Visit Author's Website"
#define STR_WND_VI_ITEM "Item"
#define STR_WND_VI_ITEM_NAME "Soft Name"
#define STR_WND_VI_ITEM_VERSION "Version"
#define STR_WND_VI_ITEM_DATE "Release Date"
#define STR_WND_VI_ITEM_AUTHOR "Author"
#define STR_WND_VI_MAIL "Send Mail to Author"
#define STR_WND_VI_VALUE "Value"

#endif
