/*********************************************************************************

 C-SWATACXg[ Ver.2.0.1.1


 Copyright (c) 2006-2013, Isao MORI (Orios)
 All rights reserved.

 Redistribution and use in source and binary forms, with or without modification,
 are permitted provided that the following conditions are met:
   * Redistributions of source code must retain the above copyright notice, this
     list of conditions and the following disclaimer.
   * Redistributions in binary form must reproduce the above copyright notice,
     this list of conditions and the following disclaimer in the documentation
     and/or other materials provided with the distribution.
 
 THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND
 ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
 WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
 DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT HOLDER OR CONTRIBUTORS BE LIABLE FOR
 ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
 (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
 LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON
 ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
 (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
 SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
*********************************************************************************/


//==================================================
// CN[h
//==================================================
#include "c-swat.h"
#include "PathManagement.h"


//==================================================
// WXg폜֐
//==================================================
bool DelRegTree(HKEY hKey, const char* pcSubKey)
{
	HKEY hSubKey;
	DWORD dwIndex = 0;
	DWORD dw = 256;
	bool b = true;
	char apcKeyName[256];
	
	if (RegOpenKeyEx(hKey, pcSubKey, 0, KEY_ENUMERATE_SUB_KEYS, &hSubKey) != ERROR_SUCCESS) {
		return false;
	}

	while (RegEnumKeyEx(hSubKey, dwIndex, (char*)&apcKeyName, &dw, NULL, NULL, NULL, NULL) != ERROR_NO_MORE_ITEMS) {
		b = b && DelRegTree(hSubKey, (char*)&apcKeyName);
	}
	RegCloseKey(hSubKey);

	if (RegDeleteKey(hKey, pcSubKey) == ERROR_SUCCESS) {
		return b && true;
	}
	else {
		return false;
	}
}


//==================================================
// t@C폜
//==================================================
bool DelFiles(const char* pcFilePath, bool bSelfRemove)
{
	// ϐ̐錾
	DWORD dwAttr;
	char* pcSearchFilePath;
	WIN32_FIND_DATA wfd;
	char* pcFoundFilePath;
	HANDLE hFileSearch;

	// t@C̎擾
	dwAttr = GetFileAttributes(pcFilePath);

	if (dwAttr == 0xFFFFFFFF) {
	// 擾Ɏsꍇ
		return false;

	}
	else if (((dwAttr & FILE_ATTRIBUTE_DIRECTORY) == FILE_ATTRIBUTE_DIRECTORY)) {
	// ̃pXfBNg̏ꍇ
	
		// p̐
		pcSearchFilePath = (char*)malloc(lstrlen((LPCSTR)pcFilePath) + 3);
		lstrcpy((LPSTR)pcSearchFilePath, pcFilePath);
		if (pcSearchFilePath[lstrlen((LPCSTR)pcSearchFilePath) - 1] != 0x5C) {
			lstrcat((LPSTR)pcSearchFilePath, "\\*");
		}
		else {
			lstrcat((LPSTR)pcSearchFilePath, "*");
		}

		// ŏ̃t@Č
		FillMemory(&wfd, sizeof(WIN32_FIND_DATA), 0);
		hFileSearch = FindFirstFile(pcSearchFilePath, &wfd);
		if (hFileSearch != INVALID_HANDLE_VALUE) {
			if (wfd.cFileName[0] != 0x2E) {
				pcFoundFilePath = (char*)malloc(lstrlen((LPCSTR)pcSearchFilePath) + lstrlen((LPCSTR)wfd.cFileName) + 1);
				lstrcpy((LPSTR)pcFoundFilePath, pcSearchFilePath);
				pcFoundFilePath[lstrlen((LPCSTR)pcFoundFilePath) - 1] = NULL;
				lstrcat((LPSTR)pcFoundFilePath, wfd.cFileName);
				DelFiles(pcFoundFilePath, true);
				free(pcFoundFilePath);
			}

			// ̃t@Č
			FillMemory(&wfd, sizeof(WIN32_FIND_DATA), 0);
			while (FindNextFile(hFileSearch, &wfd) != 0) {
				if (wfd.cFileName[0] != 0x2E) {
					pcFoundFilePath = (char*)malloc(lstrlen((LPCSTR)pcSearchFilePath) + lstrlen((LPCSTR)wfd.cFileName) + 1);
					lstrcpy((LPSTR)pcFoundFilePath, pcSearchFilePath);
					pcFoundFilePath[lstrlen((LPCSTR)pcFoundFilePath) - 1] = NULL;
					lstrcat((LPSTR)pcFoundFilePath, wfd.cFileName);
					DelFiles(pcFoundFilePath, true);
					free(pcFoundFilePath);
				}
				FillMemory(&wfd, sizeof(WIN32_FIND_DATA), 0);
			}
			FindClose(hFileSearch);
		}

		// 
		free(pcSearchFilePath);

		// fBNg̍폜
		if (bSelfRemove && (RemoveDirectory(pcFilePath) == 0)) {
			return false;
		}

		
	}
	else {
	// ̃pXt@C̏ꍇ
		if (DeleteFile(pcFilePath) == 0) {
			return false;
		}
	}

	return true;
}


//==================================================
// C֐
//==================================================
int WINAPI WinMain(HINSTANCE hInstance, HINSTANCE hPrevInstance, LPSTR pcCmdLine, int nCmdShow)
{
	if (lstrcmp(pcCmdLine, "wait") == 0) {
		Sleep(500);

	}
	else {

		bool b = true;
		PathManagement* poPathManagement;
		char acBatPath[MAX_PATH + 1];
		HANDLE hFile;
		HKEY hKey;
		DWORD dw;

		// EmF
		poPathManagement = new PathManagement();
		if (MessageBox(NULL, STR_MSG_UNINSTALL, STR_UNINSTALLER_SOFTNAME, MB_YESNO | MB_ICONEXCLAMATION | MB_DEFBUTTON2) != IDYES) {
			return 0;
		}

		// WXg̍폜
		b = b && DelRegTree(HKEY_CLASSES_ROOT, ".cse");
		b = b && DelRegTree(HKEY_CLASSES_ROOT, ".csl");
		b = b && DelRegTree(HKEY_CLASSES_ROOT, "C-SWAT.EncodedFile");
		b = b && DelRegTree(HKEY_CLASSES_ROOT, "C-SWAT.FileList");
		if (b = b && (RegCreateKeyEx(HKEY_LOCAL_MACHINE, "SOFTWARE\\Microsoft\\Windows\\CurrentVersion\\Run", 0, NULL, 0, KEY_ALL_ACCESS, NULL, &hKey, NULL) == ERROR_SUCCESS)) {
			b = b && (RegDeleteValue(hKey, "c-swat") == ERROR_SUCCESS);
			RegCloseKey(hKey);
		}
		if (!b) {
			MessageBox(NULL, STR_MSG_REGISTRY_CANNOT_DELETE, STR_UNINSTALLER_SOFTNAME, MB_OK | MB_ICONEXCLAMATION);
		}
		SHChangeNotify(SHCNE_ASSOCCHANGED, SHCNF_IDLIST, NULL, NULL);

		// eACR̍폜
		char desktopIconPath_c[MAX_PATH + 10];
		SHGetFolderPath(NULL, CSIDL_COMMON_DESKTOPDIRECTORY, NULL, SHGFP_TYPE_CURRENT, desktopIconPath_c);
		lstrcat(desktopIconPath_c, "\\C-SWAT.lnk");
		DeleteFile(desktopIconPath_c);
		SHChangeNotify(SHCNE_DELETE, SHCNF_IDLIST | SHCNF_PATH, desktopIconPath_c, NULL);

		char startMenuPath_c[MAX_PATH];
		SHGetFolderPath(NULL, CSIDL_COMMON_STARTMENU, NULL, SHGFP_TYPE_CURRENT, startMenuPath_c);

		char startMenuCSwatPath_c[MAX_PATH + 7];
		lstrcpy(startMenuCSwatPath_c, startMenuPath_c);
		lstrcat(startMenuCSwatPath_c, "\\C-SWAT");
		DelFiles(startMenuCSwatPath_c, true);

		// mFbZ[W̕\
		MessageBox(NULL, STR_MSG_UNINSTALL_COMPLETE, STR_UNINSTALLER_SOFTNAME, MB_OK);
	}

	return 0;
}
